#include <iostream>
#include <cmath>
#include <unordered_map>

#ifndef LOCAL_D
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,popcnt,abm,mmx,tune=native")
#pragma comment(linker, "/STACK:256000000")
#endif


using namespace std;

typedef long long ll;

ll is_full_square(ll a) {
    if (a == 0)
        return 0;
    if (a == 1)
        return 1;
    unordered_map<ll, ll> divs;
    for (int i = 2; i * i <= a; i++) {
        while (a % i == 0) {
            a /= i;
            divs[i]++;
        }
    }
    if (a != 1)
        divs[a]++;
    ll square_root = 1;
    for (auto [div,am]: divs) {
        if (am % 2)
            return -1;
        square_root *= pow(div, am / 2);
    }
    return square_root;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll k;
    cin >> k;
    for (int i = 0; i < 1000000; i++) {
        if (k + i * i < 0)
            continue;
        ll s = is_full_square(k + i * i);
        if (s != -1) {
            cout << s;
            return 0;
        }
    }
    cout << "none";
    return 0;
}