#include <iostream>
#include <vector>
#include <algorithm>

#ifndef LOCAL_D
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,popcnt,abm,mmx,tune=native")
#pragma comment(linker, "/STACK:256000000")
#endif


using namespace std;

typedef long long ll;

vector<int> roots;
vector<int> h;

int find(int a) {
    if (a == roots[a])
        return a;
    return roots[a] = find(roots[a]);
}

void unite(int a, int b) {
    int r1 = find(a);
    int r2 = find(b);

    if (r1 == r2)
        return;

    int h1 = h[r1];
    int h2 = h[r2];
    if (h1 < h2) {
        swap(r1, r2);
        swap(h1, h2);
    }

    roots[r2] = r1;
    h[r1] += h2;
}

bool joined(int a, int b) {
    return find(a) == find(b);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    roots.resize(n);
    h.resize(n);
    for (int i = 0; i < n; i++) {
        roots[i] = i;
        h[i] = 1;
    }
    vector<vector<int>> in_graph(n);
    vector<vector<int>> out_graph(n);
    int w;
    for (int i = 0; i < n; i++) {
        cin >> w;
        if (w == -1)
            continue;
        in_graph[w - 1].push_back(i);
        out_graph[i].push_back(w - 1);
    }
    vector<int> keks(n);
    for (int i = 0; i < n; i++)
        keks[i] = i;
    stable_sort(keks.begin(), keks.end(), [&](int a, int b) -> bool{
        return in_graph[a].size() < in_graph[b].size();
    });
    int ans = 1;
    int main_root = keks[0];
    for (int i = 1; i < n; i++) {
        int wanna_add= keks[i];
        bool can_add = true;
        for (auto e : out_graph[wanna_add]) {
            can_add &= ~joined(main_root, e);
        }
        for (auto e : in_graph[wanna_add]) {
            can_add &= ~joined(main_root, e);
        }
        if (can_add) {
            unite(main_root, wanna_add);
            ans++;
        }
    }
    cout << ans;
    return 0;
}