#include <bits/stdc++.h>

using namespace std;

#define ALL(x) (x).begin(), (x).end()
#define BALL(x) (x).rbegin(), (x).rend()

//#define DEBUG
#ifdef DEBUG
ifstream _in("debug.in");
#define cin _in
#endif

#define int long long
#define endl '\n'
#define INF 1e9+7

namespace geom {
	struct vec {
		double x, y;

		vec() {
			this->x = 1;
			this->y = 0;
		}

		vec(double x, double y) {
			this->x = x;
			this->y = y;
		}

		vec normalize() {
			return vec(x / hypot(x, y), y / hypot(x, y));
		}

		double getAngle() {
			return atan2(x, y);
		}

		double getLength() {
			return hypot(x, y);
		}

	};

	struct line {
		double a, b, c;
		
		line(double a, double b, double c) {
			this->a = a;
			this->b = b;
			this->c = c;
		}

		line(vec v1, vec v2) {
			this->a = v1.y - v2.y;
			this->b = v2.x - v1.x;
			this->c = v1.x * v2.y - v2.x * v1.y;
		}
	};

	bool is_paral(line l1, line l2) {
		return (l1.a * l2.b == l2.a * l1.b);
	}

	vec operator+(vec a, vec b) {
		return vec(a.x + b.x, a.y + b.y);		
	}

	vec operator-(vec a, vec b) {
		return vec(a.x - b.x, a.y - b.y);		
	}

	vec operator*(vec a, double b) {
		return vec(a.x * b, a.y * b);
	}

	vec operator/(vec a, double b) {
		return vec(a.x / b, a.y / b);
	}

	vec rotate90(vec a) {
		return vec(-a.y, a.x);
	}

	vec rotate(vec a, double angle) {
		return vec(a.x * cos(angle) - a.y * sin(angle),
				   a.x * sin(angle) + a.y * cos(angle));
	}

	ostream& operator<<(ostream& out, vec v) {
		out << '(' << v.x << ' ' << v.y << ')';
		return out;
	}}
using namespace geom;

signed main() {
	ios_base::sync_with_stdio(false);

	int k;
	cin >> k;
	if (k == 0) {
		cout << 0 << endl;
		return 0;
	}
	vector<pair<int, int>> partials;
	for (int i = 1; i * i <= abs(k); ++i) {
		if (k % i == 0) {
			partials.push_back({min(i, k / i), max(i, k / i)});
			partials.push_back({min(-i, -k / i), max(-i, -k / i)});
		}
	}
	int min_ans = INF;
	for (auto e : partials) {
		if ((e.first + e.second) % 2 == 0) {
			min_ans = min(min_ans, abs((e.first + e.second) / 2));
		}
	}
	if (min_ans == INF) 
		cout << "none" << endl;
	else
		cout << min_ans << endl;
}