#include <bits/stdc++.h>

using namespace std;

const int mod = 1e9 + 7;

void update_matrix(int i, int j, vector<vector<pair<long long, long long>>> &matrix, vector<vector<pair<long long, long long>>> &pref){
    int n = (int)matrix.size() - 1;
    if (i - j >= 0){
        matrix[i][j].first = ((pref[i - j][j - 1].second - pref[i - j][0].second) % mod + mod) % mod;
        matrix[i][j].second = ((pref[i - j][n].first - pref[i - j][j].first) % mod + mod) % mod;
    }
}

void update_pref(int i, vector<vector<pair<long long, long long>>> &matrix, vector<vector<pair<long long, long long>>> &pref){
    int n = (int)matrix.size() - 1;
    for (int j = 1; j <= n; j++){
        pref[i][j].first = (pref[i][j - 1].first + matrix[i][j].first) % mod;
        pref[i][j].second = (pref[i][j - 1].second + matrix[i][j].second) % mod;
    }
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    if (n == k){
        cout << 1;
        return 0;
    }

    vector<vector<pair<long long, long long>>> matrix(n + 1, vector<pair<long long, long long>> (n + 1));
    matrix[k][k] = {1, 1};

    vector<vector<pair<long long, long long>>> pref(n + 1, vector<pair<long long, long long>> (n + 1));
    for (int i = k; i <= n; i++){
        pref[k][i].first = 1;
        pref[k][i].second = 1;
    }

    for (int i = k + 1; i <= n; i++){
        for (int j = 1; j < n; j++){
            update_matrix(i, j, matrix, pref);
        }
        update_pref(i, matrix, pref);
    }

    long long ans = 0;
    for (int i = 0; i < n; i++){
        ans += matrix[n][i].first + matrix[n][i].second;
        ans %= mod;
    }
    cout << ans;
    /*cout << "matrix\n";
    for (int i = 0; i <= n; i++){
        for (int j = 0; j <= n; j++)
            cout << matrix[i][j].first << " " << matrix[i][j].second << "  ";
        cout << endl;
    }
    cout << "\npref\n";
    for (int i = 0; i <= n; i++){
        for (int j = 0; j <= n; j++)
            cout << pref[i][j].first << " " << pref[i][j].second << "  ";
        cout << endl;
    }*/
    return 0;
}