#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <cstring>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <fstream>

using namespace std;
typedef long long ll;

#ifdef DEBUG
	const int MAXN = 1;
	const int MAXLOG = 4;
	const int MAXSQRT = 7;
#else 
	const int MAXN = 5001;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
#endif
#define int ll
int n, k;
int dp[MAXN][MAXN][2];
int f[2 * MAXN][MAXN][2];
int mod = (1e9 + 7);

void add(int a, int b, int c, int d) {
	for (int i = b + 1; i < MAXN; i += i & -i) {
		f[a][i][c] += d;
		f[a][i][c] %= mod;
	}
}

int get(int a, int b, int c) {
	int res = 0;
	for (int i = b + 1; i > 0; i -= i & -i) {
		res += f[a][i][c];
		res %= mod;
	}
	return res;
}

int get(int a, int c, int l, int r) {
	return ((get(a, r, c) - get(a, l - 1, c)) % mod + mod) % mod;
}

void init() {
	memset(dp, 0, sizeof(dp));
}

void solve() {
	init();
	if (n == k) {
		cout << 1 << '\n';
		return;
	}
	for (int i = 1; i < MAXN; i++) {
		dp[0][i][0] = dp[0][i][1] = 1;
		add(i, i, 0, 1);
		add(i, i, 1, 1);
	}
	for (int sum = 1; sum <= n; sum++) {
		for (int last = 1; last <= n; last++) {
			dp[sum][last][1] += get(sum, 0, 1, min(sum + 1, last) - 1);
			dp[sum][last][1] %= mod;
			// for (int mid = 1; mid < min(sum + 1, last); mid++) {
			// 	dp[sum][last][1] += dp[sum - mid][mid][0];
			// 	dp[sum][last][1] %= mod;
			// }
			dp[sum][last][0] += get(sum, 1, last + 1, sum);
			dp[sum][last][0] %= mod;
			// for (int mid = last + 1; mid <= sum; mid++) {
			// 	dp[sum][last][0] += dp[sum - mid][mid][1];
			// 	dp[sum][last][0] %= mod;
			// }
			add(sum + last, last, 0, dp[sum][last][0]);
			add(sum + last, last, 1, dp[sum][last][1]);
		}
	}
	cout << (dp[n - k][k][0] + dp[n - k][k][1]) % mod << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("B.in", "r", stdin);
		freopen("B.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> k) {
		solve();
	}
}