#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)
//char ALLOC_MEM[480 * 1024 * 1024];
int ALLOC_POS = 0;

#include <cstddef>
#include <cstring>
/*inline void* operator new(size_t n) {
    void* res = (void*) (ALLOC_MEM + n);
    ALLOC_POS += n;
    memset(res, 0, n);
    return res;
}



inline void operator delete(void*) noexcept {

}*/

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

using ll = long long;

int main() {
    int num_tests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        scanf("%d", &num_tests);
    }
    for (int i = 0; i < num_tests; ++i) {
        $ printf("---TEST %d---\n", i);
        entry(i);
    }
}

#define all(x) x.begin(), x.end()
vector<vector<int>> req_ids;

template<typename T>
struct MinStack {
    vector<pair<T, T>> v;

    void push(T x) {
        T m = x;
        if (!v.empty()) {
            m = min(m, v.back().second);
        }
        v.emplace_back(x, m);
    }

    T pop() {
        T ret = v.back().first;
        v.pop_back();
        return ret;
    }

    T get() {
        return v.back().second;
    }
};

template<typename T>
struct MinQueue {
    MinStack<T> head, tail;

    void rebuild() {
        while (!head.v.empty()) {
            tail.push(head.pop());
        }
    }

    void push(T x) {
        head.push(x);
    }

    void pop() {
        if (tail.v.empty()) {
            rebuild();
        }
        tail.pop();
    }

    T get() {
        if (tail.v.empty()) {
            return head.get();
        }
        T res = tail.get();
        if (!head.v.empty()) {
            res = min(res, head.get());
        }
        return res;
    }
};

const ll TAMB = 100000;

ll solve_small(ll a, ll b, ll c) { // large blocks, few steps
    ll ans = 0;
    while (a != b) {
        ll bl_end = a;
        if (a % c == 0) {
            bl_end += c - 1;
        } else {
            bl_end -= a % c;
            bl_end += c - 1;
        }
        if (bl_end == a) {
            ++ans;
            a += 2;
            continue;
        }
        ll targ = min(b, bl_end);
        ll dist = targ - a;
        ll dans = (dist - 1) / 2 + 1;
        if (dist == 0) dans = 0;
        ans += dans;
        a = targ;
    }
    return ans;
}

ll solve_large(ll a, ll b, ll c) {
    ll ans = 0;
    ll bl_len = (c - 1) / 2 + 1;
    while (true) {
        ll r = a % c;
        if (r == c - 1) break;
        if (r == c - 2) {
            ++ans;
            ++a;
            break;
        }
        ++ans;
        a += 2;
    }
    ll t = (b - a) / c;
    a += t * c;
    ans += t * bl_len;
    while (a != b) {
        int d = min<ll>(2, b - a);
        a += d;
        ++ans;
    }
    return ans;
}

vector<vector<int>> g;

struct INFO {
    bool HasCycle = false;
    vector<int> CycleItems = {};
    int Root;
};

vector<INFO> components;

vector<int> color;

vector<int> explore_dfs_stack;

void explore_dfs(int v, int u) {
    color[v] = 1;
    explore_dfs_stack.push_back(v);
    for (int w : g[v]) {
        if (u == w) continue;
        if (color[w] == 1) {
            INFO &r = *components.rbegin();
            if (r.HasCycle) {
                continue;
            }
            r.Root = v;
            r.HasCycle = true;
            int k = explore_dfs_stack.size() - 1;
            while (explore_dfs_stack[k] != w) {
                r.CycleItems.push_back(explore_dfs_stack[k]);
                --k;
            }
            r.CycleItems.push_back(w);
        } else {
            (explore_dfs(w, v));
        }
    }
    explore_dfs_stack.pop_back();
}

void explore(int v) {
    $ assert(explore_dfs_stack.empty());
    components.rbegin()->Root = v;
    explore_dfs(v, -1);
}

pair<int, int> dp_dfs(int v, int u1, int u2) {
    auto t = make_pair(1, 0);
    for (int w : g[v]) {
        if (w == u1 || w == u2) continue;
        auto s = dp_dfs(w, v, -1);
        t.first += s.second;
        t.second += max(s.first, s.second);
    }

    return t;
}

struct TREE_INFO {
    int Take;
    int NotTake;
};

TREE_INFO dp(int v, int u1, int u2) {
    auto t = dp_dfs(v, u1, u2);
    TREE_INFO ti;
    ti.NotTake = t.second;
    ti.Take = max(t.first, t.second);
    return ti;
}

void entry(int test_id) {
    (void) test_id;
    g.clear();
    components.clear();
    color.clear();
    int n;
    scanf("%d", &n);
    g.resize(n);
    color.resize(n);
    for (int u = 0; u < n; ++u) {
        int v;
        scanf("%d", &v);
        if (v == -1) continue;
        --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int v = 0; v < n; ++v) {
        if (color[v] == 0) {
            components.emplace_back();
            explore(v);
        }
    }
    int ans = 0;
    for (const auto &c : components) {
        int res = 0;
        if (!c.HasCycle) {
            res = dp(c.Root, -1, -1).Take;
            ans += res;
            continue;
        }
        int k = c.CycleItems.size();
        vector<int> sc(k);
        for (int i = 0; i < k; ++i) {
            int pi = (i - 1 + k) % k;
            int ni = (i + 1) % k;
            auto t = dp(c.CycleItems[i], c.CycleItems[pi], c.CycleItems[ni]);
            sc[i] = t.Take - t.NotTake;
            res += t.NotTake;
        }
        int res_base = res;
        if (k % 2 == 0) {
            int res1 = 0;
            int res2 = 0;
            for (int i = 0; i < k; ++i) {
                if (i % 2 == 0) {
                    res1 += sc[i];
                } else {
                    res2 += sc[i];
                }
            }
            res = max(res1, res2);
            ans += res + res_base;
            continue;
        }
        sc.resize(3 * k);
        for (int i = k; i < 3 * k; ++i) {
            sc[i] = sc[i - k];
        }
        int t1, t2;
        t1 = t2 = 0;
        for (int i = 0; i < k - 1; ++i) {
            if (i % 2 == 0) {
                t1 += sc[i];
            } else {
                t2 += sc[i];
            }
        }

        res = max(t1, t2);
        for (int i = 0; i < k; ++i) {
            if (i % 2 == 0) {
                t1 -= sc[i];
                t2 += sc[i + k - 1];
            } else {
                t2 -= sc[i];
                t1 += sc[i + k - 1];
            }
            int nt = max(t1, t2);
            res = max(res, nt);
        }
        ans += res + res_base;


    }
    printf("%d\n", ans);
}