#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)
//char ALLOC_MEM[480 * 1024 * 1024];
int ALLOC_POS = 0;

#include <cstddef>
#include <cstring>
/*inline void* operator new(size_t n) {
    void* res = (void*) (ALLOC_MEM + n);
    ALLOC_POS += n;
    memset(res, 0, n);
    return res;
}



inline void operator delete(void*) noexcept {

}*/

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

using ll = long long;

int main() {
    int num_tests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        scanf("%d", &num_tests);
    }
    for (int i = 0; i < num_tests; ++i) {
        $ printf("---TEST %d---\n", i);
        entry(i);
    }
}

#define all(x) x.begin(), x.end()

vector<vector<int>> g;

struct INFO {
    bool HasCycle = false;
    vector<int> CycleItems = {};
    int Root;
};

vector<INFO> components;

vector<int> color;

vector<int> explore_dfs_stack;

void explore_dfs(int v, int u) {
    color[v] = 1;
    explore_dfs_stack.push_back(v);
    for (int w : g[v]) {
        if (u == w) continue;
        if (color[w] == 1) {
            INFO &r = *components.rbegin();
            if (r.HasCycle) {
                continue;
            }
            r.Root = v;
            r.HasCycle = true;
            int k = explore_dfs_stack.size() - 1;
            while (explore_dfs_stack[k] != w) {
                r.CycleItems.push_back(explore_dfs_stack[k]);
                --k;
            }
            r.CycleItems.push_back(w);
        } else {
            (explore_dfs(w, v));
        }
    }
    explore_dfs_stack.pop_back();
}

void explore(int v) {
    $ assert(explore_dfs_stack.empty());
    components.rbegin()->Root = v;
    explore_dfs(v, -1);
}

pair<int, int> dp_dfs(int v, int u1, int u2) {
    auto t = make_pair(1, 0);
    for (int w : g[v]) {
        if (w == u1 || w == u2) continue;
        auto s = dp_dfs(w, v, -1);
        t.first += s.second;
        t.second += max(s.first, s.second);
    }

    return t;
}

struct TREE_INFO {
    int Take;
    int NotTake;
};

TREE_INFO dp(int v, int u1, int u2) {
    auto t = dp_dfs(v, u1, u2);
    TREE_INFO ti;
    ti.NotTake = t.second;
    ti.Take = max(t.first, t.second);
    return ti;
}

int select(const vector<int>& a) {
    int n = a.size();
    vector<int> dp[2];
    dp[0].resize(n);
    dp[1].resize(n);
    dp[0][0] = 0;
    dp[1][0] = a[0];
    for (int i = 1; i <n; ++i) {
        dp[0][i] = max(dp[0][i-1], dp[1][i-1]);
        dp[1][i] = a[i] + dp[0][i-1];
    }
    return max(dp[0][n-1], dp[1][n-1]);
}

void entry(int test_id) {
    (void) test_id;
    g.clear();
    components.clear();
    color.clear();
    int n;
    scanf("%d", &n);
    g.resize(n);
    color.resize(n);
    for (int u = 0; u < n; ++u) {
        int v;
        scanf("%d", &v);
        if (v == -1) continue;
        --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int v = 0; v < n; ++v) {
        sort(all(g[v]));
        g[v].resize(unique(all(g[v])) - g[v].begin());
    }
    for (int v = 0; v < n; ++v) {
        if (color[v] == 0) {
            components.emplace_back();
            explore(v);
        }
    }
    int ans = 0;
    for (const auto &c : components) {
        int res_base = 0;
        if (!c.HasCycle) {
            res_base = dp(c.Root, -1, -1).Take;
            ans += res_base;
            continue;
        }
        int k = c.CycleItems.size();
        vector<int> sc(k);
        for (int i = 0; i < k; ++i) {
            int pi = (i - 1 + k) % k;
            int ni = (i + 1) % k;
            auto t = dp(c.CycleItems[i], c.CycleItems[pi], c.CycleItems[ni]);
            sc[i] = t.Take - t.NotTake;
            res_base += t.NotTake;
        }
        int res = 0;
        for (int t :{0, k-1}) {
            auto nsc = sc;
            nsc.erase(nsc.begin()+t);
            int val = select(nsc);
            res = max(res, val);
        }

        ans += res + res_base;

       // ans += res + res_base;
    }
    printf("%d\n", ans);
}