#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>

using namespace std;

const int MAXN = 300 * 1000 + 5;

int n, tmp, dp[MAXN][2], root[MAXN], res, cnt;
char col[MAXN];
vector<int> g[MAXN], gr[MAXN];
vector<int> cr, path;
vector<vector<int> > to;

void dfs(int v) {
	col[v] = 1;
	for (int u : g[v]) {
		if (col[u] == 0) {
			dfs(u);
		}
		else if (col[u] == 1) {
			cr.push_back(u);
		}
	}
	col[v] = 2;
}

void dfs2(int v, int c) {
	path.push_back(v);
	root[v] = c;
	for (int u : g[v]) {
		if (!root[u]) dfs2(u, c);
	}
}

void dfs3(int v) {
	int s1 = 1, s0 = 0;
	for (int u : gr[v]) {
		if (!root[u]) {
			dfs3(u);
			s1 += dp[u][0];
			s0 += max(dp[u][0], dp[u][1]);
		}
	}
	dp[v][1] = s1;
	dp[v][0] = s0;
}

signed main() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> tmp;
		if (tmp != -1) {
			gr[tmp - 1].push_back(i);
			g[i].push_back(tmp - 1);
		}
		else {
			path.clear();
			path.push_back(i);
			root[i] = ++cnt, to.push_back(path);
		}
	}
	for (int i = 0; i < n; ++i) {
		if (!col[i]) {
			dfs(i);
		}
	}
	memset(col, 0, sizeof(col));

	for (int i : cr) {
		path.clear();
		dfs2(i, ++cnt);
		to.push_back(path);
	}

	for (int i = 0; i < n; ++i) {
		if (root[i] != 0) {
			dfs3(i);
		}
	}

	for (vector<int> a : to) {
		if (a.size() > 1) {
			vector<pair<int, int> > q;
			q.resize(a.size(), { 0, 0 });

			q[0].second = dp[a[0]][1];
			for (int i = 1; i < a.size() - 1; ++i) {
				q[i].first = max(q[i - 1].second, q[i - 1].first) + dp[a[i]][0];
				q[i].second = q[i - 1].first + dp[a[i]][1];
			}
			int ans = max(q[a.size() - 2].second, q[a.size() - 2].first) + dp[a[a.size() - 1]][0];

			q.clear();
			q.resize(a.size(), { 0, 0 });

			q[0].first = dp[a[0]][0];
			for (int i = 1; i < a.size(); ++i) {
				q[i].first = max(q[i - 1].second, q[i - 1].first) + dp[a[i]][0];
				q[i].second = q[i - 1].first + dp[a[i]][1];
			}
			ans = max(ans, q.back().first);
			ans = max(ans, q.back().second);
			res += ans;
		}
		else {
			res += max(dp[a[0]][1], dp[a[0]][0]);
		}
	}
	cout << res << endl;
	return 0;
}

/*
5
2
3
1
1
-1
*/