#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cstring>

using namespace std;

const int MAXN = 2e5 + 5, MAXA = 1e9 + 7;

int n, k, cnt;
int a[MAXN][8];
int col[MAXN], mt[MAXN];
vector<pair<int, int> > ans;
bool f = 0, alldiff = 1;
multiset<int> all[8], all2[8];
map<int, int> mp[8];
vector<int> g[MAXN];
bool used[MAXN];

void gen() {
	if (f) return;

	if (cnt * 2 == n) {
		bool ok = 1;
		vector<pair<int, int> > seg;
		for (int i = 0; i < k; ++i) {
			int l = -MAXA, r = MAXA;

			for (auto p : ans) {
				int ln = min(a[p.first][i], a[p.second][i]), rn = max(a[p.first][i], a[p.second][i]);

				l = max(ln, l);
				r = min(rn, r);
			}

			if (l > r) ok = 0;
		}

		if (ok) f = 1;
		return;
	}

	++cnt;
	for (int i = 0; i < n; ++i) {
		if (!col[i]) {
			col[i] = cnt;
			for (int j = i + 1; j < n; ++j) {
				if (!col[j]) {
					col[j] = cnt;
					ans.push_back({ i, j });
					gen();
					if (f) return;
					ans.pop_back();
					col[j] = 0;
				}
			}
			col[i] = 0;
		}
	}
	--cnt;
}

bool dfs(int v) {
	used[v] = 1;
	for (int u : g[v]) {
		if (mt[u] == -1 || dfs(mt[u])) {
			mt[u] = v;
			return 1;
		}
	}
}

signed main() {
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
			mp[j][a[i][j]] = i;
			all[j].insert(a[i][j]);
			all2[j].insert(a[i][j]);
		}
	}

	for (int i = 0; i < k; ++i) {
		if (all[i].size() != n) {
			alldiff = 0;
		}
	}

	if (k == 1) {
		vector<pair<int, int> > arr;
		for (int i = 0; i < n; ++i) {
			arr.push_back({a[i][0], i});
		}
		sort(arr.begin(), arr.end());
		cout << "YES\n";
		for (int i = 0; i < n / 2; ++i) {
			cout << arr[i].second + 1 << " " << arr[n - i - 1].second + 1 << endl;
		}
	}
	else if (n <= 10) {
		gen();
		if (f) {
			cout << "YES" << endl;
			for (auto p : ans) {
				cout << p.first + 1 << " " << p.second + 1 << endl;
			}
		}
		else {
			cout << "NO" << endl;
		}
	}
	else {
		set<int> can[MAXN];
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				can[i].insert(j);
			}
		}
		set<int> l[8], r[8];
		for (int i = 0; i < k; ++i) {
			int lst, fst = -1;

			while (all2[i].size() * 2 != n) {
				lst = *all2[i].begin();
				all2[i].erase(all2[i].begin());
			}
			while (all2[i].size()) {
				if (fst == -1) {
					fst = *all2[i].begin();
				}
				all2[i].erase(all2[i].begin());
			}

			while (all[i].size() * 2 != n) {
				if (fst != lst || *all[i].begin() != fst) {
					l[i].insert(mp[i][(*all[i].begin())]);
					all[i].erase(all[i].begin());
				}
				else {
					all[i].erase(all[i].begin());
				}
			}
			while (all[i].size()) {
				if (fst != lst || *all[i].begin() != fst) {
					r[i].insert(mp[i][(*all[i].begin())]);
					all[i].erase(all[i].begin());
				}
				else {
					all[i].erase(all[i].begin());
				}
			}
		}

		for (int i = 0; i < k; ++i) {
			for (int a : l[i]) {
				for (int b : l[i]) {
					if (can[a].count(b)) can[a].erase(b);
				}
			}
		}

		for (int i = 0; i < k; ++i) {
			for (int a : r[i]) {
				for (int b : r[i]) {
					if (can[a].count(b)) can[a].erase(b);
				}
			}
		}

		for (int i = 0; i < n; ++i) {
			for (int j : can[i]) {
				g[i].push_back(j);
			}
		}

		for (int i = 0; i < n; ++i) {
			mt[i] = -1;
		}

		bool ch = 0;
		while (ch) {
			memset(used, 0, sizeof(used));
			for (int i = 0; i < n; ++i) {
				if (dfs(i)) ch = 1;
			}
		}

		bool allok = 1;
		set<pair<int, int> > resq;
		for (int i = 0; i < n; ++i) {
			if (mt[i] == -1) allok = 0;
			else {
				resq.insert({ min(i, mt[i]), max(i, mt[i]) });
			}
		}

		if (allok) {
			cout << "YES" << endl;
			for (auto p : resq) {
				cout << p.first + 1 << " " << p.second + 1 << endl;
			}
		}
		else {
			cout << "NO" << endl;
		}

		/*
		while (all[0].size()) {
			r.insert(*all[0].begin());
			all[0].erase(all[0].begin());
		}

		bool ok = 1;
		for (int i = 0; i < k - 1; ++i) {
			while (!l[i].empty()) {
				if (!l[i + 1].count(*l[i].begin())) ok = 0;
				l[i].erase(l[i].begin());
			}
		}

		if (ok) {
			cout << "YES" << endl;
			while (!r.empty()) {
				cout << (*l[k - 1].begin()) + 1 << " " << (*r.begin()) + 1 << endl;
				l[k - 1].erase(l[k - 1].begin());
				r.erase(r.begin());
			}
		}
		else {
			cout << "NO" << endl;
		}
		*/
	}
	return 0;
} 