#include<iostream>
#include<vector>
#include<algorithm>

#define int long long 

using namespace std;

int n;
const int MAXN = 300000;
int a[MAXN + 1];

void solve1()
{
    int ans = 1;
    for (int mask = 1; mask < (1LL << n); ++mask) {
        bool ok = 1;
        for (int i = 1; i <= n; ++i) {
            if (a[i] != -1 && (mask & (1LL << (i - 1))) && (mask & (1LL << (a[i] - 1)))) {
                ok = 0;
            }
        }
        if (ok) {
            int cur = 0;
            for (int i = 0; i < n; ++i) {
                if (mask & (1LL << i)) {
                    ++cur;
                }
            }
            ans = max(ans, cur);
        }
    }
    cout << ans << "\n";
}

void solve2()
{
    int ans = (n + 1) / 2;
    cout << ans << "\n";
}

vector<vector<int>> ch(MAXN + 1);
vector<vector<int>> dp(MAXN + 1, vector<int>(2));
vector<bool> used(MAXN + 1);

void dfs(int u)
{
    used[u] = 1;
    for (int v : ch[u]) {
        dfs(v);
    }
    if (ch[u].empty()) {
        dp[u][1] = 1;
    }
    else {
        dp[u][1] = 1;
        for (int v : ch[u]) {
            dp[u][1] += dp[v][0];
            dp[u][0] += max(dp[v][0], dp[v][1]);
        }
    }
}

void solve3()
{
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        if (a[i] == -1) {
            continue;
        }
        ch[a[i]].push_back(i);
    }
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            dfs(i);
            ans += max(dp[i][0], dp[i][1]);
        }
    }
    cout << ans << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    bool t2 = 1;
    bool t3 = 1;
    if (a[1] != -1) {
        t2 = 0;
    }
    for (int i = 2; i <= n; ++i) {
        if (a[i] != i - 1) {
            t2 = 0;
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (a[i] > i) {
            t3 = 0;
        }
    }
    if (n <= 20) {
        solve1();
    }
    else if (t2) {
        solve2();
    }
    else if (t3) {
        solve3();
    }
    //system("pause");
    return 0;
}