#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>

#define MOD 1000000007
#define MAX 100

typedef long long lol;

using namespace std;

struct request
{
	lol z;
	lol k;
	request(lol new_z = 0, lol new_k = 0) : z(new_z), k(new_k) {}
};

bool operator <(request A, request B)
{
	if (A.k == B.k) return A.z < B.z;
	return A.k < B.k;
}

map <request, lol> requests;

lol num_of_numbers(request A)
{
	if (requests.find(A) != requests.end()) return requests[A];
	if ((A.z == 0) && (A.k == 0)) return 1;
	if ((A.z >= 0) && (A.z <= 1) && (A.k == 1)) return 1;
	if ((A.k == 0) || (A.k == 1)) return 0;
	lol l = floor(log2(A.k)) + 1, result;
	if (A.k >> (l - 1) == 1)
	{
		result = num_of_numbers(request(A.z - 1, A.k - (1 << (l - 1)))) + num_of_numbers(request(A.z, (1 << (l - 1)) - 1));
	}
	else result = num_of_numbers(request(A.z, A.k - (1 << (l - 1))));
	result %= MOD;
	requests.insert(make_pair(A, result));
	return result;
}

lol binpow(lol a, lol b)
{
	lol answer = 1;
	while (b > 0)
	{
		if (b & 1)
		{
			b--;
			answer = (answer * a) % MOD;
		}
		else
		{
			b /= 2;
			a = (a * a) % MOD;
		}
	}
	return answer;
}

lol num_of_ones(lol a)
{
	lol answer = 0;
	while (a > 0)
	{
		answer += a & 1;
		a >>= 1;
	}
	return answer;
}

int main()
{
	int n, m, k;
	cin >> n >> m >> k;
	if (m != 0) throw 1;
	int answer = 0;
	/*for (int z = 0; z < MAX; z++)
	{
		answer += binpow(n, z) * num_of_numbers(request(z, k));
		answer %= MOD;
	}
	cout << answer;*/
	for (int i = 0; i <= k; i++)
	{
		answer += binpow(n, num_of_ones(i));
	}
	cout << answer;
	return 0;
}