#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>

typedef long long lol;

using namespace std;

void dfs(int current_vertex, const vector <vector <int> > &graph, vector <bool> &visited, vector <bool> &is_taken)
{
	visited[current_vertex] = true;
	is_taken[current_vertex] = true;
	for (int i = 0; i < graph[current_vertex].size(); i++)
	{
		if (!visited[graph[current_vertex][i]])
		{
			dfs(graph[current_vertex][i], graph, visited, is_taken);
			is_taken[current_vertex] = is_taken[current_vertex] && !is_taken[graph[current_vertex][i]];
		}
	}
}

int main()
{
	int n;
	cin >> n;
	vector <vector <int> > graph(n);
	for (int i = 0; i < n; i++)
	{
		int next_vertex;
		cin >> next_vertex;
		if (next_vertex != -1)
		{
			graph[i].push_back(next_vertex - 1);
			graph[next_vertex - 1].push_back(i);
		}
	}
	vector <bool> visited(n, false), is_taken(n, false);
	vector <int> random_permutation(n);
	for (int i = 0; i < n; i++)
	{
		random_permutation[i] = i;
	}
	for (int i = 0; i < 5 * n; i++)
	{
		int j = rand() % n, k = rand() % n;
		swap(random_permutation[j], random_permutation[k]);
	}
	for (int i = 0; i < n; i++)
	{
		if (!visited[random_permutation[i]])
		{
			dfs(random_permutation[i], graph, visited, is_taken);
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < graph[i].size(); j++)
		{
			if (is_taken[i] && is_taken[graph[i][j]])
			{
				is_taken[i] = false;
			}
		}
	}
	int answer = 0;
	for (int i = 0; i < n; i++)
	{
		if (is_taken[i]) answer++;
	}
	cout << answer;
	return 0;
}