#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

typedef long long ll;

void print(vector<vector<ll>> &v) {
    for (auto &i : v) {
        for (auto j : i) {
            cout << j << " ";
        }
        cout << endl;
    }
    cout << "///" << endl;
}

int main() {
    int n, k;
    cin >> n >> k;
    ll mod = 1000000000ll + 7;
    if (n == k) {
        cout << 1 << endl;
        return 0;
    }
    vector<vector<int>> dp1(n + 1, vector<int>(n + 1));//less
    vector<vector<int>> dp2(n + 1, vector<int>(n + 1));//more
    vector<vector<int>> pref1(n + 1, vector<int>(n + 1));
    vector<vector<int>> pref2(n + 1, vector<int>(n + 1));
    dp1.shrink_to_fit();
    dp2.shrink_to_fit();
    pref1.shrink_to_fit();
    pref2.shrink_to_fit();
    dp1[1][1] = 1;
    dp2[1][1] = 1;
    for (int i = 1; i <= n; ++i) {
        pref2[1][i] = 1;
    }
    pref1[1][1] = 1;
    for (int i = 1; i <= n; ++i) {
        dp1[i][i] = 1;
        dp2[i][i] = 1;
    }
    for (int i = 2; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (i <= j) {
                break;
            }
            dp1[i][j] = pref2[i - j][j - 1];
            dp2[i][j] = pref1[i - j][j + 1];
        }
        for (int j = 1; j <= n; ++j) {
            pref2[i][j] = (pref2[i][j - 1] + dp2[i][j]) % mod;
        }
        pref1[i][n] = dp1[i][n];
        for (int j = n - 1; j >= 1; --j) {
            pref1[i][j] = (pref1[i][j + 1] + dp1[i][j]) % mod;
        }
    }
//    print(dp1);
//    print(pref1);
//    print(dp2);
//    print(pref2);
    cout << (dp1[n][k] + dp2[n][k]) % mod << endl;
}//
// Created by olymp2031 on 26.01.2019.
//

