#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

typedef long long ll;

int cp;

struct arthefact {
    vector<int> param;
    vector<int> state;
    int ind;
    int k;
    arthefact(int indd, int kk) {
        ind = indd;
        k = kk;
        param.resize(k);
        state.resize(k);
    }
    bool operator<(arthefact a) {
        return param[cp] < a.param[cp];
    }
    int get_st() {
        int res = 0;
        for (int i = 0; i < k; ++i) {
            res = (res << 1) + state[i];
        }
        return res;
    }
};

vector<int> perm;
int n, k;
vector<arthefact> v;

bool check() {
    for (int i = 0; i < k; ++i) {
        int l = -2e9;
        int r = 2e9;
        for (int j = 0; j < n; j += 2) {
            l = max(l, min(v[perm[j]].param[i], v[perm[j + 1]].param[i]));
            r = min(r, max(v[perm[j]].param[i], v[perm[j + 1]].param[i]));
        }
        if (l > r) {
            return false;
        }
    }
    cout << "YES" << endl;
    for (int i = 0; i < n; i += 2) {
        cout << v[perm[i]].ind + 1 << " " << v[perm[i + 1]].ind + 1 << endl;
    }
    return true;
}

bool f(int ind) {
    if (ind == n) {
        if (check()) {
            return true;
        }
    }
    else {
        for (int i = 0; i < n; ++i) {
            bool flag = true;
            for (int j = 0; j < ind; ++j) {
                if (i == perm[j]) {
                    flag = false;
                    break;
                }
            }
            if (!flag) {
                continue;
            }
            perm.push_back(i);
            if (f(ind + 1)) {
                return true;
            }
            perm.pop_back();
        }
    }
    return false;
}

int main() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        v.push_back({i, k});
        for (int j = 0; j < k; ++j) {
            cin >> v[i].param[j];
        }
    }

    if (n <= 10) {
        if (!f(0)) {
            cout << "NO" << endl;
        }
        return 0;
    }

    for (cp = 0; cp < k; ++cp) {
        sort(v.begin(), v.end());
        for (int i = 0; i < n / 2; ++i) {
            v[i].state[cp] = 0;
        }
        for (int i = n / 2; i < n; ++i) {
            v[i].state[cp] = 1;
        }
    }
    int m = 1 << k;
    vector<vector<int>> by_st(m);
    for (int i = 0; i < n; ++i) {
        by_st[v[i].get_st()].push_back(v[i].ind + 1);
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < m / 2; ++i) {
        if (by_st[i].size() != by_st[m - i - 1].size()) {
            cout << "NO" << endl;
            return 0;
        }
        for (int j = 0; j < by_st[i].size(); ++j) {
            ans.push_back({by_st[i][j], by_st[m - i - 1][j]});
        }
    }
    cout << "YES" << endl;
    for (auto i : ans) {
        cout << i.first << " " << i.second << endl;
    }
}

