#include <bits/stdc++.h>


//#define int long long


using namespace std;


void warp()
{
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


bool in(int mask, int i)
{
    return ((mask & (1 << i)) > 0);
}


int dumbSolve(vector<int> a)
{
    int n = a.size();
    int bestmask = -1;
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++)
    {
        int cnt = 0;
        bool flag = true;
        for (int i = 0; i < n; i++)
        {
            if (in(mask, i)) cnt++;
            if (a[i] != -1 && in(mask, i) && in(mask, a[i])) flag = false;
        }
        if (flag)
        {
            if (cnt > ans)
            {
                bestmask = mask;
                ans = cnt;
            }
        }
    }
    return ans;
}


pair<int, int> dfs(int v, vector<vector<int> > &g, vector<bool> &used)
{
    used[v] = true;
    pair<int, int> ans = make_pair(1, 0);
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i];
        if (!used[u])
        {
            pair<int, int> res = dfs(u, g, used);
            ans.first += res.second;
            ans.second += max(res.first, res.second);
        }
    }
    return ans;
}


bool cyclic(int v, int prev, vector<vector<int> > &g, vector<bool> &used)
{
    used[v] = true;
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i];
        if (u == prev) continue;
        if (used[u]) return true;
        if (cyclic(u, v, g, used)) return true;
    }
    return false;
}


void die()
{
    while(true){}
}


int solve(vector<int> &a)
{
    int n = a.size();
    vector<vector<int> > g(n);
    for (int i = 0; i < n; i++)
    {
        if (a[i] == -1) continue;
        g[i].push_back(a[i]);
        g[a[i]].push_back(i);
    }
    vector<bool> used(n);
    /*for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            if (cyclic(i, -1, g, used)) die();
        }
    }
    used.assign(n, false);
    */
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            pair<int, int> res = dfs(i, g, used);
            ans += max(res.first, res.second);
        }
    }
    return ans;
}


void leaveDfs(int v, int before, vector<vector<int> > &g, vector<bool> &used, vector<pair<int, int> > &profit)
{
    used[v] = true;
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i];
        if (used[u]) continue;
        if (g[u].size() < 3) leaveDfs(u, before + 1, g, used, profit);
        else
        {
            profit[u].first += (before + 1) / 2;
            profit[u].second += (before + 1) / 2 + (before + 1) % 2;
        }
    }
}


void cycleDfs(int v, vector<vector<int> > &g, vector<bool> &used, vector<int> &ans)
{
    used[v] = true;
    ans.push_back(v);
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i];
        if (!used[u]) cycleDfs(u, g, used, ans);
    }
}


int bestSolve(vector<int> &a)
{
    int n = a.size();
    vector<vector<int> > g(n);
    for (int i = 0; i < n; i++)
    {
        if (a[i] == -1) continue;
        g[i].push_back(a[i]);
        g[a[i]].push_back(i);
    }
    vector<bool> used(n);
    int ans = 0;
    vector<int> good;
    for (int i = 0; i < n; i++)
    {
        if (used[i]) continue;
        if (!cyclic(i, -1, g, used)) good.push_back(i);
    }
    used.assign(n, false);
    for (int i = 0; i < good.size(); i++)
    {
        pair<int, int> res = dfs(good[i], g, used);
        ans += max(res.first, res.second);
    }
    vector<pair<int, int> > profit(n, make_pair(1, 0));
    for (int i = 0; i < n; i++)
    {
        if (used[i] || g[i].size() > 1) continue;
        leaveDfs(i, 0, g, used, profit);
    }
    vector<vector<int> > cycles;
    for (int i = 0; i < n; i++)
    {
        if (used[i]) continue;
        cycles.push_back(vector<int>());
        cycleDfs(i, g, used, cycles[cycles.size() - 1]);
    }
    for (int i = 0; i < cycles.size(); i++)
    {
        vector<pair<int, int> > dp1(cycles[i].size());
        vector<pair<int, int> > dp2(cycles[i].size());
        dp1[0] = profit[cycles[i][0]];
        dp2[0] = dp1[0];
        dp2[0].first = dp2[0].second;
        for (int j = 1; j < cycles[i].size(); j++)
        {
            dp1[j].first = profit[cycles[i][j]].first + dp1[j - 1].second;
            dp1[j].second = profit[cycles[i][j]].second + max(dp1[j - 1].first, dp1[j - 1].second);
            dp2[j].first = profit[cycles[i][j]].first + dp2[j - 1].second;
            dp2[j].second = profit[cycles[i][j]].second + max(dp2[j - 1].first, dp2[j - 1].second);
        }
        ans += max(max(dp2[dp2.size() - 1].first, dp2[dp2.size() - 1].second), dp1[dp2.size() - 1].second);
    }
    return ans;
}


signed main()
{
    //warp();
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        if (a[i] > 0) a[i]--;
    }
    cout << bestSolve(a) << endl;
    /*
    cont int n = 15;
    vector<int> a(n);
    while(true)
    {
        for (int i = 0; i < n; i++)
        {
            a[i] = rand() % (i + 1) - 1;
        }
        if (solve(a) != dumbSolve(a))
        {
            cout << "FAIL" << endl;
            break;
        }
        else
        {
            cout << "OK" << endl;
        }
    }
    for (int i = 0; i < n; i++)
    {
        cout << a[i] << "  ";
    }
    cout << endl;
    cout << dumbSolve(a) << endl;
    cout << solve(a) << endl;
    */
    return 0;
}
