#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <cstdio>
#include <iomanip>

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define RAND srand(time(0));
#define FIXED cout << fixed << setprecision(8);

#define pb push_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()

#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int INF = (int) 1e9;

int n, k;
vector<vector<int>> a;

void solve1() {
	vector<int> p(n, 0);
	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}
	do {
		vector<int> b1(k, -INF), b2(k, +INF);
		for (int i = 0; i + 1 < n; i += 2) {
			for (int j = 0; j < k; ++j) {
				int q, w;
				q = a[p[i]][j];
				w = a[p[i + 1]][j];
				if (q > w) swap(q, w);
				b1[j] = max(b1[j], q);
				b2[j] = min(b2[j], w);
			}
		}
		bool flag = true;
		for (int j = 0; j < k; ++j) {
			if (b1[j] > b2[j]) {
				flag = false;
				break;
			}
		}
		if (flag) {
			cout << "YES" << endl;
			for (int i = 0; i + 1 < n; i += 2) {
				cout << p[i] + 1 << " " << p[i + 1] + 1 << endl;
			}
			return;
		}
	}
	while (next_permutation(all(p)));
	cout << "NO" << endl;
}

void solve2() {
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}
	sort(all(p), [&] (int i, int j) {
		return a[i][0] < a[j][0];
	});
	int b1 = -INF, b2 = +INF;
	for (int i = 0, j = n - 1; i < j; ++i, --j) {
		b1 = max(b1, a[p[i]][0]);
		b2 = min(b2, a[p[j]][0]);
	}
	if (b1 <= b2) {
		cout << "YES" << endl;
		for (int i = 0; i < n / 2; ++i) {
			cout << p[i] + 1 << " " << p[n - i - 1] + 1 << endl;
		}
	}
	else {
		cout << "NO" << endl;
	}
}

signed main() {

	cin >> n >> k;
	a.resize(n, vector<int>(k));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
		}
	}

	if (n <= 11)
		solve1();
	else if (k == 1)
		solve2();
	else
		solve1();

	return 0;
}