
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#define ll long long

using namespace std;

struct node {
	int l = -1;
	int r = -1;
	int x;
	int size = 1;
	int ind;
	ll y = (rand() << 15) + rand();
	node(){}
};

vector<node> pool;

int safe(int root) {
	if (root == -1) return 0;
	return pool[root].size;
}

void relax(int root) {
	if (root == -1) return;
	pool[root].size = (1 + safe(pool[root].l) + safe(pool[root].r));
}

pair<int, int> split(int root, int k) {
	if (root == -1) return { -1, -1 };
	if (pool[root].x >= k) {
		auto res = split(pool[root].l, k);
		pool[root].l = res.second;
		relax(root);
		return { res.first, root };
	}
	auto res = split(pool[root].r, k);
	pool[root].r = res.first;
	relax(root);
	return { root, res.second };
}

int merge(int L, int R) {
	if (L == -1) return R;
	if (R == -1) return L;
	if (pool[L].y < pool[R].y) {
		pool[R].l = merge(L, pool[R].l);
		relax(R);
		return R;
	}
	pool[L].r = merge(pool[L].r, R);
	relax(L);
	return L;
}

int add(int root, int x) {
	node A;
	A.x = x;
	int ind = pool.size();
	pool.push_back(A);
	auto res = split(root, x);
	return merge(res.first, merge(ind, res.second));
}

int del(int root, int x) {
	auto res = split(root, x);
	//res.second >= x
	auto res1 = split(res.second, x + 1);
	//res1.second >= x + 1
	//res.first < x
	return merge(res.first, res1.second);
}

int main() {
	int n, m;
	cin >> n >> m;
	vector<int> a(m);
	vector<int> b(n);
	int el;
	for (int i = 0; i < m; i++) {
		cin >> el;
		a[i] = el - 1;
	}
	for (int i = 0; i < n; i++) {
		cin >> el;
		b[i] = el - 1;
	}

	///*
	//-----------------first and second----------------------------
	if (n == m) {
		bool flag = 1;
		for (int i = 0; i < n; i++) {
			if (a[i] != b[i]) {
				flag = 0;
				break;
			}
		}
		if (flag == 1) {
			cout << n << endl;
			for (int i = 0; i < n; i++) cout << n << " ";
			cout << endl;
			return 0;
		}
		flag = 1;
		for (int i = 0; i < n; i++) {
			if (a[i] != b[n - i - 1]) {
				flag = 0;
				break;
			}
		}
		if (flag == 1) {
			cout << 2 * n - 1 << endl;
			for (int i = 0; i < n - 1; i++) {
				cout << n - i << " ";
			}
			for (int i = 0; i < n; i++) {
				cout << n << " ";
			}
			cout << endl;
			return 0;
		}
	}
	//--------------------------------------------------------

	
	//-----------------------------third-------------------------------------
	if (n <= 2000 && m <= 2000) {
		vector<int> place(n);
		for (int i = 0; i < n; i++) {
			place[b[i]] = i;
		}
		vector<vector<int> > pos(n);
		vector<int> pt(n);
		for (int i = 0; i < n; i++) pt[i] = 0;
		for (int i = 0; i < m; i++) {
			pos[a[i]].push_back(i);
		}
		for (int i = 0; i < n; i++) {
			pt[i] = 0;
			pos[i].push_back(m);
		}
		vector<int> move;
		for (int j = 0; j < m; j++) {
			//cout << j << endl;
			//for (auto elem : place) cout << elem << " ";
			//cout << endl;
			//cout << j << endl;
			int need = a[j];
			while (place[need] != 0) {
				int now = -1;
				for (int i = 0; i < n; i++) {
					if (place[i] == 0) {
						now = i;
						break;
					}
				}
				//cout << now << "!" << endl;
				//for (auto elem : place) cout << elem << " ";
				//cout << endl;
				int ind = pos[now][pt[now]];
				int maxim = 0;
				for (int i = j; i < ind; i++) {
					maxim = max(maxim, place[a[i]]);
				}
				move.push_back(maxim + 1);
				for (int i = 0; i < n; i++) {
					if (place[i] <= maxim) place[i]--;
				}
				place[now] = maxim;
			}
			//cout << "here" << endl;
			pt[need]++;
			int ind = pos[need][pt[need]];
			//cout << "here" << endl;
			int maxim = 0;
			for (int i = j + 1; i < ind; i++) {
				maxim = max(maxim, place[a[i]]);
			}
			move.push_back(maxim + 1);
			for (int i = 0; i < n; i++) {
				if (place[i] <= maxim) place[i]--;
			}
			place[need] = maxim;
		}
		cout << move.size() << endl;
		for (auto elem : move) cout << elem << " ";
		cout << endl;
		return 0;
	}
	//--------------------------------------------------------------------------
	//*/
	
	// a[i] - are different
	int root = -1;
	vector<int> pos(n);
	vector<int> place(n);
	vector<int> ans(n);
	vector<int> out(n);
	for (int i = 0; i < m; i++) {
		pos[a[i]] = i;
	}
	for (int i = 0; i < n; i++) {
		ans[i] = -1;
		place[b[i]] = i;
	}
	set<int> white;
	int pt = 0;
	for (int i = 0; i < n; i++) {
		int need = a[i];
		if (white.find(need) == white.end()) {
			//it is still in  stack
			while (b[pt] != need) {
				white.insert(b[pt]);
				auto res = split(root, pos[b[pt]]);
				out[b[pt]] = safe(res.first);
				root = merge(res.first, res.second);
				root = add(root, pos[b[pt]]);
				pt++;
			}
			pt++;
		}
		else {
			int numb = pt - place[need];
			numb += out[need];
			ans[need] = numb;
			del(root, pos[need]);
			white.erase(need);
			pt++;
		}
	}
	pt = 0;
	white.clear();
	vector<int> move;
	for (int i = 0; i < n; i++) {
		int need = a[i];
		if (white.find(need) == white.end()) {
			//it is still in  stack
			while (b[pt] != need) {
				white.insert(b[pt]);
				move.push_back(ans[b[pt]]);
				pt++;
			}
			move.push_back(n);
			pt++;
		}
		else {
			white.erase(need);
			move.push_back(n);
		}
	}
	cout << move.size() << endl;
	for (auto elem : move) cout << elem << " ";
	cout << endl;
}
