#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>

using namespace std;

int cnt = 0;
int inf = 1e9;

vector<int> st;

vector<vector<int> > circle;
unordered_set<int> bad;

void dfs(int now, int par, vector<int> &used, vector<vector<int> > &graph) {
	used[now] = 1;
	st.push_back(now);
	for (auto elem : graph[now]) {
		if (elem == par) continue;
		if (used[elem] == 1) circle.push_back(st);
		if (used[elem] == 0) {
			dfs(elem, now, used, graph);
		}
	}
	used[now] = 2;
	st.pop_back();
}

void dfs_calc(int now, vector<pair<int, int> > &dp, vector<int> &used, vector<vector<int> > &graph) {
	used[now] = 1;
	vector<int> child;
	for (auto elem : graph[now]) {
		if (bad.find(elem) != bad.end()) continue;
		if (used[elem] == 1) continue;
		child.push_back(elem);
		dfs_calc(elem, dp, used, graph);
	}
	dp[now].first = 0;
	dp[now].second = 1;
	for (auto elem : child) {
		dp[now].first += max(dp[elem].first, dp[elem].second);
		dp[now].second += dp[elem].first;
	}
}

int main(){
	int n;
	cin >> n;
	vector<vector<int> > graph(n);
	int x;
	for (int i = 0; i < n; i++) {
		cin >> x;
		if (x == -1) continue;
		x--;
		graph[i].push_back(x);
		graph[x].push_back(i);
	}
	vector<int> used(n);
	for (int i = 0; i < n; i++) used[i] = 0;
	vector<int> roots;
	int help;
	for (int i = 0; i < n; i++) {
		st.clear();
		help = circle.size();
		if (used[i] == 0) {
			dfs(i, -1, used, graph);
			if (help == circle.size()) roots.push_back(i);
		}
	}
	//cout << roots.size() << ": ";
	//cout << circle.size() << endl;
	/*
	for (auto c : circle) {
		for (auto elem : c) cout << elem << " ";
		cout << endl;
	}
	*/
	//cout << "here" << endl;
	vector<pair<int, int> > dp(n);
	for (int i = 0; i < n; i++) dp[i] = { -1, -1 };
	for (auto c : circle) {
		for (auto elem : c) bad.insert(elem);
	}
	for (int i = 0; i < n; i++) used[i] = 0;
	for (auto c : circle) {
		for (auto elem : c) {
			dfs_calc(elem, dp, used, graph);
		}
	}
	/*
	for (int i = 0; i < n; i++) {
		cout << i << ": ";
		cout << dp[i].first << "/" << dp[i].second << endl;
	}
	*/
	//cout << "here" << endl;
	int ans = 0;
	for (auto elem : roots) {
		dfs_calc(elem, dp, used, graph);
		ans += max(dp[elem].first, dp[elem].second);
	}
	for (auto c : circle) {
		int n1 = c.size();
		vector<pair<int, int> > dp1(n1); // starts with 0
		vector<pair<int, int> > dp2(n1); //starts with 1
		dp1[0] = { dp[c[0]].first, -inf };
		dp2[0] = { -inf, dp[c[0]].second};
		for (int i = 1; i < n1; i++) {
			//cout << i << "!!" << endl;
			int ind = c[i];
			int last = c[i - 1];
			//cout << ind << " " << last << endl;
			dp1[i].first = max(dp1[i - 1].first, dp1[i - 1].second) + dp[ind].first;
			dp1[i].second = dp1[i - 1].first + dp[ind].second;

			dp2[i].first = max(dp2[i - 1].first, dp2[i - 1].second) + dp[ind].first;
			dp2[i].second = dp2[i - 1].first + dp[ind].second;
		}
		//cout << "here" << endl;
		int ans1 = max(dp1[n1 - 1].first, dp1[n1 - 1].second);
		ans1 = max(ans1, dp2[n1 - 1].first);
		ans += ans1;
	}
	cout << ans << endl;
	//cin >> ans;
}