
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

int n, k;
bool flag = 0;

void check(vector<int> &now, vector<vector<int> > &arr) {
	vector<pair<int, int> > para;
	for (int i = 0; i < n; i++) {
		if (now[i] != -1) para.push_back({ i, now[i] });
	}
	for (int j = 0; j < k; j++) {
		int L = -1e9 - 1;
		int R = 1e9 + 1;
		for (auto elem : para) {
			int x, y;
			x = arr[elem.first][j];
			y = arr[elem.second][j];
			if (x > y) swap(x, y);
			L = max(L, x);
			R = min(R, y);
		}
		if (L > R) return;
	}
	flag = 1;
	cout << "YES" << endl;
	for (auto elem : para) {
		cout << elem.first + 1 << " " << elem.second + 1 << endl;
	}
}


void gen(vector<int> &now, int pt, vector<vector<int> > &arr, set<int> &used) {
	if (flag) return;
	if (pt == n) {
		check(now, arr);
		if (flag) return;
	}
	if (used.find(pt) != used.end()) {
		gen(now, pt + 1, arr, used);
		return;
	}
	for (int i = pt + 1; i < n; i++) {
		if (used.find(i) != used.end()) continue;
		now[pt] = i;
		used.insert(i);
		gen(now, pt + 1, arr, used);
		if (flag) return;
		used.erase(i);
		now[pt] = -1;
	}
}

int main() {
	cin >> n >> k;
	vector<vector<int> > arr(n);
	int el;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			cin >> el;
			arr[i].push_back(el);
		}
	}
	if (k == 1) {
		vector<pair<int, int> > line(n);
		for (int i = 0; i < n; i++) {
			line[i] = { arr[i][0], i };
		}
		sort(line.begin(), line.end());
		cout << "YES" << endl;
		for (int i = 0; i < n / 2; i++) {
			cout << line[i].second + 1 << " " << line[n - i - 1].second + 1 << endl;
		}
		return 0;
	}
	
	if (n <= 10) {
		vector<int> now(n);
		for (int i = 0; i < n; i++) now[i] = -1;
		set<int> used;
		gen(now, 0, arr, used);
		if (!flag) cout << "NO" << endl;
		return 0;
	}
	
	vector<int> used(n);
	for (int i = 0; i < n; i++) used[i] = 0;
	vector<vector<int> > cnt(1 << k);
	vector<vector<int> > type(n);
	for (int j = 0; j < k; j++) {
		vector<pair<int, int> > line(n);
		for (int i = 0; i < n; i++) {
			line[i] = { arr[i][j], i };
		}
		sort(line.begin(), line.end());
		for (int i = 0; i < n / 2; i++) {
			int el = line[i].second;
			type[el].push_back(0);
		}
		for (int i = n/ 2; i < n; i++) {
			int el = line[i].second;
			type[el].push_back(1);
		}
	}
	for (int i = 0; i < n; i++) {
		int mask = 0;
		for (int j = 0; j < k; j++) {
			mask *= 2;
			mask += type[i][j];
		}
		cnt[mask].push_back(i);
	}
	vector<pair<int, int> > para;
	for (int mask = 0; mask < (1 << k); mask++) {
		int mask1 = mask ^ (1 << k);
		if (mask1 < mask) continue;
		if (cnt[mask].size() != cnt[mask1].size()) {
			cout << "NO" << endl;
			return 0;
		}
		for (int j = 0; j < cnt[mask].size(); j++) {
			para.push_back({ cnt[mask][j], cnt[mask1][j] });
		}
	}
	cout << "YES" << endl;
	for (auto elem : para) {
		cout << elem.first + 1 << " " << elem.second + 1 << endl;
	}
}