#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;

vector<vector<int>> g;
vector<int> p;
vector<bool> used;

bool dfs(int v) {
	used[v] = false;
	for (auto i : g[v]) {
		if (p[i] == -1) {
			p[v] = i;
			p[i] = v;
			return true;
		}
	}
	for (auto i : g[v]) {
		if (used[p[i]]) {
			used[i] = false;
			if (dfs(p[i])) {
				p[v] = i;
				p[i] = v;
				return true;
			}
		}
	}
	return false;
}

int main() {
	ios_base::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector<vector<int>> ms(n, vector<int>(m + 1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> ms[i][j];
		}
		ms[i][m] = i;
	}
	if (m==1) {
		sort(ms.begin(), ms.end());
		cout << "YES" << '\n';
		for (int i = 0; i < n / 2; i++) {
			cout << ms[i][m] + 1 << ' ' << ms[n - 1 - i][m] + 1 << '\n';
		}
	}
	else {
		g.resize(n);
		p.resize(n, -1);
		vector<vector<int>> h(m);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				h[j].push_back(ms[i][j]);
			}
		}
		vector<int> ogr(m);
		for (int i = 0; i < m; i++) {
			sort(h[i].begin(), h[i].end());
			ogr[i] = h[i][n / 2];
		}
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				bool t1 = true;
				for (int t = 0; t < m; t++) {
					if (min(ms[i][t], ms[j][t]) > ogr[t] || max(ms[i][t], ms[j][t]) < ogr[t]) {
						t1 = false;
					}
				}
				if (t1) {
					g[i].push_back(j);
					g[j].push_back(i);
				}
			}
		}
		bool t = true;
		for (int i = 0; i < n; i++) {
			if (p[i] == -1) {
				used.resize(0);
				used.resize(n, true);
				dfs(i);
			}
			if (p[i] == -1) {
				t = false;
			}
		}
		if (!t) {
			cout << "NO";
		}
		else {
			cout << "YES" << '\n';
			for (int i = 0; i < n; i++) {
				if (p[i] > i) {
					cout << i + 1 << ' ' << p[i] + 1 << '\n';
				}
			}
		}
	}
	system("pause");
}
