#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <assert.h>
#include <set>
#include <cassert>
#define int long long

using namespace std;

struct go
{
	int v1, v2;
};

int n;
vector<int> u_cycle;
vector<bool> l_used, cycle, used;
vector<go> vert, dp;
vector<vector<int>> g;

bool find_cycle(int v, int pr, vector<int> &arr)
{
	//arr.push_back(v);
	u_cycle[v] = 1;
	for (int to : g[v])
	{
		if (to == pr) continue;
		if (u_cycle[to] == 2) continue;
		else if (u_cycle[to] == 1)
		{
			u_cycle[to] = 2;
			arr.push_back(to);
			arr.push_back(v);
			return true;
		}
		else
		{
			if (find_cycle(to, v, arr))
			{
				if (u_cycle[v] == 2)
					return false;
				arr.push_back(v);
				return true;
			}
		}
	}
	u_cycle[v] = 2;
	return false;
}

void dfs(int v, int par)
{
	used[v] = true;
	for (int to : g[v])
	{
		if (par == to) continue;
		if (cycle[to]) continue;
		dfs(to, v);
	}
	for (int to : g[v])
	{
		if (par == to) continue;
		if (cycle[to]) continue;
		vert[v].v1 += vert[to].v2;
		vert[v].v2 += max(vert[to].v1, vert[to].v2);
	}
}

int result(int v, int pr, int start, int len, int now, bool use)
{
	if (now == len - 1)
	{
		for (int to : g[v])
			if (cycle[to])
			{
				if ((start != to))
				{
					if (use)
					{
						//dp[v].v1 = (dp[to].v2 + max(vert[v].v1, vert[v].v2));
						dp[v].v2 = max(dp[to].v1 + vert[v].v2, dp[to].v2 + vert[v].v2);
						return dp[v].v2;
					}
					else
					{
						dp[v].v1 = (dp[to].v2 + max(vert[v].v1, vert[v].v2));
						dp[v].v2 = max(dp[to].v1 + vert[v].v2, dp[to].v2 + vert[v].v2);
						return max(dp[v].v1, dp[v].v2);
					}
				}
			}
	}
	for (int to : g[v])
		if (cycle[to])
		{
			if (to == pr)
			{
				dp[v].v1 = (dp[to].v2 + max(vert[v].v1, vert[v].v2));
				dp[v].v2 = max(dp[to].v1 + vert[v].v2, dp[to].v2 + vert[v].v2);
			}
		}

	for (int to : g[v])
		if (cycle[to])
		{
			if (!(to == pr))
			{
				if (start == to)
				{
					dp[start].v1 = dp[v].v2 + vert[v].v2;
					dp[start].v2 = max(dp[v].v1 + vert[v].v1, dp[v].v2 + vert[v].v2);
				}
				else
				{
					return result(to, v, start, len, now + 1, use);
				}
			}
		}
}

int solve(int v)
{
	vector<int> arr;
	find_cycle(v, -1, arr);
	vector<int> true_arr;
	for (int v : arr)
	{
		if (!cycle[v]) true_arr.push_back(v);
		cycle[v] = true;
	}
	if (!arr.size())
	{
		dfs(v, -1);
		return max(vert[v].v1, vert[v].v2);
	}
	for (int to : true_arr)
	{
		if (cycle[to])
		{
			dfs(to, -1);
		}
	}
	dp[true_arr[0]] = { max(vert[true_arr[0]].v1, vert[true_arr[0]].v2), vert[true_arr[0]].v2 };
	int a = result(true_arr[0], -1, true_arr[0], true_arr.size(), 0, true);
	dp[true_arr[0]] = { vert[true_arr[0]].v2, vert[true_arr[0]].v2 };
	int b = result(true_arr[0], -1, true_arr[0], true_arr.size(), 0, false);
	return max(a, b);
}

int solveXX()
{
	int best = 0;
	for (int i = 0; i < (1 << n); i++)
	{
		bool good = true;
		int cnt = 0;
		for (int v = 0; v < n; v++)
		{
			if ((1 << v) & (i))
			{
				cnt++;
				for (int to : g[v])
				{
					if ((1 << to) & i)
						good = false;
				}
			}
		}
		if (good)
			best = max(best, cnt);
	}
	return best;
}

int solver()
{
	u_cycle.assign(n, 0);
	cycle.assign(n, false);
	used.assign(n, false);
	vert.assign(n, { 1, 0 });
	dp.assign(n, { 1, 0 });
	int ans = 0;
	for (int i = 0; i < n; i++)
		if (used[i] == 0)
			ans += solve(i);
	return ans;
}

void norm_solve()
{
	cin >> n;
	g.clear();
	g.resize(n);
	vector<set<int>> gg(n);
	for (int i = 0; i < n; i++)
	{
		int to;
		cin >> to;
		if (--to >= 0)
		{
			gg[i].insert(to);
			gg[to].insert(i);
		}
	}	
	for (int v = 0; v < n; v++)
		for (int to : gg[v])
			g[v].push_back(to);
	int now_ans = solver();
	cout << now_ans;
}

signed main()
{
	//solver();
	//freopen("input.txt", "r", stdin);

	//cin >> n;

	
	norm_solve();
	return 0;
	
	

	int k = 0;
	for (int test = 0; test < 10000; test++)
	{
		n = 5;
		vector<set<int>> gg(n);
		g.clear();
		g.resize(n);
		for (int i = 0; i < n; i++)
		{
			int to;
			//cin >> to;
			to = i + 1;
			while (to == i + 1)
				to = rand() % n + 1;
			if (--to >= 0)
			{
				gg[i].insert(to);
				gg[to].insert(i);
			}
		}
		for (int v = 0; v < n; v++)
			for (int to : gg[v])
				g[v].push_back(to);
		int now_ans = solver();
		int true_ans = solveXX();
		if (now_ans != true_ans)
		{
			cout << true_ans << "\n";
			cout << now_ans << "\n";
			for (int v = 0; v < n; v++)
			{
				for (int to : g[v])
					cout << to << " ";
				cout << "\n";
			}
			return 0;
		}
		//cout << now_ans;
	}
	return 0;
}