#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define all(v) v.begin(), v.end()
#define x first
#define y second
#pragma GCC optimize("fast-math")

/*

void build(int v, int l, int r)
{
	if (l + 1 == r)
	{
		rmq[v] = a[v];
		return;
	}
	build(v + v, l, (l + r) / 2);
	build(v + v + 1, (l + r) / 2, r);
	rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

int get(int v, int tl, int tr, int l, int r)
{
	if (l >= tr || r <= tl) return 0;
	if (l <= tl && r >= tr)
	{
		return rmq[v];
	}
	return get(v + v, tl, (tl + tr) / 2, l, r) + get(v + v + 1, (tl + tr) / 2, tr, l, r);
}


int update(int v, int l, int r, int ind, int x)
{
	if (l + 1 == r)
	{
		rmq[v] = x;
		return;
	}
	int m = (l + r) / 2;
	if (ind < m) update(v + v, l, m, ind, x);
	else update(v + v + 1, m, r, ind, x);
	rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

*/

int32_t main()
{
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector<int> a(m), b(n);
	vector<vector<int>> q(n, vector<int>(0));
	for (int i = 0; i < m; i++)
	{
		cin >> a[i];
		a[i]--;
		q[a[i]].push_back(i);
	}
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
		b[i]--;
	}

	if (n == m)
	{
		bool flag = true;
		for (int i = 0; i < n; i++) flag = flag & (a[i] == b[i]);
		if (flag)
		{
			cout << n << '\n';
			for (int i = 0; i < n; i++)
			{
				cout << n << " ";
			}
			system("pause");
			return 0;
		}
		flag = true;
		for (int i = 0; i < n; i++) flag = flag & (a[i] == b[n - i - 1]);
		if (flag)
		{
			cout << n + n - 1 << '\n';
			for (int i = 0; i < n - 1; i++)
			{
				cout << n - i << " ";
			}
			for (int i = 0; i < n; i++) cout << n << " ";
			system("pause");
			return 0;
		}
	}


	if (n <= 2000 && m <= 2000)
	{
		vector<int> ans;
		bool flag;
		int kolvo;
		int curr = 0;
		vector<bool> used(n, false);
		int where;
		auto it = b.begin();
		int j;
		for (int i = 0; i < m;)
		{
			flag = false;
			curr = b[0];
			kolvo = 0;
			j = i + 1;
			if (a[i] != b[0]) j--;
			for (j; j < m; j++)
			{
				if (a[j] == b[0])
				{
					flag = true;
					break;
				}
				if (!used[a[j]])
				{
					kolvo++;
					used[a[j]] = true;
				}
			}
			b.erase(b.begin());
			where = 1;
			for (it = b.begin(); it != b.end(); it++)
			{
				if (kolvo == 0) break;
				where++;
				if (used[*it])
				{
					used[*it] = false;
					kolvo--;
				}
			}
			ans.push_back(where);
			b.insert(it, curr);
			if (curr == a[i]) i++;
		}
		cout << ans.size() << '\n';
		for (auto i : ans) cout << i << " ";
		return 0;
	}


	vector<bool> u(n, false);
	for (auto i : a) u[i] = true;
	vector<int> ans;
	bool flag;
	int kolvo;
	int curr = 0;
	vector<bool> used(n, false);
	int where;
	auto it = b.begin();
	int j;
	for (int i = 0; i < m;)
	{
		if (!u[b[0]])
		{
			b.push_back(*b.begin());
			b.erase(b.begin());
			ans.push_back(n);
			continue;
		}
		if (b[0] == a[i])
		{
			u[b[0]] = false;
			i++;
			b.push_back(*b.begin());
			b.erase(b.begin());
			ans.push_back(n);
			continue;
		}
		flag = false;
		curr = b[0];
		kolvo = 0;
		j = i + 1;
		if (a[i] != b[0]) j--;
		for (j; j < m; j++)
		{
			if (a[j] == b[0])
			{
				flag = true;
				break;
			}
			if (!used[a[j]])
			{
				kolvo++;
				used[a[j]] = true;
			}
		}
		b.erase(b.begin());
		where = 1;
		for (it = b.begin(); it != b.end(); it++)
		{
			if (kolvo == 0) break;
			where++;
			if (used[*it])
			{
				used[*it] = false;
				kolvo--;
			}
		}
		ans.push_back(where);
		b.insert(it, curr);
		if (curr == a[i]) i++;
	}
	cout << ans.size() << '\n';
	for (auto i : ans) cout << i << " ";

	system("pause");
	return 0;
}
/*
#define mod 1000000007

bool check(int a, int b)
{
	for (int i = 0; i <= 10; i++)
	{
		if ((a >> i) & 1)
		{
			if (!((b >> i) & 1)) return false;
		}
	}
	return true;
}

int32_t main()
{
	
	int n, m, k;
	cin >> n >> m >> k;
	if (n <= 500 && k <= 500)
	{
		int ans = 0;
		vector<vector<int>> a(k + 1, vector<int>(0));
		for (int i = 0; i <= k; i++)
		{
			for (int j = i; j <= k; j++)
			{
				if (check(i, j)) a[i].push_back(j);
			}
		}
		vector<int> curr(k + 1, 1), tmp(k + 1);
		for (int i = 1; i < n; i++)
		{
			tmp.assign(k + 1, 0);
			for (auto j = 0; j <= k; j++)
			{
				for (auto t : a[j])
				{
					tmp[t] += curr[j];
					if (tmp[t] >= mod) tmp[t] -= mod;
				}
			}
			curr = tmp;
		}
		for (auto i : curr)
		{
			ans += i;
			if (ans >= mod) ans -= mod;
		}
		cout << ans;
		return 0;
	}
	if (n >= 300000) return 2;
	system("pause");
	return 0;
}*/