#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define all(v) v.begin(), v.end()
#define x first
#define y second
#pragma GCC optimize("fast-math")

/*
int32_t main()
{
	int n, k;
	cin >> n >> k;
	if (k == 1)
	{
		cout << "YES\n";
		vector<pair<int, int>> a(n);
		for (int i = 0; i < n; i++)
		{
			cin >> a[i].x;
			a[i].y = i + 1;
		}
		sort(all(a));
		for (int i = 0; i < n / 2; i ++)
		{
			cout << a[i].y << " " << a[n - i - 1].y << '\n';
		}
		return 0;
	}
	vector<vector<int>> a(n, vector<int>(k));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < k; j++) cin >> a[i][j];
	}
	vector<int> q(n);
	for (int i = n - 1; i >= 0; i--) q[i] = i;
	vector<pair<int, int>> gr(k);

	bool flag = true;
	do
	{
		flag = true;
		for (int i = 0; i < k; i++) gr[i] = { -1000000007, 1000000007 };
		for (int i = 0; i < n; i += 2)
		{
			for (int j = 0; j < k; j++)
			{
				gr[j].x = max(gr[j].x, min(a[q[i]][j], a[q[i + 1]][j]));
				gr[j].y = min(gr[j].y, max(a[q[i]][j], a[q[i + 1]][j]));
			}
		}
		for (int i = 0; i < k; i++)
		{
			if (gr[i].x > gr[i].y) flag = false;
		}
		if (flag)
		{
			cout << "YES" << '\n';
			for (int i = 0; i < n; i += 2)
			{
				cout << q[i] + 1<< " " << q[i + 1] + 1<< '\n';
			}
			system("pause");
			return 0;
		}
	} while (next_permutation(all(q)));
	cout << "NO";
	system("pause");
	return 0;
}

*/


int n;
vector<set<int>> g;
vector<int> cant;
vector<bool> used(n);
vector<pair<int, int>> dp(n);
int kolvo;


void DFS(int v)
{
	used[v] = true;
	kolvo++;
	for (auto i : g[v])
	{
		if (used[i]) continue;
		DFS(i);
	}
}

void DFS2(int v, int p)
{
	used[v] = true;
	for (auto i : g[v])
	{
		if (i == p) continue;
		DFS2(i, v);
		dp[v].x += dp[i].y;
		dp[v].y += dp[i].x;
	}
	dp[v].x++;
}


int32_t main()
{
	cin >> n;
	g.resize(n);
	cant.resize(n, -1);
	used.resize(n, false);
	bool flag = true, flag2 = true;

	int tmp;
	for (int i = 0; i < n; i++)
	{
		cin >> tmp;
		if (tmp == -1) continue;
		tmp--;
		cant[i] = tmp;
		g[tmp].insert(i);
		g[i].insert(tmp);
	}
	if (cant[0] != -1) flag = false;
	for (int i = 1; i < n; i++)
	{
		if (cant[i] != i - 1) flag = false;
		if (cant[i] > i) flag2 = false;
	}
	
	if (flag2)
	{
		int ans = 0;
		dp.resize(n, { 0, 0 });
		for (int i = 0; i < n; i++)
		{
			if (used[i]) continue;
			DFS2(i, i);
			ans += max(dp[i].x, dp[i].y);
		}
		cout << ans;
		system("pause");
		return 0;
	}
	



	if (flag)
	{
		cout << (n + 1) / 2;
		system("pause");
		return 0;
	}
	

	int ans = 0;
	// queue<int> q;
	for (int i = 0; i < n; i++)
	{
		if (used[i]) continue;
		if (g[i].size() == 1)
		{
			ans++;
			used[i] = true;
			tmp = *g[i].begin();
			used[tmp] = true;
			for (auto j : g[tmp])
			{
				g[j].erase(tmp);
			}
			i = 0;
			continue;
		}
		if (g[i].size() == 0)
		{
			used[i] = true;
			ans++;
		}
	}

	for (int i = 0; i < n; i++)
	{
		if (used[i]) continue;
		kolvo = 0;
		DFS(i);
		ans += (kolvo / 2);
	}
	cout << ans;
	system("pause");
	return 0;
}



/*
int32_t main()
{
	int mod = 1000000007;
	int n, k;
	cin >> n >> k;
	vector<vector<vector<int>>> dp(5001, vector<vector<int>>(0, vector<int>(2, 0)));
	for (int i = 0; i <= 5001; i++)
	{
		dp[i].resize(i + 1, vector<int>(2, 0));
	}
	vector<vector<vector<int>>> pr(n + 1, vector<vector<int>>(n + 1, vector<int>(2, 0)));
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	for (int i = k; i <= n; i++)
	{
		pr[k][i][0] = 1;
		pr[k][i][1] = 1;
	}
	//dpsumm][last]
	//0 - up
	//1 - down
	if (n == k)
	{
		cout << 1;
		return 0;
	}

	for (int i = k + 1; i <= n; i++)
	{
		for (int j = 1; j < i; j++)
		{
			if (i == k && j == k) continue;
			dp[i][j][0] += pr[i - j][j - 1][1];
			dp[i][j][0] %= mod;
			pr[i][j][0] = pr[i][j - 1][0] + dp[i][j][0];
			pr[i][j][0] %= mod;

			dp[i][j][1] += (pr[i - j][n][0] - pr[i - j][j][0]);
			while (dp[i][j][1] < 0) dp[i][j][1] += mod;
			dp[i][j][1] %= mod;
			pr[i][j][1] = pr[i][j - 1][1] + dp[i][j][1];
			pr[i][j][1] %= mod;
		}
		for (int j = i; j <= n; j++)
		{
			pr[i][j][0] = pr[i][j - 1][0];
			pr[i][j][1] = pr[i][j - 1][1];
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; i++)
	{
		ans += dp[n][i][0];
		ans %= mod;
		ans += dp[n][i][1];
		ans %= mod;
	}
	cout << ans;
	system("pause");
	return 0;
}


*/
/*
int32_t main()
{
int mod = 1000000007;
int n, k;
cin >> n >> k;
vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 1, vector<int>(2, 0)));
dp[k][k][0] = 1;
dp[k][k][1] = 1;
//dpsumm][last]
//0 - up
//1 - down
if (n == k)
{
cout << 1;
return 0;
}

for (int i = k + 1; i <= n; i++)
{
for (int j = 1; j < i; j++)
{
if (i == k && j == k) continue;
for (int l = 1; l < j; l++)
{
dp[i][j][0] += dp[i - j][l][1];
if (dp[i][j][0] >= mod) dp[i][j][0] -= mod;
}
for (int l = j + 1; l < n; l++)
{
dp[i][j][1] += dp[i - j][l][0];
if (dp[i][j][1] >= mod) dp[i][j][1] -= mod;
}
}
}
int ans = 0;
for (int i = 1; i < n; i++)
{
ans += dp[n][i][0] + dp[n][i][1];
ans %= mod;
}
cout << ans;
system("pause");
return 0;
}

*/






/*
vector<int> rmq;

vector<int> a, b;

void build(int v, int l, int r)
{
if (l + 1 == r)
{
rmq[v] = 0;
return;
}
build(v + v, l, (l + r) / 2);
build(v + v + 1, (l + r) / 2, r);
rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

int get(int v, int l, int r, int ind)
{
if (l == ind && l + 1 == r) return rmq[v];
int m = (l + r) / 2;
if (ind < m) return get(v + v, l, m, ind) + rmq[v];
return get(v + v + 1, m, r, ind) + rmq[v];
}


void update(int v, int l, int r, int tl, int tr)
{
if (tl >= tr) return;
if (tl >= r) return;
if (tr <= l) return;
if (tl <= l && tr >= r)
{
rmq[v]++;
return;
}
int m = (l + r) / 2;
if (tr < m) update(v + v, l, m, tl, tr);
else update(v + v + 1, m, r, tl, tr);
}
*/