#include <bits/stdc++.h>
using namespace std;

const int inf = 1000 * 1000 * 1000;

struct node {
    int data, y, size, min;
    node *left, *right;
    vector<int> pos;
    node(int val, vector<int> &p) {
        data = val;
        y = rand();
        size = 1;
        min = inf;
        left = right = nullptr;
        pos.resize(p.size());
        for (int i = 0; i < p.size(); ++i) pos[i] = p[i];
    }
};

int get_size(node *root) {
    if (root == nullptr) return 0;
    return root->size;
}

int get_min(node *root) {
    if (root == nullptr) return inf;
    return root->min;
}

void update(node *root) {
    if (root == nullptr) return;
    root->size = get_size(root->left) + get_size(root->right) + 1;
    if (root->pos.empty()) root->min = inf;
    else root->min = root->pos.back();
    root->min = min(min(get_min(root->left), get_min(root->right)), root->min);
}

node *get_k(node *root, int k) {
    if (root == nullptr) return root;
    if (get_size(root->left) == k - 1) return root;
    if (get_size(root->left) >= k) return get_k(root->left, k);
    return get_k(root->right, k - get_size(root->left) - 1);
}

bool ex(node *root, int val) {
    if (root == nullptr) return false;
    if (root->data == val) return true;
    return ex(root->left, val) || ex(root->right, val);
}

pair<node *, node *> split(node *root, int k) {
    if (root == nullptr) return {nullptr, nullptr};
    if (get_size(root->left) >= k) {
        auto res = split(root->left, k);
        root->left = res.second;
        update(root);
        return {res.first, root};
    }
    auto res = split(root->right, k - get_size(root->left) - 1);
    root->right = res.first;
    update(root);
    return {root, res.second};
}

node *merge(node *root1, node *root2) {
    if (root1 == nullptr) return root2;
    if (root2 == nullptr) return root1;
    if (root1->y <= root2->y) {
        root1->right = merge(root1->right, root2);
        update(root1);
        return root1;
    }
    root2->left = merge(root1, root2->left);
    update(root2);
    return root2;
}

void print(node *root) {
    if (root == nullptr) return;
    print(root->left);
    //cout << root->data << " ";
    for (int i = 0; i < root->pos.size(); ++i) cout << root->pos[i] << " ";
    cout << "\n";
    print(root->right);
}

bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.second < b.second;
}

int solve(node *root, int valmin, int ans) {
    if (root == nullptr)
        return ans;
    if (root->right == nullptr && valmin > (root->pos.empty() ? inf : root->pos.back())) {
        solve(root->right, valmin, ans + 1 + get_size(root->left));
    }
    if (get_min(root->right) > valmin)
        return solve(root->left, valmin, ans + 1);
    else
        return solve(root->right, valmin, ans + 1 + get_size(root->left));
}

void up(node *root) {
    if (root == nullptr) return;
    up(root->left);
    up(root->right);
    if (root->pos.empty()) root->min = min(get_min(root->left), get_min(root->right));
    else root->min = min(min(get_min(root->left), get_min(root->right)), root->pos.back());
}

signed main() {
    //freopen("input.txt", "r", stdin);
    //ios::sync_with_stdio(false);
    //cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    vector<pair<int, int>> b(n);
    for (int i = 0; i < m; ++i) cin >> a[i];
    for (int i = 0; i < m; ++i) --a[i];
    for (int i = 0; i < n; ++i) cin >> b[i].first;
    for (int i = 0; i < n; ++i) --b[i].first;
    for (int i = 0; i < n; ++i) b[i].second = i;
    if (n == m) {
        bool found = false;
        for (int i = 0; i < n; ++i) {
            if (a[i] != b[n - 1 - i].first) {
                found = true;
                break;
            }
        }
        if (!found) {
            cout << n * 2 - 1 << "\n";
            for (int i = 0; i < n * 2 - 1; ++i) cout << n << " ";
            return 0;
        }
    }
    sort(b.begin(), b.end());
    vector<vector<int>> push(n);
    for (int i = m - 1; i >= 0; --i) push[b[a[i]].second].push_back(i);
    sort(b.begin(), b.end(), cmp);
    node *root = nullptr;
    for (int i = 0; i < n; ++i) {
        root = merge(root, new node(b[i].first, push[i]));
    }
    up(root);
    //print(root);
    vector<int> answer;
    for (int i = 0; i < m; ++i) {
        node *temp = get_k(root, 1);
        do {
            //cout << "fjh ";
            int res = 0;
            bool found = false;
            if (temp->pos.empty() || temp->pos.back() != i) res = solve(root, temp->pos.empty() ? inf : temp->pos.back(), 0);
            else {
                res = solve(root, temp->pos.size() <= 1 ? inf : temp->pos[temp->pos.size() - 2], 0);
                if (!root->pos.empty()) temp->pos.pop_back();
                found = true;
            }
//            cout << res << " ";
//            exit(0);
            answer.push_back(res);
            auto res1 = split(root, res);
            auto res2 = split(res1.first, 1);
            root = merge(merge(res2.second, res2.first), res1.second);
            if (found) break;
            temp = get_k(root, 1);
//        } while (!(!temp->pos.empty() && temp->pos.back() != i));
        } while (true);
    }
    cout << answer.size() << "\n";
    for (int i = 0; i < answer.size(); ++i) cout << answer[i] << " ";
    return 0;
}
