#include <iostream>
#include <vector>
#include <set>
#pragma GCC optimize "O3"

using namespace std;

struct node {
    int x, y, sz, mn, v;
    node * left, * right;
    node (int val, int val2) {
        x = val;
        v = val2;
        sz = 1;
        left = right = nullptr;
        y = rand();
    }
};

inline int getSize(node * root) {
    if (root == nullptr) return 0;
    return root -> sz;
}

inline int getMin(node * root) {
    if (root == nullptr) return 1000000000;
    return root -> mn;
}

inline void update(node * root) {
    if (root == nullptr) return;
    root -> sz = getSize(root -> left) + getSize(root -> right) + 1;
    root -> mn = min(getMin(root -> left), min(getMin(root -> right), root -> v));
}

inline node * merge(node * root1, node * root2) {
    if (root1 == nullptr) return root2;
    if (root2 == nullptr) return root1;
    if (root1 -> y < root2 -> y) {
        root1 -> right = merge(root1 -> right, root2);
        update(root1);
        return root1;
    }
    root2 -> left = merge(root1, root2 -> left);
    update(root2);
    return root2;
}

inline pair<node *, node *> split(node * root, int x) {
    if (root == nullptr) return {nullptr, nullptr};
    if (x <= 0) return {nullptr, root};
    if (getSize(root) == x) return {root, nullptr};
    if (getSize(root -> left) >= x) {
        auto res = split(root -> left, x);
        root -> left = res.second;
        update(res.first);
        update(root);
        return {res.first, root};
    }
    auto res = split(root -> right, x - getSize(root -> left) - 1);
    root -> right = res.first;
    update(root);
    update(res.second);
    return {root, res.second};
}

void print(node * root) {
    if (root == nullptr) return;
    print(root -> left);
    cout << root -> x << ' ';
    print(root -> right);
}

inline node * add(node * root, int x, int v, int v1) {
    auto [res1, res2] = split(root, x);
    res1 = merge(res1, new node(v, v1));
    return merge(res1, res2);
}

inline node * cut(node * root, int x) {
    auto[res1, tmp] = split(root, x);
    auto [res2, res3] = split(tmp, 1);
    return merge(res1, res3);
}

inline int first (node * root) {
    if (root == nullptr) return -1;
    if (root -> left != nullptr) return first(root -> left);
    else return root -> x;
}

int main() {
    node * rt = nullptr;
    int n, m, b;
    cin >> n >> m;
    vector<int> ar(n);
    for (int i = 0; i < m; ++i) {
        cin >> ar[i];
        ar[i]--;
    }
    vector<int> cur(n, -1), fr(n, 1000000000);
    for (int i = 0; i < m; ++i) {
        fr[ar[i]] = min(fr[ar[i]], i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> b;
        rt = add(rt, i, b - 1, fr[b - 1]);
        cur[b - 1] = i;
    }
    vector<int> last(n, -1), next(m, -1);
    set<pair<int, int>> qs;
    for (int i = 0; i < m; ++i) {
        qs.insert({ar[i], i});
        if (last[ar[i]] != -1) next[last[ar[i]]] = i;
        last[ar[i]] = i;
    }
    vector<int> ans;
    for (int i = 0; i < m; ++i) {
        if (i == m - 2) cout << n << endl;
        int f = first(rt);
        while (f != ar[i]) {
            rt = cut(rt, 0);
            auto nx = qs.lower_bound({f, i + 1});
            if (nx == qs.end() || nx -> first != f) {
                if (f == first(rt)) {
                    ans.push_back(1);
                    rt = add(rt, 0, f, 1000000000);
                } else {
                    ans.push_back(n);
                    rt = add(rt, n - 1, f, 1000000000);
                }
            } else {
                int l = -1, r = n, mm;
                while (r > l + 1) {
                    mm = (l + r) / 2;
                    auto[res1, res2] = split(rt, mm);
                    if (getMin(res2) > nx->second) r = mm;
                    else l = mm;
                    merge(res1, res2);
                }
                ans.push_back(r + 1);
                rt = add(rt, r, f, nx -> second);
            }
            f = first(rt);
        }
        rt = cut(rt, 0);
        auto nx = qs.lower_bound({ar[f], i + 1});
        if (nx == qs.end() || nx -> first != ar[f]) {
            if (f == first(rt)) {
                ans.push_back(1);
                rt = add(rt, 0, f, 1000000000);
            } else {
                ans.push_back(n);
                rt = add(rt, n - 1, f, 1000000000);
            }
        } else {
            int l = -1, r = n, mm;
            while (r > l + 1) {
                mm = (l + r) / 2;
                if (i == m - 2) cout << l << ' ' << r << ' ' << mm << endl;
                auto[res1, res2] = split(rt, mm);
                if (getMin(res2) > nx->second) r = mm;
                else l = mm;
                merge(res1, res2);
            }
            ans.push_back(r + 1);
            rt = add(rt, r, f, nx -> second);
        }
    }
    cout << ans.size() << endl;
    for (auto i : ans) cout << i << ' ';
    cout << endl;
    return 0;
}
