// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int ll;
typedef long double ld;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

const ll MAX_N = 300001;
const ll BUBEN = 300;

struct Question {
	ll left, right, index;

	Question(ll left, ll right, ll index)
		: left(left), right(right), index(index) {}

	bool operator< (Question other) {
		if (left / BUBEN != other.left / BUBEN) {
			return left < other.left;
		}
		if ((left / BUBEN) % 2 == 0) {
			return right < other.right;
		}
		return right > other.right;
	}
};

ll answer = 0;
ll cnt[MAX_N];

inline void insert(ll x) {
	if (cnt[x] == 0) {
		++answer;
	}
	++cnt[x];
}

inline void erase(ll x) {
	if (cnt[x] == 1) {
		--answer;
	}
	--cnt[x];
}

inline void solve() {
	ll n, m;
	cin >> n >> m;
	vector<ll> a(m);
	vector<ll> b(n);
	for (ll i = 0; i < m; ++i) {
		cin >> a[i];
	}
	for (ll i = 0; i < n; ++i) {
		cin >> b[i];
	}
	reverse(b.begin(), b.end());
	vector<ll> used(n + 1);
	vector<ll> d;
	cnt.resize(n + 1);
	for (ll i = 0; i < m; ++i) {
		if (used[a[i]]) {
			d.emplace_back(a[i]);
		}
		else {
			while (b.back() != a[i]) {
				used[b.back()] = 1;
				d.emplace_back(b.back());
				b.pop_back();
			}
			used[b.back()] = 1;
			d.emplace_back(b.back());
			b.pop_back();
		}
	}
	vector<ll> id(n + 1, -1);
	vector<ll> res(d.size());
	vector<Question> q;
	for (ll i = d.size() - 1; i >= 0; --i) {
		if (id[d[i]] == -1) {
			res[i] = n;
		}
		else {
			q.emplace_back(i, id[d[i]], i);
		}
		id[d[i]] = i;
	}

	sort(q.begin(), q.end());
	ll left = 0;
	ll right = 0;
	for (auto i : q) {
		while (right < i.right) {
			insert(d[right]);
			++right;
		}
		while (left > i.left) {
			--left;
			insert(d[left]);
		}
		while (right > i.right) {
			--right;
			erase(d[right]);
		}
		while (left < i.left) {
			erase(d[left]);
			++left;
		}
		res[i.index] = answer;
	}

	cout << res.size() << endl;
	for (ll i : res) {
		cout << i << " ";
	}
}

int main() {
	start();
	solve();
	return 0;
}
