// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int64_t ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

ll n;
vector<vector<ll>> g;
vector<pair<ll, ll>> dp;
vector<ll> used;
ll need = 1;

void dfs(ll v, ll p) {
	used[v] = need;
	dp[v].first = 0;
	dp[v].second = 1;
	for (ll u : g[v]) {
		if (u == p) {
			continue;
		}
		if (used[u] == need) {
			--dp[v].second;
			continue;
		}
		dfs(u, v);
		dp[v].first += max(dp[u].second, dp[u].first);
		dp[v].second += dp[u].first;
	}
}

inline void solve() {
	cin >> n;
	g.resize(n);
	used.resize(n);
	dp.resize(n);
	for (ll i = 0; i < n; ++i) {
		ll p;
		cin >> p;
		if (p == -1) {
			continue;
		}
		g[p - 1].emplace_back(i);
		g[i].emplace_back(p - 1);
	}
	ll res = 0;
	for (ll i = 0; i < n; ++i) {
		if (used[i]) {
			continue;
		}
		dfs(i, i);
		res += max(dp[i].first, dp[i].second);
	}
	cout << res << endl;
}

int32_t main() {
	start();
	solve();
	return 0;
}
