// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int64_t ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

ll n;
vector<vector<ll>> g;
vector<pair<ll, ll>> dp;
vector<ll> used;
vector<ll> height;
vector<ll> circle;
ll need = 1;

ll add = 0;

void dfs(ll v) {
	used[v] = need;
	dp[v].first = 0;
	dp[v].second = 1;
	for (ll u : g[v]) {
		if (used[u] == need) {
			continue;
		}
		dfs(u);
		dp[v].first += max(dp[u].second, dp[u].first);
		dp[v].second += dp[u].first;
	}
}

ll find_circle(ll v, ll p) {
	height[v] = height[p] + 1;
	for (auto u : g[v]) {
		if (u == p) {
			continue;
		}
		if (height[u]) {
			circle.emplace_back(u);
			circle.emplace_back(v);
			return 1;
		}
		else {
			if (find_circle(u, v)) {
				if (height[circle[0]] < height[v]) {
					circle.emplace_back(v);
				}
				return 1;
			}
		}
	}
}

ll get_res(ll i) {
	circle.clear();
	find_circle(i, i);
	if (circle.empty()) {
		dfs(i);
		return max(dp[i].first, dp[i].second);
	}

}

inline void solve() {
	cin >> n;
	g.resize(n);
	used.resize(n);
	height.resize(n);
	dp.resize(n);
	for (ll i = 0; i < n; ++i) {
		ll p;
		cin >> p;
		if (p == -1) {
			continue;
		}
		g[p - 1].emplace_back(i);
		g[i].emplace_back(p - 1);
	}
	ll res = 0;
	for (ll i = 0; i < n; ++i) {
		if (used[i]) {
			continue;
		}

		dfs(i, i);
		res += max(dp[i].first, dp[i].second);
	}
	cout << res + add / 2 << endl;
}

int32_t main() {
	start();
	solve();
	return 0;
}
