#include <iostream>
#include <vector>

using namespace std;

vector<vector<int> > g;
vector<int> used;
vector<int> cycle;
vector<int> us;

int dfs(int v, int take){
    used[v] = true;
    us.push_back(v);
    int ans = take;
    for (auto i : g[v]){
        if (!used[i]){
            ans += dfs(i, 1 - take);
        }
    }
    return ans;
}

vector<int> p;
int start = -1, fin = -1;
void find_cycle(int v, int pr){
    p[v] = pr;
    for (auto i : g[v]){
        if (i == pr){
            continue;
        }
        if (p[i] != -2 && start == -1){
            start = v;
            fin = i;
            break;
        }else if (p[i] == -2){
            find_cycle(i, v);
        }
    }
}

void reset(){
    for (auto i : us){
        used[i] = false;
    }
    us.resize(0);
}

int solve(){
    for (auto i : cycle){
        used[i] = true;
    }
    vector<vector<int> > sz(cycle.size(), vector<int>(2));
    for (int i = 0; i < cycle.size(); i++){
        sz[i][0] = dfs(i, 0);
        reset();
        sz[i][1] = dfs(i, 1);
        //cout << sz[i][0] << ' ' << sz[i][1] << endl;
        us.resize(0);
    }
    int m = cycle.size();
    int ans = 0;
    for (int i = 0; i < m; i++){
        ans += sz[i][0];
        sz[i][1] -= sz[i][0];
        sz[i][0] = 0;
    }
    int pos = 0;
    vector<int> s(m);
    for (int i = 0; i < m; i++){
        s[i] = sz[i][1];
        if (s[i] < s[pos]){
            pos = i;
        }
    }
    vector<vector<int> > dp(m, vector<int>(2));
    for (int i = 1; i < m; i++){
        dp[i][0] = max(dp[i - 1][0], dp[i - 1][1]);
        dp[i][1] = dp[i - 1][0] + s[i];
    }
    int res1 = max(dp[m - 1][0], dp[m - 1][1]);
    dp.resize(0);
    dp.resize(m, vector<int>(2));
    dp[1][1] = s[0];
    for (int i = 2; i < m - 1; i++){
        dp[i][0] = max(dp[i - 1][0], dp[i - 1][1]);
        dp[i][1] = dp[i - 1][0] + s[i];
    }
    int res2 = max(dp[m - 2][1], dp[m - 2][0]);
    ans += max(res1, res2);
    return ans;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n; i++){
        int x;
        cin >> x;
        x--;
        if (x + 2){
            g[x].push_back(i);
            g[i].push_back(x);
        }
    }
    used.resize(n);
    p.resize(n, -2);
    int ans = 0;
    for (int i = 0; i < n; i++){
        if (start == -1 && p[i] == -2){
            find_cycle(i, -1);
            if (start == -1){
                int mx = dfs(i, 1);
                reset();
                mx = max(mx, dfs(i, 0));
                ans += mx;
            }else{
                cycle.resize(0);
                while (start != fin){
                    cycle.push_back(start);
                    start = p[start];
                }
                cycle.push_back(fin);
                ans += solve();
                start = -1;
                fin = -1;
            }
        }
    }
    cout << ans << endl;
    return 0;
}
