#include <iostream>

using namespace std;
const int mod = 1000000007;

int countUnits(long long k) {
	if (k == 0) {
		return 0;
	}
	if (k % 2 == 0) {
		return countUnits(k / 2);
	}
	if (k % 2 == 1) {
		return countUnits(k / 2) + 1;
	}
}

long long modPow(long long n, int a) {
	long long res = 1;
	n = n % mod;
	for (int i = 0; i < a; i++) {
		res = (res * n) % mod;
	}
	return res;
}

long long f(long long n, long long k) {
	if (k == 0) {
		return 1;
	}
	if (k == 1) {
		return (n + 1) % mod;
	}
	if (n == 1) {
		return (k + 1) % mod;
	}

	long long pred = f(n, k / 2);
	long long res;
	if (k % 2 == 1) {
		res = (pred * (n + 1)) % mod;
	} else {
		long long withLast = modPow(n, countUnits(k));
		long long without = pred - withLast;
		//cout << pred << " " << withLast << " " << without << endl;
		res = (withLast + without * (n + 1)) % mod;
	}
	//cout << "F: " << n << " " << k << " " << res << endl;
	return res;
}

int main() {
	long long n, m, k, nil;
	cin >> n >> m >> k;
	for (int i = 0; i < m; i++) {
		cin >> nil;
		cin >> nil;
	}

	cout << f(n, k) << endl;
	return 0;
}