#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int MOD = 1e9 + 7;

struct SegTree {
	int n;
	vector<int> a;

	SegTree(int n) {
		this->n = n;
		this->a = vector<int>(4 * n, 0);
	}

	int get(int x) {
		return this->get(x, 0, 0, this->n + 1);
	}

	int get(int x, int v, int vl, int vr) {
		if (x >= vr || x < vl) {
			return 0;
		}
		int res = this->a[v];
		if (vr - vl > 1) {
			res = (res + this->get(x, v * 2 + 1, vl, (vl + vr) / 2)) % MOD;
			res = (res + this->get(x, v * 2 + 2, (vl + vr) / 2, vr)) % MOD;
		}
		return res;
	}

	void add(int l, int r, int x) {
		return this->add(l, r, x, 0, 0, this->n + 1);
	}

	void add(int l, int r, int x, int v, int vl, int vr) {
		if (l >= vr || r <= vl) {
			return;
		}
		if (l <= vl && r >= vr) {
			this->a[v] = (this->a[v] + x) % MOD;
		} else {
			this->add(l, r, x, v * 2 + 1, vl, (vl + vr) / 2);
			this->add(l, r, x, v * 2 + 2, (vl + vr) / 2, vr);
		}
	}

};

int main() {
	int n, k;
	cin >> n >> k;
	if (n == k) {
		cout << 1 << endl;
		return 0;
	}
	vector<vector<SegTree>> d(n + 1, vector<SegTree>(2, SegTree(n + 1)));
	d[0][0].add(k, k + 1, 1);
	d[0][1].add(k, k + 1, 1);
	for (int s = k; s < n + 1; ++s) {
		for (int prev = 0; prev < n + 1; ++prev) {
			int last = s - prev;
			d[s][1].add(s + last + 1, n + 1, d[prev][0].get(s));
			d[s][0].add(s + 1, s + min(last, n - s + 1), d[prev][1].get(s));
		}
	}
	int res = 0;
	for (int prev = 0; prev < n + 1; ++prev) {
		res = (res + (d[prev][0].get(n) + d[prev][1].get(n)) % MOD) % MOD;
	}
	cout << res << endl;
	return 0;
}
