#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>

#ifndef LOCAL
#define fprintf if (0) fprintf
#endif

const long long INF = 1e18;

long long sqrt(long long n)
{
    if (n == 0)
        return 1;
    long long l = 0, r = n;
    while (l + 1 < r) {
        long long m = (l + r) / 2;
        if (m * m < n)
            l = m;
        else
            r = m;
    }
    return r;
}

int main(int argc, char const *argv[])
{
    long long k;
    std::cin >> k;

    if (k == 0)
    {
        std::cout << 0 << '\n';
        return 0;
    }

    long long sq = sqrt(std::abs(k));
    fprintf(stderr, "sq = %lld\n", sq);
    long long answ = INF;

    for (long long div1 = -sq; div1 <= sq; ++div1)
    {
        if (div1 == 0)
            continue;
        if (k % div1 == 0)
        {
            long long div2 = k / div1;
            if ((div1 + div2) % 2 == 0 && div1 + div2 >= 0)
                answ = std::min(answ, (div1 + div2) / 2);
        }
    }

    if (answ == INF)
        std::cout << "none" << '\n';
    else
        std::cout << answ << '\n';

    return 0;
}