#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <unordered_set>

#ifndef LOCAL
#define fprintf if (0) fprintf
#endif

void print_vec(const std::vector<int>& v)
{
    for (auto e : v) {
        std::cerr << e << ' ';
    }
    std::cerr << '\n';
}

void unificate(std::vector<int>& items)
{
    std::unordered_set<int> used;
    int to_write = 1;
    used.insert(items.front());
    for (int i = 1; i < items.size(); ++i)
    {
        if (used.find(items[i]) == used.end())
        {
            used.insert(items[i]);
            items[to_write] = items[i];
        }
        else
            --to_write;
        ++to_write;
    }
    items.erase(items.begin() + to_write, items.end());
}

void sort_preparation(std::vector<int>&a, std::vector<int>& order, std::vector<int>& glob_order)
{
    unificate(order);
    std::vector<int> pos(a.size() + 1, -1);
    for (int i = 0; i < order.size(); ++i)
        pos[order[i]] = i + 1;
    int next = *std::max(pos.begin(), pos.end()) + 1;
    for (auto &e : pos) {
        e = (e == -1 ? next : e);
        ++next;
    }
    for (auto &e : a) {
        e = pos[e];
    }
    for (auto &e : glob_order) {
        e = pos[e];
    }
    for (auto &e : order) {
        e = pos[e];
    }
}

/*{
    unificate(order);
    std::vector<int> pos(a.size());
    for (int i = 0; i < a.size(); ++i)
        pos[a[i]] = i + 1;
    for (auto &e : order) {
        e = pos[e];
    }
    for (auto &e : a) {
        e = pos[e];
    }
}*/

int main(int argc, char const *argv[])
{
    int n, m;
    std::cin >> n >> m;
    std::vector<int> b(m);
    for (auto &e : b) {
        std::cin >> e;
    }
    std::vector<int> a(n);
    for (auto &e : a) {
        std::cin >> e;
    }
    std::vector<int> order(b.begin(), b.end());
    sort_preparation(a, order, b);
    //print_vec(a);
    //print_vec(order);
    /*
    int max_prefix = 0;
    while (max_prefix < std::min(a.size(), order.size()) && a[max_prefix] == order[max_prefix]) {
        ++max_prefix;
    }
    order.erase(order.begin(), order.begin() + max_prefix);
    */

    std::unordered_set<int> used_in_ord;
    for (auto e : order) {
        used_in_ord.insert(e);
    }

    std::vector<int> answ;

    int unsorted = n - 1, sorted = 1, unused = 0;
    while (used_in_ord.find(a[unsorted + sorted - 1]) == used_in_ord.end()) {
        ++unused;
        --unsorted;
    }
    while (0 < unsorted && a[unsorted - 1] < a[unsorted]) {
        --unsorted;
        ++sorted;
    }
    while (unsorted > 0) {
        int top = a.front();
        if (used_in_ord.find(top) == used_in_ord.end())
        {
            a.erase(a.begin());
            a.push_back(top);
            --unsorted;
            ++unused;
            answ.push_back(n);
        }
        else
        {
            auto it = std::upper_bound(a.begin() + unsorted, a.begin() + unsorted + sorted, top);
            answ.push_back(std::distance(a.begin(), it));
            a.insert(it, top);
            a.erase(a.begin());
            --unsorted;
            ++sorted;
        }
    }

    int card = 0;
    for (int i = 0; i < m - 1; ++i)
    {
        if (a[card] == b[i + 1])
            answ.push_back(1);
        else
            answ.push_back(n);
    }
    answ.push_back(n);

    std::cout << answ.size() << '\n';
    for (auto e : answ) {
        std::cout << e << ' ';
    }

    return 0;
}