#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>

#ifndef LOCAL
#define fprintf if (0) fprintf
#endif

const long long MOD = 1e9 + 7;
const long long INF = MOD - 1;

void print_dp(const std::vector<std::vector<long long>>& dp)
{
    for (auto &line : dp) {
        for (auto &cell : line) {
            std::cerr << cell << ' ';
        }
        std::cerr << '\n';
    }
}

int main(int argc, char const *argv[])
{
    int n, m, k;
    std::cin >> n >> m >> k;
    std::vector<std::vector<long long>> dp(n, std::vector<long long>(k + 1, 0));
    for (int i = 0; i <= k; ++i)
        dp[0][i] = 1;
    for (int i = 1; i < n; ++i)
    {
        for (int j = 0; j < k + 1; ++j)
        {
            for (int l = 0; l < k + 1; ++l)
            {
                if ((l & j) == l)
                {
                    dp[i][j] += dp[i - 1][l];
                    dp[i][j] %= MOD;
                }
            }
        }
    }
    //print_dp(dp);

    long long answ = 0;
    for (int i = 0; i < k + 1; ++i)
    {
        answ += dp[n - 1][i];
        answ %= MOD;
    }
    std::cout << answ << '\n';
    
    return 0;
}