#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>

#ifndef LOCAL
#define fprintf if (0) fprintf
#endif

const long long MOD = 1e9 + 7;

template<typename Cont>
void print_dp(const Cont& c)
{
    for (const auto &line : c) {
        for (const auto &cell : line) {
            std::cerr << cell << ' ';
        }
        std::cerr << '\n';
    }
}

int main(int argc, char const *argv[])
{
    int n, k;
    std::cin >> n >> k;

    std::vector<std::vector<long long>> dp_up(n + 1, std::vector<long long>(n + 1, 0));
    std::vector<std::vector<long long>> dp_down(n + 1, std::vector<long long>(n + 1, 0));

    dp_up[k][k] = 1;
    dp_down[k][k] = 1;

    for (int s = k + 1; s < n + 1; ++s)
    {
        for (int y = 0; y <= s; ++y)
        {
            {
                for (int x = 0; x < y; ++x)
                {
                    dp_up[s][y] += dp_down[s - y][x];
                    dp_up[s][y] %= MOD;
                }
                for (int x = y + 1; x < n + 1; ++x)
                {
                    dp_down[s][y] += dp_up[s - y][x];
                    dp_down[s][y] %= MOD;
                }
            }
        }
    }
    /*
    std::cerr << "dp_up" << '\n';
    print_dp(dp_up);
    std::cerr << "dp_down" << '\n';
    print_dp(dp_down);
    */
    long long answ = 0;
    for (int i = 0; i < n + 1; ++i)
    {
        answ += dp_up[n][i];
        answ %= MOD;
        answ += dp_down[n][i];
        answ %= MOD;
    }
    if (n == k)
    {
        answ = 1;
    }
    std::cout << answ << '\n';

    return 0;
}