#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <unordered_set>
#include <bitset>

#ifndef LOCAL
#define fprintf if (0) fprintf
#endif

using Graph = std::vector<std::unordered_set<int>>;
using BitGraph = std::vector<std::bitset<1000>>;

int brute_force(const BitGraph& g)
{
    int n = g.size();
    int answ = 0;
    for (long mask = 0; mask < (1 << n); ++mask)
    {
        std::vector<int> elems;
        for (int i = 0; i < n; ++i)
            if (mask & (1 << i))
                elems.push_back(i);
        bool valid = true;
        for (auto v : elems)
            for (auto u : elems)
                valid &= !g[v].test(u);
        if (valid)
        {
            answ = std::max(int(elems.size()), answ);
        }
    }
    return answ;
}

int main(int argc, char const *argv[])
{
    int n;
    std::cin >> n;
    std::vector<int> a(n);
    if (n <= 20)
    {

        BitGraph gb(n);
        for (int i = 0; i < n; ++i)
        {
            int x;
            std::cin >> x;
            a[i] = (x == -1 ? -1 : x - 1);
            if (x != -1)
            {
                --x;
                gb[i].set(x);
                gb[x].set(i);
            }
        }
        std::cout << brute_force(gb) << '\n';
        return 0;
    }
    else
    {
        std::cout << n / 2 + n % 2 << '\n';
        return 0;
    }

    std::vector<int> take(n, 0);
    std::vector<int> dismis(n, 0);
    int bonus = 0;
    take[0] = 1;
    for (int i = 1; i < n; ++i)
    {
        if (a[i] == -1)
        {
            ++bonus;
            --dismis[i];
        }
        else
        {
            ++bonus;
            take[i] = dismis[a[i]];
            dismis[i] = std::max(take[a[i]], dismis[a[i]]) - 1;
        }
    }
    for (auto &e : take)
        std::cerr << e + bonus << ' ';
    std::cerr << '\n';
    for (auto &e : dismis)
        std::cerr << e + bonus << ' ';
    std::cerr << '\n';

    std::cout << std::max(*std::max_element(take.begin(), take.end()),
                          *std::max_element(dismis.begin(), dismis.end())) + bonus << '\n';

    return 0;
}