#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <unordered_set>
#include <bitset>

#ifndef LOCAL
#define fprintf if (0) fprintf
#endif

        enum Color
        {
            BLACK, WHITE
        };
using Graph = std::vector<std::unordered_set<int>>;
using BitGraph = std::vector<std::bitset<1000>>;

int brute_force(const BitGraph& g)
{
    int n = g.size();
    int answ = 0;
    for (long mask = 0; mask < (1 << n); ++mask)
    {
        std::vector<int> elems;
        for (int i = 0; i < n; ++i)
            if (mask & (1 << i))
                elems.push_back(i);
        bool valid = true;
        for (auto v : elems)
            for (auto u : elems)
                valid &= !g[v].test(u);
        if (valid)
        {
            answ = std::max(int(elems.size()), answ);
        }
    }
    return answ;
}

int main(int argc, char const *argv[])
{
    int n;
    std::cin >> n;
    if (n <= 20)
    {

        BitGraph gb(n);
        for (int i = 0; i < n; ++i)
        {
            int x;
            std::cin >> x;
            if (x != -1)
            {
                --x;
                gb[i].set(x);
                gb[x].set(i);
            }
        }
        std::cout << brute_force(gb) << '\n';
        return 0;
    }
    else
    {
        std::vector<int> a(n);
        for (int i = 0; i < n; ++i)
        {
            int x;
            std::cin >> x;
            a[i] = (x == -1 ? -1 : x - 1);
        }
        std::vector<Color> v_color(n);
        v_color[0] = BLACK;
        int black_cnt = 1;
        int white_cnt = 0;
        for (int i = 1; i < n; ++i)
        {
            if (a[i] == -1)
            {
                if (black_cnt > white_cnt)
                {
                    ++black_cnt;
                    v_color[i] = BLACK;
                }
                else
                {
                    ++white_cnt;
                    v_color[i] = WHITE;
                }
            }
            else
            {
                if (v_color[a[i]] == BLACK)
                {
                    v_color[i] = WHITE;
                    ++white_cnt;
                }
                else
                {
                    v_color[i] = BLACK;
                    ++black_cnt;
                }
            }
        }
        std::cout << std::max(black_cnt, white_cnt) << '\n';
        return 0;
    }

    return 0;
}