#pragma GCC optimize("O3")
#include <iostream>
#include <fstream>
#include <utility>
#include <stdio.h>
#include <stdlib.h>
#include <utility>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#define x first
#define y second

using namespace std;

typedef long double ld;

const int N = 3e5 + 10;

int n;
vector<int> adj[N];
set<int> s_adj[N];
vector<vector<int> > comps;
bool used[N];
int ans = 0;

inline void fast() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

inline void dfs(int v) {
    used[v] = 1;
    comps.back().push_back(v);
    for (auto el : adj[v]) {
        if (!used[el]) dfs(el);
    }
}

inline void mw(vector<int> &comp, set<int> &can) {
    for (auto v : comp) {
        can.insert(v);
    }
    set<int> not_can;
    set<int> meow;
    while (1) {
        not_can.clear();
        meow.clear();
        int cnt = 0;
        for (auto v : can) {
            if (s_adj[v].empty()) {
                ++ans;
                meow.insert(v);
                continue;
            }
            if (s_adj[v].size() == 1) {
                ++cnt;
                ++ans;
                meow.insert(v);
                can.erase(*s_adj[v].begin());
                not_can.insert(*s_adj[v].begin());
            }
        }
        for (auto v : meow) can.erase(v);
        if (!cnt) return;
        meow.clear();
        for (auto v : can) {
            for (auto u : s_adj[v]) {
                if (not_can.count(u))
                    meow.insert(u);
            }
            for (auto u : meow) {
                s_adj[v].erase(u);
                s_adj[u].erase(v);
            }
            meow.clear();
        }
    }
}

set<int> sused, dead, can;
int cnt[N];

inline void dfs3(int v) {
    sused.insert(v);
    for (auto u : s_adj[v]) {
        if (!dead.count(u)) ++cnt[v];
    }
    if (cnt[v] > 1) {
        for (auto u : s_adj[v]) {
            if (!sused.count(u)) dfs3(u);
        }
        if (cnt[v] <= 1) {
            if (!dead.count(v)) ++ans;
            dead.insert(v);
            can.erase(v);
        }
        return;
    }
    if (cnt[v] <= 1) {
            bool fl = !dead.count(v);
            if (!dead.count(v)) ++ans;
            dead.insert(v);
            can.erase(v);
            for (auto u : s_adj[v]) {
                if (sused.count(u)) {
                    if (fl) dead.insert(u);
                    cnt[u]--;
                    continue;
                }
                if (fl) dead.insert(u);
                dfs3(u);
            }
            return;
    }
}

inline void mww(vector<int> &comp) {
    for (auto el : comp) can.insert(el);
    for (auto el : comp) {
        if (s_adj[el].empty()) {
            ++ans;
            can.erase(el);
        }
    }
    dfs3(comp[0]);
    for (auto v : can) {
        set<int> meow;
        for (auto u : s_adj[v]) if (!can.count(u)) meow.insert(u);
        for (auto u : meow) s_adj[v].erase(u);
    }
    //cout << "meow" << endl;
}

inline void dfs2(int v, int &ans, bool fl = 0) {
    sused.insert(v);
    if (!dead.count(v)) {
        ++ans;
    }
    for (auto u : s_adj[v]) {
        if (!sused.count(u)) {
            if (!dead.count(v)) dead.insert(u);
        }
    }
    for (auto u : s_adj[v]) {
        if (!sused.count(u)) dfs2(u, ans);
    }
}

inline int get_ans(vector<int> &comp) {
    ans = 0;
    sused.clear();
    dead.clear();
    can.clear();
    mww(comp);
    /*for (auto el : can) {
        cout << el + 1 << " : ";
        for (auto u : s_adj[el]) cout << u + 1 << " ";
        cout << endl;
    }
    for (auto el : dead) cout << el + 1 << " ";
    cout << endl;*/
    if (!can.empty()) {
        sused.clear();
        dfs2(*can.begin(), ans);
    }
    return ans;
}


signed main() {
    fast();
    cin >> n;
    bool is_tree = 1;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x == -1) {
            continue;
        }
        --x;
        if (i == 0 && x == -1) continue;
        if (x != i - 1) is_tree = 0;
        s_adj[i].insert(x);
        s_adj[x].insert(i);
    }
    if (is_tree) {
        cout << (n + 1) / 2;
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        for (auto el : s_adj[i]) {
            adj[i].push_back(el);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            comps.push_back({});
            dfs(i);
        }
    }
    int cur_ans = 0;
    for (auto cmp : comps) {
        cur_ans += get_ans(cmp);
    }
    cout << cur_ans;
}
