#include <iostream>
#include <random>
#include <ctime>
#include <set>

using namespace std;

mt19937 rnd;
uniform_int_distribution <long long> rnd2(1, 10000000000000000);
const int maxM = 1000007;

struct node{
    int cnt, mnuse, use;
    long long y;
    node *left, *right;
    node(int _use, int _y){
        use = _use;
        y = _y;
        mnuse = use;
        cnt = 1;
        left = nullptr;
        right = nullptr;
    }

    void update(){
        mnuse = use;
        cnt = 1;
        if (left != nullptr){
            cnt += left -> cnt;
            mnuse = min(mnuse, left -> mnuse);
        }
        if (right != nullptr){
            cnt += right -> cnt;
            mnuse = min(mnuse, right -> mnuse);
        }
    }

};

int getcnt(node *root){
    if (root == nullptr){
        return 0;
    }
    return root -> cnt;
}

node *merge(node *left, node *right){
    if (left == nullptr){
        return right;
    }
    if (right == nullptr){
        return left;
    }
    if (left -> y > right -> y){
        left -> right = merge(left -> right, right);
        left -> update();
        return left;
    }
    else {
        right -> left = merge(left, right -> left);
        right -> update();
        return right;
    }
}

pair <node*, node*> split(node* root, int ncnt){
    if (root == nullptr){
        return {nullptr, nullptr};
    }
    if (getcnt(root -> left) + 1 <= ncnt){
        auto r = split(root -> right, ncnt - (getcnt(root -> left) + 1));
        root -> right = r.first;
        root -> update();
        return {root, r.second};
    }
    else {
        auto r = split(root -> left, ncnt);
        root -> left = r.second;
        root -> update();
        return  {r.first, root};
    }
}

int getmnuse(node *root){
    if (root == nullptr){
        return maxM;
    }
    return root -> mnuse;
}

vector <int> ans;

node *add(node *root, int use, bool mode = false){
    node* n = new node(use, rnd2(rnd));
    if (!mode){
        root = merge(root, n);
    }
    else {
        int now = 0;
        node* nowrt = root;
        while (nowrt != nullptr){
            if (getmnuse(nowrt -> right) <= use){
                now += getcnt(nowrt -> left) + 1;
                nowrt = nowrt -> right;
            }
            else if (nowrt -> use <= use){
                now += getcnt(nowrt -> left) + 1;
                nowrt = nullptr;
            }
            else{//} if (getmnuse(nowrt -> left) < use){
                nowrt = nowrt -> left;
            }
        }
        ans.push_back(now + 1);
        auto r = split(root, now);
        root = merge(r.first, merge(n, r.second));
    }
    return root;
}

int main() {
    rnd.seed(time(0));
    int n, m;
    cin >> n >> m;
    vector <set <int> > wluse(n);
    for (int i = 0; i < n; i++){
        wluse[i].insert(maxM);
    }
    vector <int> a(m);
    for (int i = 0; i < m; i++){
        int tmp;
        cin >> tmp;
        tmp--;
        a[i] = tmp;
        wluse[tmp].insert(i);
    }
    node* root = nullptr;
    for (int i = 0; i < n; i++){
        /*for (auto c: wluse[i]){
            cout << c << " ";
        }
        cout << endl;*/
        int tmp;
        cin >> tmp;
        tmp--;
        root = add(root, *(wluse[tmp].begin()));
    }
    for (int i = 0; i < m; i++){
        auto tr = split(root, 1);
        while (tr.first -> use != i){
            root = add(tr.second, tr.first -> use, 1);
            tr = split(root, 1);
        }
        wluse[a[i]].erase(wluse[a[i]].begin());
        root = add(tr.second, *(wluse[a[i]].begin()), 1);
    }
    cout << ans.size() << endl;
    for (auto tm: ans){
        cout << tm << " ";
    }
    return 0;
}