#include <iostream>
#include <vector>

using namespace std;

const int inf = 1e9 + 7;

struct node{
    int sum, mod;
    int tl, tr;
    node *left, *right;
    node(){}
    node(int _tl, int _tr, int _sum, node *_left, node *_right){
        mod = 0;
        tl = _tl;
        tr = _tr;
        left = _left;
        right = _right;
        sum = _sum;
    }
    node(int _tl, int _tr, node *_left, node *_right){
        mod = 0;
        tl = _tl;
        tr = _tr;
        left = _left;
        right = _right;
        sum = left -> sum + right -> sum;
    }
};

vector <vector <vector <int> > > dp;
vector <vector <vector <int> > > prevsum;
//vector <vector <vector <bool> > > counted;

node *create(int tl, int tr){
    if (tl + 1 == tr){
        return new node(tl, tr, 0, nullptr, nullptr);
    }
    int mid = (tr + tl) / 2;
    return new node(tl, tr, create(tl, mid), create(mid, tr));
}

void add(node* root, int x, int ind){
    if (root -> tl == ind && root -> tr - 1 == ind){
        root -> sum += x;
        return;
    }
    if (root -> tl > ind || root -> tr <= ind){
        return;
    }
    root -> sum += x;
    root -> sum %= inf;
    add(root -> left, x, ind);
    add(root -> right, x, ind);
}

int get_sum(node* root, int nl, int nr){
    if (root -> tl >= nr || nl >= root -> tr){
        return 0;
    }
    if (nl <= root -> tl && root -> tr <= nr){
        return root -> sum;
    }
    return (get_sum(root -> left, nl, nr) + get_sum(root -> right, nl, nr));
}

int main() {
    int n, k;
    cin >> n >> k;
    if (k == n){
        cout << 1;
        return 0;
    }
    dp.assign(2, vector <vector <int> > (n + 1, vector <int> (n + 1, 0)));
    prevsum.assign(2, vector <vector <int> > (n + 1, vector <int> (n + 2, 0)));
//    counted.assign(2, vector <vector <bool> (n, vector <bool> (n, false)));
    int res = 0;
    dp[0][k][k] = 1;
    dp[1][k][k] = 1;
    prevsum[0][k][k] = 1;
    prevsum[1][k][k] = 1;
    for (int i = k + 1; i <= n; i++){
        for (int j = 1; j <= i; j++){
            if (i - j >= j) {
                dp[1][i][j] = (prevsum[0][i - j][i - j] - prevsum[0][i - j][j] + inf) % inf;
            }
            prevsum[1][i][j] = prevsum[1][i][j - 1] + dp[1][i][j];
            prevsum[1][i][j] %= inf;
            /*for (int j2 = j + 1; j2 < n; j2++){
                dp[1][i][j] += dp[0][i - j][j2];
                dp[1][i][j] %= inf;
            }*/
            dp[0][i][j] = prevsum[1][i - j][min(j - 1, i - j)];
            prevsum[0][i][j] = prevsum[0][i][j - 1] + dp[0][i][j];
            prevsum[0][i][j] %= inf;
            /*for (int j2 = 1; j2 < j; j2++){
                dp[0][i][j] += dp[1][i - j][j2];
                dp[0][i][j] %= inf;
            }*/
        }
    }
    for (int i = 0; i <= n; i++){
        res += dp[0][n][i];
        res %= inf;
//        cout << "0 " << i << " " << dp[0][n][i] << endl;
        res += dp[1][n][i];
        res %= inf;
//        cout << "1 " << i << " " << dp[1][n][i] << endl;
    }
    cout << res;
    return 0;
}