#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <bitset>
#include <vector>
#include <cmath>
#include <ctime>
#include <map>
#include <set>
using namespace std;

struct Node{

    int v = -1, sz = 1, y = rand(), mx = v, it = 1;
    Node* l = nullptr, *r = nullptr;

    Node(){}

    Node(int v):v(v){}

};

Node* merge(Node* a, Node* b){
    if(a==nullptr)
        return b;
    if(b==nullptr)
        return a;
    if((a->y)>(b->y)){
        a->sz += b->sz;
        a->mx = max(a->mx, b->mx);
        a->r = merge(a->r, b);
        return a;
    }
    else{
        b->sz += a->sz;
        b->it += a->sz;
        b->mx = max(a->mx, b->mx);
        b->l = merge(a, b->l);
        return b;
    }
}

pair<Node*, Node*> split(Node* a, int it){
    if(a==nullptr)
        return {nullptr, nullptr};
    if((a->it)<=it){
        a->mx = a->v;
        if(a->l!=nullptr)
            a->mx = max(a->mx, a->l->mx);
        if(a->r!=nullptr)
            a->sz -= a->r->sz;
        pair<Node*, Node*> kek = split(a->r, it-(a->sz));
        a->r = kek.first;
        if(a->r!=nullptr)
            a->sz += a->r->sz;
        if(a->r!=nullptr)
            a->mx = max(a->mx, a->r->mx);
        return {a, kek.second};
    }
    if((a->l)!=nullptr){
        a->sz -= a->l->sz;
        a->it -= a->l->sz;
    }
    a->mx = a->v;
    if(a->r!=nullptr)
        a->mx = max(a->mx, a->r->mx);
    pair<Node*, Node*> kek = split(a->l, it);
    a->l = kek.second;
    if(a->l!=nullptr)
        a->mx = max(a->mx, a->l->mx);
    if(a->l!=nullptr){
        a->sz += a->l->sz;
        a->it += a->l->sz;
    }
    return {kek.first, a};
}

int get(Node* a, int v){
    if(a==nullptr)
        return 0;
    if((a->v)==v)
        return a->it;
    if(a->l==nullptr||(a->l->mx)<v){
        if((a->v)>v){
    //cout << a->it << ' ' << a->v << ':' << v << endl;
            return (a->l==nullptr)?0:a->l->sz;
        }
        else
            return a->it+get(a->r, v);
    }
    return get(a->l, v);
}

vector<int> ans;

void print(Node* a){
    if(a==nullptr)
        return;
    print(a->l);
    cout << a->v << ' ';
    print(a->r);
}

Node* erase(Node* a){
    //cout << a->v << endl;
    pair<Node*, Node*> kek = split(a, 1);
    /*if(kek.first==nullptr)
        cout << "fefsfesf" << endl;
    cout << kek.first->sz << endl;*/
    int cl = get(kek.second, kek.first->v)+1;
    //cout << cl << ' ' << kek.first->v << endl;
    //print(kek.second);
    //cout << endl;
    pair<Node*, Node*> kek1 = split(kek.second, cl-1);
    ans.push_back(cl);
    //cout << cl << endl;
    return merge(merge(kek1.first, kek.first), kek1.second);
}

Node* first(Node* a){
    //cout << a->v << endl;
    if(a->l==nullptr)
        return a;
    return first(a->l);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    map<int, int> check;
    for(int i = 0; i<m; i++)
        cin >> a[i], check[a[i]] = i+1;
    vector<int> b(n);
    for(int i = 0; i<n; i++)
        cin >> b[i];
    bool kek = (check.size()==m);
    if(kek){
        Node *r = nullptr;
        for(int i = 0; i<n; i++){
            if(check[b[i]]==0)
                check[b[i]] = 1000000000;
            r = merge(r, new Node(check[b[i]]));
            //cout << b[i] << ' ' << check[b[i]] << ' ' << r->sz << endl;
        }
        for(int i = 0; i<m; i++){
            //cout << i << endl;
            while((first(r)->v)!=check[a[i]]){
                //cout << i << ' ' << first(r)->v << endl;
                r = erase(r);
                //print(r);
                //cout << endl;
            }
            first(r)->v = 1000000000;
            r = erase(r);
            //print(r);
            //cout << endl;
            //cout << first(r)->v << ':' << check[a[i]] << endl;
        }
        cout << ans.size() << '\n';
        for(int i = 0; i<ans.size(); i++)
            cout << ans[i] << ' ';
        return 0;
    }
    vector<int> ans;
    for(int i = 0; i<m; i++){
        while(b[0]!=a[i]){
            //cout << b[0] << ' ' << a[i] << endl;
            map<int, bool> k;
            for(int j = i; j<m; j++){
                if(a[j]==b[0])
                    break;
                k[a[j]] = false;
            }
            int kek = k.size();
            int it = n;
            for(int j = 1; j<n; j++){
                if(kek==0){
                    it = j;
                    break;
                }
                if(k.find(b[j])!=k.end()&&k[b[j]]==false){
                    kek--;
                    k[b[j]] = true;
                }
                swap(b[j-1], b[j]);
            }
            ans.push_back(it);
            //cout << b[0] << ' ' << b[1] << ' ' << b[2] << ' ' << b[3] << endl;
        }
        map<int, bool> k;
        for(int j = i+1; j<m; j++){
            if(a[j]==b[0])
                break;
            k[a[j]] = false;
        }
        int kek = k.size();
        int it = n;
        for(int j = 1; j<n; j++){
            if(kek==0){
                it = j;
                break;
            }
            if(k.find(b[j])!=k.end()&&k[b[j]]==false){
                kek--;
                k[b[j]] = true;
            }
            swap(b[j-1], b[j]);
        }
        ans.push_back(it);
    }
    cout << ans.size() << '\n';
    for(int i = 0; i<ans.size(); i++)
        cout << ans[i] << ' ';

    return 0;
}
/*
4 5
4 1 2 4 4
4 3 2 1

4 4
1 2 3 4
1 2 3 4

4 4
1 2 3 4
4 3 2 1
*/
