#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <bitset>
#include <vector>
#include <cmath>
#include <ctime>
#include <stack>
#include <queue>
#include <map>
#include <set>
using namespace std;

struct Node{

    int v = -1, sz = 1, y = rand(), mx = v, it = 1;
    Node* l = nullptr, *r = nullptr;

    Node(){}

    Node(int v):v(v){}

};

Node* merge(Node* a, Node* b){
    if(a==nullptr)
        return b;
    if(b==nullptr)
        return a;
    if((a->y)>(b->y)){
        a->sz += b->sz;
        a->mx = min(a->mx, b->mx);
        a->r = merge(a->r, b);
        return a;
    }
    else{
        b->sz += a->sz;
        b->it += a->sz;
        b->mx = min(a->mx, b->mx);
        b->l = merge(a, b->l);
        return b;
    }
}

pair<Node*, Node*> split(Node* a, int it){
    if(a==nullptr)
        return {nullptr, nullptr};
    if((a->it)<=it){
        a->mx = a->v;
        if(a->l!=nullptr)
            a->mx = min(a->mx, a->l->mx);
        if(a->r!=nullptr)
            a->sz -= a->r->sz;
        pair<Node*, Node*> kek = split(a->r, it-(a->sz));
        a->r = kek.first;
        if(a->r!=nullptr)
            a->sz += a->r->sz;
        if(a->r!=nullptr)
            a->mx = min(a->mx, a->r->mx);
        return {a, kek.second};
    }
    if((a->l)!=nullptr){
        a->sz -= a->l->sz;
        a->it -= a->l->sz;
    }
    a->mx = a->v;
    if(a->r!=nullptr)
        a->mx = min(a->mx, a->r->mx);
    pair<Node*, Node*> kek = split(a->l, it);
    a->l = kek.second;
    if(a->l!=nullptr)
        a->mx = min(a->mx, a->l->mx);
    if(a->l!=nullptr){
        a->sz += a->l->sz;
        a->it += a->l->sz;
    }
    return {kek.first, a};
}

int get(Node* a, int v){
    if(a==nullptr)
        return 0;
    //cout << a->v << ' ' << v << endl;
    if(a->r!=nullptr&&a->r->mx<v)
        return a->it+get(a->r, v);
    if(a->v<=v)
        return a->it;
    return get(a->l, v);
}

vector<int> ans;

void print(Node* a){
    if(a==nullptr)
        return;
    print(a->l);
    cout << a->v << ' ';
    print(a->r);
}

Node* erase(Node* a){
    //cout << a->v << endl;
    pair<Node*, Node*> kek = split(a, 1);
    /*if(kek.first==nullptr)
        cout << "fefsfesf" << endl;
    cout << kek.first->sz << endl;*/
    int cl = get(kek.second, kek.first->v)+1;
    //cout << cl << ' ' << kek.first->v << endl;
    //print(kek.second);
    //cout << endl;
    pair<Node*, Node*> kek1 = split(kek.second, cl-1);
    ans.push_back(cl);
    //cout << cl << endl;
    return merge(merge(kek1.first, kek.first), kek1.second);
}

Node* first(Node* a){
    //cout << a->v << endl;
    if(a->l==nullptr)
        return a;
    return first(a->l);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    vector<queue<int> > yu(n+1);
    for(int i = 0; i<m; i++)
        cin >> a[i], yu[a[i]].push(i+1);
    for(int i = 0; i<=n; i++)
        yu[i].push(1000000000);
    vector<int> b(n);
    for(int i = 0; i<n; i++)
        cin >> b[i];
    Node *r = nullptr;
    for(int i = 0; i<n; i++){
        r = merge(r, new Node(yu[b[i]].front()));
        //cout << yu[b[i]].size() << endl;
        //cout << b[i] << ' ' << check[b[i]] << ' ' << r->sz << endl;
    }
    for(int i = 0; i<m; i++){
        //cout << i << endl;
        while((first(r)->v)!=yu[a[i]].front()){
            //cout << yu[a[i]].back() << ' ' << first(r)->v << endl;
            r = erase(r);
            //print(r);
            //cout << endl;
        }
        yu[a[i]].pop();
        first(r)->v = yu[a[i]].front();
        //cout << yu[a[i]].front() << endl;
        r = erase(r);
        //print(r);
        //cout << endl;
        //cout << first(r)->v << ':' << check[a[i]] << endl;
    }
    cout << ans.size() << '\n';
    for(int i = 0; i<ans.size(); i++)
        cout << ans[i] << ' ';
    return 0;
}
/*
4 5
4 1 2 4 4
4 3 2 1

4 4
1 2 3 4
1 2 3 4

4 4
1 2 3 4
4 3 2 1
*/
