#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <fstream>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7;

mt19937_64 MyRand(0);

struct Node {
	Node *l = nullptr, *r = nullptr;
	ll x, y = rand(), size = 1, minvalue;
	pair<ll, ll> value;
	Node(pair<ll, ll> value) :value(value), minvalue(value.first) {}
	void Update() {
		size = 1;
		minvalue = value.first;
		if (l != nullptr) {
			size += l->size;
			minvalue = min(minvalue, l->value.first);
		}
		if (r != nullptr) {
			size += r->size;
			minvalue = min(minvalue, r->value.first);
		}
	}
};

Node* Merge(Node *a, Node *b) {
	if (a == nullptr) return b;
	if (b == nullptr) return a;
	Node *Root = nullptr;
	if (a->y > b->y) {
		Root = a;
		Root->r = Merge(Root->r, b);
	} else {
		Root = b;
		Root->l = Merge(a, Root->l);
	}
	Root->Update();
	return Root;
}

pair<Node *, Node *> Split(Node *Root, ll k) {
	if (Root == nullptr) return{ nullptr, nullptr };
	ll sizeleft = 0;
	if (Root->l != nullptr) sizeleft = Root->l->size;
	if (k > sizeleft) {
		auto splt = Split(Root->r, k - 1 - sizeleft);
		Root->r = splt.first;
		Root->Update();
		return{ Root, splt.second };
	} else {
		auto splt = Split(Root->l, k);
		Root->l = splt.second;
		Root->Update();
		return { splt.first, Root };
	}
}


int main() {
	ll n, m;
	cin >> n;
	cout << n << "\n";
	for (ll i = 0; i < n; i++) cout << n << " ";
}

