#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <utility>
#include <cassert>
#include <ctime>
#include <vector>
#include <deque>

#pragma warning(disable: 4996)

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, const C& b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, const C& b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 3e5 + 7;
const int MAXL = 70;
const ll MOD = 1e9 + 7;

ll Pow(ll n, ll k) {
	if (k == 0) return 1;
	if (k == 1) return n;
	ll res = Pow(n, k / 2);
	res = (res * res) % MOD;
	if (k & 1)
		res = (res * n) % MOD;
	return res;
}

inline ll Inv(ll n) {
	return Pow(n, MOD - 2);
}

ll fact[MAXN];
//ll C[MAXL][MAXL];
ll amNum[MAXL][MAXL];
ll K;

ll C(ll n, ll k) {
	if (k < 0 || k > n) return 0;
	return (((fact[n] * Inv(fact[k])) % MOD)
		* Inv(fact[n - k])) % MOD;
}

bool GetBit(ll n, ll i) {
	return (n >> i) & 1;
}




const int MAXM = 407;

int sep[MAXM];
int amInSep[MAXM];
int toSep[MAXN];
pair<int, int> req[MAXM / 2];

ll d[MAXM][MAXM][MAXL];
ll fin[MAXL];

int main() {
	fact[0] = 1;
	//C[0][0] = 1;
	for (int i = 1; i < MAXN; ++i) {
		fact[i] = (fact[i - 1] * i) % MOD;
		//C[i][0] = 1;
		//for (int j = 1; j < MAXL; ++j) {
		//	C[i][j] = C[i - 1][j] + C[i - 1][j - 1];
		//	if (C[i][j] >= MOD) C[i][j] -= MOD;
		//}
	}


	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m >> K;

	amNum[0][0] = 1;
	for (int len = 1; len < MAXL; ++len) {
		for (int k = 0; k <= len; ++k) {
			bool cbit = GetBit(K, len - 1);
			if (k - cbit >= 0)
				amNum[len][k] = amNum[len - 1][k - cbit];
			if (cbit) {
				amNum[len][k] += C(len - 1, k);
			}
		}
	}
/*
	for (int i = 0; i < m; ++i) {
		cin >> req[i].first >> req[i].second;
		sep[2 * i + 1] = req[i].first;
		sep[2 * i + 2] = req[i].second;
	}
	int nn = 2 * m + 2;
	sep[nn - 1] = n - 1;
	sort(sep, sep + nn);
	nn = unique(sep, sep + nn) - sep;
	for (int i = 0; i < nn - 1; ++i) {
		amInSep[i] = sep[i + 1] - sep[i];
	}
	for (int i = 0; i < nn; ++i) {
		toSep[sep[i]] = i;
	}
	--nn;
	for (int i = 0; i < m; ++i) {
		req[i].first = toSep[req[i].first];
		req[i].second = toSep[req[i].second];
	}

	d[0][0][0] = 1;
	for (int i = 0; i <= nn; ++i) {
		for (int j = i; j < nn; ++j) {
			for (int k = 0; k < MAXL; ++k) {
				for (int ck = 1; ck < MAXL; ++ck) {
					d[j][j + 1][k + ck] += C(amInSep[j], ck) * d[i][j][k];
					d[j][j + 1][k + ck] %= MOD;
				}
				bool canSkip = true;
				for (int q = 0; q < m; ++q) {
					if (req[q].first > i && req[q].second <= j + 1) {
						canSkip = false;
						break;
					}
				}
				if (canSkip) {
					d[i][j + 1][k] += d[i][j][k];
					if (d[i][j + 1][k] >= MOD)
						d[i][j + 1][k] -= MOD;
				}
			}
		}
	}

	for (int i = 0; i <= nn; ++i) {
		for (int k = 0; k < MAXL; ++k) {
			fin[k] += d[i][nn][k];
			if (fin[k] >= MOD)
				fin[k] -= MOD;
		}
	}*/

	ll res = 0;
	for (int ak = 0; ak < MAXL; ++ak) {
		for (int bk = 0; bk + ak < MAXL; ++bk) {
			for (int tk = 0; tk < MAXL; ++tk) {
				int k = ak + bk;
				ll cres = 0;
				for (int q = 0; q < k; ++q) {
					ll ccres = C(tk, q) * Pow(q, ak);
					if (q % 2)
						cres -= ccres % MOD;
					else
						cres += ccres % MOD;
				}
				res += cres * C(k, ak);
			}
		}
	}
	cout << res << '\n';
}

