#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <utility>
#include <cassert>
#include <ctime>
#include <vector>
#include <deque>
#include <bitset>

#pragma warning(disable: 4996)

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, const C& b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, const C& b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 3e5 + 3;

vector<int> g[MAXN];
vector<int> h[MAXN];
int p[MAXN];

int d[2][MAXN];
int d2[MAXN];
bitset<MAXN> used;
bitset<MAXN> used2;

void DFS(int v, bool q, int f) {
	if (used[v]) return;
	used[v] = true;
	vector<int>* adj;
	if (q) {
		adj = h + v;
	} else {
		adj = g + v;
	}
	d[1][v] = 1;
	for (int u : *adj) {
		if (!used[u] && u != f) {
			DFS(u, q, f);
			d[0][v] += d[1][u];
			d[1][v] += d[0][u];
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
		if (p[i] != -1) {
			--p[i];
			g[p[i]].push_back(i);
			h[p[i]].push_back(i);
			h[i].push_back(p[i]);
		}
	}
	int res = 0;
	for (int v = 0; v < n; ++v) {
		if (p[v] != -1 || used[v]) continue;
		DFS(v, 1, -1);
		res += max(d[0][v], d[1][v]);
	}
	for (int v = 0; v < n; ++v) {
		if (used[v]) continue;
		int u = v;
		while (!used2[u]) {
			used2[u] = true;
			u = p[u];
		}
		vector<int> cycle;
		v = u;
		do {
			cycle.push_back(u);
			u = p[u];
		} while (u != v);
		cycle.push_back(v);
		int m = cycle.size() - 1;
		for (int i = 0; i < m; ++i) {
			DFS(cycle[i + 1], 0, cycle[i]);
		}
		d2[0] = 0;
		d2[1] = 0;
		for (int i = 2; i < m - 1; ++i) {
			d2[i] = max(d[0][cycle[i]] + d2[i - 1], d[1][cycle[i]] + d2[i - 2]);
		}
		int cres = d[1][v] + d[0][cycle[1]] + d2[m - 2] + d[0][cycle[m - 1]];
		d2[0] = 0;
		for (int i = 1; i < m; ++i) {
			d2[i] = max(d[0][cycle[i]] + d2[i - 1], d[1][cycle[i]] + d2[max(0, i - 2)]);
		}
		chkmax(cres, d2[m - 1] + d[0][v]);
		res += cres;
	}
	cout << res << '\n';
}

