#include <bitset>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <utility>
#include <cassert>
#include <ctime>
#include <vector>
#include <deque>

#pragma warning(disable: 4996)

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, const C& b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, const C& b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int DEG[7] = { 1, 3, 9, 27, 81, 243, 729 };

int GetDig(int n, int i) {
	return (n / DEG[i]) % 3;
}

const int N = 729;

vector<int> to[2][N];
int g[N][N];
int single[2][N];
int am[2][N];
vector<int> orig[2][N];
int used[2][N];
int t = 1;

void Pair(int v);

void Free(int u) {
	used[1][u] = true;
	int s = to[1][u].size();
	for (int i = 0; i < s; ++i) {
		int v = to[1][u][i];
		if (used[0][v] == t) continue;
		//used[v][u] = t;
		single[1][u] += g[v][u];
		single[0][v] += g[v][u];
		int tmp = g[v][u];
		g[v][u] = 0;
		Pair(v);
		//assert(single[0][v] <= tmp);
		g[v][u] = min(single[0][v], single[1][u]);
		single[0][v] -= g[v][u];
		single[1][u] -= g[v][u];
	}
}

void Pair(int v) {
	used[0][v] = t;
	int s = to[0][v].size();
	for (int i = 0; i < s; ++i) {
		int u = to[0][v][i];
		if (used[1][u] == t) continue;
		//used[v][u] = t;
		Free(u);
		int cres = min(single[0][v], single[1][u]);
		single[0][v] -= cres;
		single[1][u] -= cres;
		g[v][u] += cres;
		if (single[0][v] == 0) {
			used[0][v] = 0;
			return;
		}
	}
}

const int MAXV = 2e5 + 6;
const int MAXK = 7;

pair<int, int> a[MAXK][MAXV];
int pos[MAXV][MAXK];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, k;
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> a[j][i].first;
			a[j][i].second = i;
		}
	}
	for (int j = 0; j < k; ++j) {
		sort(a[j], a[j] + n);
		int r = n / 2;
		int l = r - 1;
		if (a[j][l].first == a[j][r].first) {
			while (r < n && a[j][n / 2].first == a[j][r].first) ++r;
			while (l >= 0 && a[j][n / 2].first == a[j][l].first) --l;
		}
		for (int i = 0; i <= l; ++i) {
			pos[a[j][i].second][j] = 0;
		}
		for (int i = l + 1; i < r; ++i) {
			pos[a[j][i].second][j] = 1;
		}
		for (int i = r; i < n; ++i) {
			pos[a[j][i].second][j] = 2;
		}
	}
	for (int i = 0; i < n; ++i) {
		bool side = pos[i][0] == 2;
		assert(pos[i][0] != 1);
		int gpos = 0;
		for (int j = 1; j < k; ++j) {
			gpos += DEG[j - 1] * pos[i][j];
		}
		orig[side][gpos].push_back(i);
	}
	--k;
	int N = DEG[k];
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < N; ++j) {
			bool connect = true;
			for (int q = 0; q < k; ++q) {
				int d1 = GetDig(i, q);
				int d2 = GetDig(j, q);
				if (d1 == d2 && d1 != 1) {
					connect = false;
					break;
				}
			}
			if (connect) {
				to[0][i].push_back(j);
				to[1][i].push_back(j);
			}
		}
	}
	for (int q = 0; q < 2; ++q) {
		for (int i = 0; i < N; ++i) {
			single[q][i] = am[q][i] = orig[q][i].size();
		}
	}
	for (int i = 0; i < N; ++i) {
		t += 2;
		Pair(i);
		if (single[0][i] != 0) {
			cout << "NO\n";
			return 0;
		}
	}
	cout << "YES\n";
	for (int v = 0; v < N; ++v) {
		for (int u : to[0][v]) {
			int k = g[v][u];
			for (int q = 0; q < k; ++q) {
				int a = orig[0][v].back();
				int b = orig[1][u].back();
				cout << a + 1 << ' ' << b + 1 << '\n';
				orig[0][v].pop_back();
				orig[1][u].pop_back();
			}
		}
	}
	//while (1) ++n;
}

