#include <bitset>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <utility>
#include <cassert>
#include <ctime>
#include <vector>
#include <deque>

#pragma warning(disable: 4996)

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, const C& b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, const C& b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int DEG[7] = { 1, 3, 9, 27, 81, 243, 729 };

int GetDig(int n, int i) {
	return (n / DEG[i]) % 3;
}

const int N = 729;

vector<int> orig[2][N];

const int MAXN = 2e5 + 3;

vector<int> g[MAXN];
int pr[MAXN];
int used[MAXN];
int t = 1;

bool Pair(int v) {
	used[v] = t;
	for (int u : g[v]) {
		if (pr[u] != -1 && used[pr[u]] == t)
			continue;
		if (pr[u] == -1 || Pair(pr[u])) {
			pr[u] = v;
			return true;
		}
	}
	return false;
}

const int MAXV = 2e5 + 6;
const int MAXK = 7;

pair<int, int> a[MAXK][MAXV];
int pos[MAXV][MAXK];

bitset<MAXN> qqq;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, k;
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> a[j][i].first;
			a[j][i].second = i;
		}
	}
	if (k == 1) {
		cout << "YES\n";
	}
	bool cool = true;
	for (int j = 0; j < k; ++j) {
		sort(a[j], a[j] + n);
		int r = n / 2;
		int l = r - 1;
		if (a[j][l].first == a[j][r].first) {
			while (r < n && a[j][n / 2].first == a[j][r].first) ++r;
			while (l >= 0 && a[j][n / 2].first == a[j][l].first) --l;
		}
		for (int i = 0; i <= l; ++i) {
			pos[a[j][i].second][j] = 0;
		}
		for (int i = l + 1; i < r; ++i) {
			pos[a[j][i].second][j] = 1;
			cool = false;
		}
		for (int i = r; i < n; ++i) {
			pos[a[j][i].second][j] = 2;
		}
		if (k == 1) {
			for (int i = 0; i < n / 2; ++i) {
				cout << a[j][i].second + 1 << ' ' << a[j][i + n / 2].second + 1 << '\n';
			}
			return 0;
		}
	}
	for (int i = 0; i < n; ++i) {
		pr[i] = -1;
		bool side = pos[i][0] == 2;
		assert(pos[i][0] != 1);
		int gpos = 0;
		for (int j = 1; j < k; ++j) {
			gpos += DEG[j - 1] * pos[i][j];
		}
		orig[side][gpos].push_back(i);
	}
	--k;
	int N = DEG[k];
	vector<pair<int, int>> res;
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < N; ++j) {
			bool connect = true;
			for (int q = 0; q < k; ++q) {
				int d1 = GetDig(i, q);
				int d2 = GetDig(j, q);
				if (d1 == d2 && d1 != 1) {
					connect = false;
					break;
				}
			}
			if (connect) {
				if (n <= 457) {
					for (int v : orig[0][i]) {
						for (int u : orig[1][j]) {
							g[v].push_back(u);
						}
					}
				} else if (cool) {
					if (orig[0][i].size() != orig[1][j].size()) {
						cout << "NO\n";
						return 0;
					} else {
						int s = orig[0][i].size();
						if (i < j || i == j && !qqq[i])
							for (int q = 0; q < s; ++q) {
								res.push_back(make_pair(orig[0][i][q], orig[1][j][q]));
							}
						if (i == j) qqq[i] = true;
					}
				}
			}
		}
	}
	if (cool) {
		cout << "YES\n";
		for (auto c : res) {
			cout << c.first + 1 << ' ' << c.second + 1 << '\n';
		}
		return 0;
	}
	for (int i = 0; i < n; ++i) {
		if (pos[i][0] == 2) continue;
		++t;
		if (!Pair(i)) {
			cout << "NO\n";
			return 0;
		}
	}
	cout << "YES\n";
	for (int v = 0; v < n; ++v) {
		if (pos[v][0] != 2) continue;
		cout << v + 1 << ' ' << pr[v] + 1 << '\n';
	}
	//while (1) ++n;
}

