#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>


#define ll long long
#define pii pair<ll, ll>
#define x first
#define y second
#define ld long double

using namespace std;

const ll NMAX = 211111;
const ll inf = 2e18;
const ll M = 1e9 + 7;

ll a[NMAX][10];
ll c[NMAX];
ll b[10];

ll cnt[NMAX];
vector<ll> dop[NMAX];
ll ptr[NMAX];

struct edge
{
	ll u, v;
	ll f, c;
	edge * e;
} e[511111];

edge * ls = e;

pair<edge *, edge * > nedge(ll u, ll v, ll c)
{
	ls->c = c;
	ls->f = 0;
	ls->u = u;
	ls->v = v;
	ls->e = ls + 1;
	ls++;
	ls->c = 0;
	ls->f = 0;
	ls->u = v;
	ls->v = u;
	ls->e = ls - 1;
	ls++;
	return { ls - 2, ls - 1 };
}

vector<edge *> g[NMAX];

ll pw3(ll n)
{
	if (n == 0)
		return 1;
	else if (n % 2 == 0)
	{
		ll x = pw3(n / 2);
		return x * x;
	}
	else
		return pw3(n - 1) * 3;
}

ll used[NMAX];
ll tm = 1;

ll dfs(ll v, ll f, ll cur)
{
	if (v == f)
	{
		return cur;
	}
	used[v] = tm;
	for (auto u : g[v])
	{
		if (used[u->v] != tm && u->c > u->f)
		{
			ll a = dfs(u->v, f, min(cur, u->c - u->f));
			if (a != 0)
			{
				u->f += a;
				u->e->f -= a;
				return a;
			}
		}
	}
	return 0;
}

vector<pii> ans;

signed main()
{
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cout.precision(10);
	ll n, k;
	cin >> n >> k;
	for (ll i = 1; i <= n; i++)
	{
		for (ll j = 0; j < k; j++)
		{
			cin >> a[i][j];
			a[i][j] *= 2;
		}
	}
	for (ll j = 0; j < k; j++)
	{
		for (ll i = 1; i <= n; i++)
			c[i] = a[i][j];
		sort(c + 1, c + n + 1);
		ll q = n / 2;
		if (c[q] == c[q + 1])
			b[j] = c[q];
		else
			b[j] = (c[q] + c[q + 1]) / 2;
	}

	ll st = pw3(k - 1);
	ll fn = pw3(k);

	for (ll i = 1; i <= n; i++)
	{
		ll cur = 0;
		for (ll j = 0; j < k; j++)
		{
			cur *= 3;
			if (a[i][j] > b[j])
				cur += 2;
			else if (a[i][j] == b[j])
				cur += 1;
		}
		cnt[cur]++;
		dop[cur].push_back(i);
	}

	for (ll i = 0; i < pw3(k - 1); i++)
	{
		auto w = nedge(st, i, cnt[i]);
		g[st].push_back(w.first);
		g[i].push_back(w.second);


		ll cur = i + pw3(k - 1) * 2;
		w = nedge(cur, fn, cnt[cur]);
		g[cur].push_back(w.first);
		g[fn].push_back(w.second);
	}

	for (ll i = 0; i < pw3(k - 1); i++)
	{
		for (ll j = pw3(k - 1) * 2; j < pw3(k - 1) * 3; j++)
		{
			ll a = i;
			ll b = j;
			pair<edge *, edge *> w;
			for (ll q = 0; q < k; q++)
			{
				ll x = a % 3;
				ll y = b % 3;
				if (x == 0 && y == 0 || x == 2 && y == 2)
					goto lab;
				a /= 3;
				b /= 3;
			}
			w = nedge(i, j, inf);
			g[i].push_back(w.first);
			g[j].push_back(w.second);
		lab:
			;
		}
	}

	while (dfs(st, fn, inf))
	{
		tm++;
	}
	ll res = 0;
	for (auto u : g[st])
	{
		res += u->f;
	}
	if (res * 2 != n)
	{
		cout << "NO" << endl;
		return 0;
	}

	for (ll i = 0; i < pw3(k - 1); i++)
	{
		for (auto e : g[i])
		{
			while (e->f > 0)
			{
				ans.push_back({ dop[i][ptr[i]++], dop[e->v][ptr[e->v]++] });
				e->f--;
			}
		}
	}

	cout << "YES" << endl;
	
	for (auto u : ans)
		cout << u.x << ' ' << u.y << endl;

	return 0;
}