#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

bool kuhn(int v, vector<set<int> > &gr, vector<int> &par, vector<bool> &Is)
{
    if (Is[v]) return false;
    Is[v] = true;
    for (auto i:gr[v]){
        if (par[v]==i) continue;
        if (par[i]==-1 || kuhn(par[i], gr, par, Is)){
            if (par[v]!=-1) par[par[v]] = -1;
            par[i] = v;
            if (par[v]!=-1){
                par[par[v]] = -1;
                kuhn(par[v], gr, par, Is);
            }
            par[v] = i;
            return true;
        }
    }
    return false;
}

int main()
{
    int n;
    cin >> n;
    vector<set<int> > A(n);
    vector<int> sp(n), B(n, -1);
    for (int i=0; i<n; i++){
        int a;
        cin >> a;
        sp[i] = a;
        if (a!=-1){
            A[i].insert(a-1);
            A[a-1].insert(i);
        }
    }
    for (int i=0; i<n; i++){
        vector<bool> Is(n);
        kuhn(i, A, B, Is);
    }
    int ans = 0, len = n;
    for (int i=0; i<n; i++){
        if (sp[i]==-1){
            len--;
        }
    }
    bool q = false;
    int ma_len = 0;
    for (int i=0; i<n; i++){
        int l = 1, y = i;
        set<int> U;
        U.insert(i);
        while (sp[y]!=-1 && U.find(sp[y]-1)==U.end()){
            y = sp[y]-1;
            U.insert(y);
            l++;
        }
        if (i==sp[y]-1 && ma_len<l){
            q = (l%2==1);
            ma_len = max(ma_len, l);
        }
        if (i!=sp[y]-1 && sp[y]!=-1 && ma_len<l){
            q = (l%2==1);
            ma_len = max(ma_len, l);
        }

    }
    for (int i=0; i<n; i++){
        if (B[i]!=-1) ans++;
    }
    cout << n-ans/2-q << endl;
}

