#include <bits/stdc++.h>

#ifdef AAA_LOCAL_EXECUTION
    #define db(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbs(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;35m" << x << "\x1b[0m" <<  endl;
    #define dbsx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;35m" << x << "\x1b[0m" << endl;
#else
    #define db(x)
    #define dbx(x)
    #define dbs(x)
    #define dbsx(x)
#endif

using namespace std;

using ll = long long;

const ll MOD = 1'000'000'007;


template <typename T>
ostream& operator<<(ostream& s, const vector<T>& v)
{
    for (auto& i : v) {
        s << i << "\t";
    }
    return s;
}


template <typename T, typename U>
ostream& operator<<(ostream& s, const pair<T, U>& p)
{
    s << "[" << p.first << "," << p.second << "]";
    return s;
}


void dfs(vector<vector<ll>>& g, vector<ll>& colors, vector<int>& used, ll root)
{
    if (used[root]) {
        return;
    }

    used[root] = 1;

    ll n = (ll)colors.size();
    vector<int> used_colors(n, 0);
    for (auto& to : g[root]) {
        if (colors[to] != -1) {
            used_colors[colors[to]] = 1;
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (!used_colors[i]) {
            colors[root] = i;
            break;
        }
    }
    for (auto& to : g[root]) {
        dfs(g, colors, used, to);
    }
}


ll max_count(const vector<ll>& v)
{
    unordered_map<ll, ll> count;
    for (auto& i : v) {
        if (i >= 0) {
            if (count.count(i) == 0) {
                count.emplace(i, 0);
            }
            count.at(i)++;
        }
    }
    
    ll max_count = 0;
    for (auto [c, n] : count) {
        max_count = max(max_count, n);
    }
    return max_count;
}


bool bit(ll a, ll n) {
    if (n < 0) {
        return 0;
    }
    return (a & (1 << n)) != 0;
}


pair<ll, ll> tree_dfs(const vector<vector<ll>>& ch, bool parity, ll root = 0)
{
    if (ch[root].empty()) {
        return parity ? make_pair(1LL, 0LL) : make_pair(0LL, 1LL);
    }

    ll sum1 = 0, sum2 = 0;
    for (ll child : ch[root]) {
        auto [a, b] = tree_dfs(ch, !parity, child);
        sum1 += a;
        sum2 += b;
    }
    if (parity) {
        sum1++;
    } else {
        sum2++;
    }
    return {sum1, sum2};
}


int main()
{
    ll n;
    cin >> n;
    vector<pair<ll, ll>> a;
    vector<vector<ll>> ch(n);
    for (ll i = 0; i < n; ++i) {
        ll t;
        cin >> t;
        if (t == -1) {
            continue;
        }
        --t;
        a.emplace_back(i, t);
        if (n > 20) {
            assert(t < i);
        }
        ch[t].push_back(i);
    }

    auto can = [&a](ll mask) -> bool {
        for (auto [p, q] : a) {
            dbx(p);
            dbx(q);
            if (bit(mask, p) && bit(mask, q)) {
                return false;
            }
        }
        return true;
    };

    if (n <= 20) {
        ll maxcount = 0;
        for (ll mask = 0; mask < (1 << n); ++mask) {
            db(mask);

            if (can(mask)) {
                dbs("can(mask)");
                maxcount = max<ll>(maxcount, __builtin_popcount(mask));
            }
        }
        cout << maxcount << endl;
        return 0;
    }

    auto [p, q] = tree_dfs(ch, false);
    cout << max(p, q) << endl;
}
