#include <bits/stdc++.h>

#ifdef AAA_LOCAL_EXECUTION
    #define db(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbs(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;35m" << x << "\x1b[0m" <<  endl;
    #define dbsx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;35m" << x << "\x1b[0m" << endl;
#else
    #define db(x)
    #define dbx(x)
    #define dbs(x)
    #define dbsx(x)
#endif

using namespace std;

using ll = long long;

const ll MOD = 1'000'000'007;


template <typename T>
ostream& operator<<(ostream& s, const vector<T>& v)
{
    for (auto& i : v) {
        s << i << "\t";
    }
    return s;
}


template <typename T, typename U>
ostream& operator<<(ostream& s, const pair<T, U>& p)
{
    s << "[" << p.first << "," << p.second << "]";
    return s;
}


void dfs(vector<vector<ll>>& g, vector<ll>& colors, vector<int>& used, ll root)
{
    if (used[root]) {
        return;
    }

    used[root] = 1;

    ll n = (ll)colors.size();
    vector<int> used_colors(n, 0);
    for (auto& to : g[root]) {
        if (colors[to] != -1) {
            used_colors[colors[to]] = 1;
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (!used_colors[i]) {
            colors[root] = i;
            break;
        }
    }
    for (auto& to : g[root]) {
        dfs(g, colors, used, to);
    }
}


ll max_count(const vector<ll>& v)
{
    unordered_map<ll, ll> count;
    for (auto& i : v) {
        if (i >= 0) {
            if (count.count(i) == 0) {
                count.emplace(i, 0);
            }
            count.at(i)++;
        }
    }
    
    ll max_count = 0;
    for (auto [c, n] : count) {
        max_count = max(max_count, n);
    }
    return max_count;
}


bool bit(ll a, ll n) {
    if (n < 0) {
        return 0;
    }
    return (a & (1 << n)) != 0;
}

ll gcount = 0;

bool tree_dfs(const vector<vector<ll>>& ch, ll root = 0)
{
    if (ch[root].empty()) {
        ++gcount;
        return true;
    }

    bool okval = true;
    for (ll child : ch[root]) {
        if (tree_dfs(ch, child)) {
            okval = false;
        }
    }
    if (!okval) {
        return false;
    }

    ++gcount;
    return true;
}

/*
bool operator<(const vector<ll>& a, const vector<ll>& b)
{
    for (ll i = 0; i < (ll)min(a.size(), b.size()); ++i) {
        if (a[i] < b[i]) {
            return true;
        } else if (a[i] > b[i]) {
            return false;
        }
    }
    if (a.size() < b.size()) {
        return true;
    }
    return false;
}
*/

int main()
{
    ios_base::sync_with_stdio(false);
    ll n, k;
    cin >> n >> k;

    vector<pair<vector<ll>, ll>> a(n, {vector<ll>(k), 0});

    for (ll i = 0; i < n; ++i) {
        for (auto& j : a[i].first) {
            cin >> j;
        }
        a[i].second = i + 1;
    }

    sort(a.begin(), a.end());

    do {
        //vector<pair<pair<vector<ll>, ll>, pair<vector<ll>, ll>>> v;
        vector<ll> min_bound (k, -999'999'999);
        vector<ll> max_bound (k, 999'999'999);

        for (ll j = 0; j < n/2; ++j) {
            const auto& p = a[2*j];
            const auto& q = a[2*j+1];
            for (ll i = 0; i < k; ++i) {
                min_bound[i] = max(min_bound[i], min(p.first[i], q.first[i]));
                max_bound[i] = min(max_bound[i], max(p.first[i], q.first[i]));
            }
        }
        bool can = true;
        for (ll i = 0; i < k; ++i) {
            if (max_bound[i] < min_bound[i]) {
                can = false;
                break;
            }
        }
        if (can) {
            cout << "YES" << endl;
            for (ll j = 0; j < n/2; ++j) {
                const auto& p = a[2*j];
                const auto& q = a[2*j+1];
                cout << p.second << ' ' << q.second << endl;
            }
            return 0;
        }
    } while (next_permutation(a.begin(), a.end()));
    cout << "NO" << endl;
}
