#include <iostream>
#include <unistd.h>

using namespace std;

typedef long int i64;
typedef long unsigned int u64;
typedef int i32;
typedef unsigned int u32;

i64 sqrt(i64 n) {
    if (n == 0) {
        return 0;
    }
    i64 a = n;
    for (int _ = 0; _ < 64; _++) {
        a = (a + n / a) / 2;
    }
    while (a * a > n) {
        a--;
    }
    return a;
}

i64 sqr(i64 n) {
    return n * n;
}

bool is_sqr(i64 n) {
    return (n >= 0) && (sqr(sqrt(n)) == n);
}

int main() {
    i64 k;
    cin >> k;
    if (is_sqr(k)) {
        cout << sqrt(k) << endl;
    } else if (k > 0) {
        i64 sq = sqrt(k);
        for (int i = sq; i > 0; i--) {
            if (k % i == 0) {
                i64 a = i;
                i64 b = k / i;
                if (k % b == 0 && (a + b) % 2 == 0) {
                    cout << (a + b) / 2 << endl;
                    return 0;
                }
            }
        }
        cout << "none" << endl;
    } else {
        i64 t = sqrt(sqr((-k + 1) / 2) + k);
        if (sqrt(-k) >= t) {
            cout << sqrt(sqr((-k + 1) / 2) + k) << endl;
        } else {
            cout << "none" << endl;
        }
    }
}
