// D.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <array>
#include <algorithm>

using namespace std;
using ll = long long;

bool eq(vector<int>& elem1, vector<int>& elem2) {
	for (int i = 0; i < (int)elem1.size(); i++) {
		if (elem1[i] == 2 || elem2[i] == 2) continue;
		if (elem1[i] == elem2[i]) return 0;
	}
	return 1;
}

bool dfs(int u, vector<vector<int> > &g, vector<bool>& used, vector<int>& ans) {
	used[u] = 1;
	for (int v : g[u]) {
		if (ans[v] == -1 || (!used[ans[v]] && dfs(ans[v], g, used, ans))) {
			ans[v] = u;
			return true;
		}
	}
	return false;
}

int main()
{
	ios::sync_with_stdio(0);
	int n, k;
	cin >> n >> k;
	vector<vector<int> > a(n, vector<int>(k));
	vector<vector<pair<int, int> > > ind(k);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			int x;
			cin >> x;
			ind[j].push_back({ x, i });
		}
	}
	for (int j = 0; j < k; j++) {
		nth_element(ind[j].begin(), ind[j].begin() + n / 2, ind[j].end());
		int cur1 = ind[j][n / 2].first;
		nth_element(ind[j].begin(), ind[j].begin() + n / 2 - 1, ind[j].end());
		int cur2 = ind[j][n / 2 - 1].first;
		for (int i = 0; i < n; i++) {
			if (cur1 == cur2 && ind[j][i].first == cur1) a[ind[j][i].second][j] = 2;
			else {
				if (ind[j][i].first < cur1) a[ind[j][i].second][j] = 0;
				else a[ind[j][i].second][j] = 1;
			}
		}
	}
	if (n <= 500) {
		vector<int> left, right;
		for (int i = 0; i < n; i++) {
			if (a[i][0] == 0) left.push_back(i);
			else right.push_back(i);
		}
		vector<vector<int> > g(n);
		for (int i = 0; i < (int)left.size(); i++) {
			for (int j = 0; j < (int)right.size(); j++) {
				if (eq(a[left[i]], a[right[j]])) g[i].push_back(j);
			}
		}
		vector<bool> used(n);
		vector<int> ans(n, -1);
		int all = 0;
		for (int i = 0; i < (int)left.size(); i++) {
			if (dfs(i, g, used, ans)) {
				used.assign(n, false);
				all++;
			}
		}
		if (all != n / 2) {
			cout << "NO" << endl;
			return 0;
		}
		cout << "YES" << endl;
		for (int i = 0; i < (int)right.size(); i++) {
			cout << left[ans[i]] + 1 << ' ' << right[i] + 1 << '\n';
		}
	}
	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			cout << a[i][j] << ' ';
		}
		cout << endl;
	}*/
	else {
		int sz = (1 << k);
		vector<vector<int> > cnt(sz);
		for (int i = 0; i < n; i++) {
			int cur = 0;
			for (int j = 0; j < k; j++) {
				cur = cur * 2 + a[i][j];
			}
			cnt[cur].push_back(i);
		}
		bool ok = 1;
		for (int i = 0; i < sz; i++) {
			if (cnt[i].size() != cnt[(sz - 1) ^ i].size()) {
				ok = 0;
				break;
			}
		}
		if (!ok) {
			cout << "NO" << endl;
			return 0;
		}
		cout << "YES" << endl;
		for (int i = 0; i < sz; i++) {
			if (i > ((sz - 1) ^ i)) continue;
			auto elem1 = cnt[i], elem2 = cnt[(sz - 1) ^ i];
			for (int j = 0; j < (int)elem1.size(); j++) {
				cout << elem1[j] + 1 << ' ' << elem2[j] + 1 << endl;
			}
		}
	}
	return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
