// D.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <array>
#include <cmath>
#include <algorithm>

using namespace std;
using ll = long long;

bool eq(int elem1, int elem2, int k, bool inv) {
	vector<int> a1, a2;
	for (int i = 0; i < k; i++) {
		a1.push_back(elem1 % 3);
		elem1 /= 3;
	}
	for (int i = 0; i < k; i++) {
		a2.push_back(elem2 % 2);
		elem2 /= 2;
	}
	for (int i = 0; i < k; i++) {
		if (a1[i] != 2 && ((a2[i] != a1[i]) ^ inv)) {
			return 0;
		}
	}
	return 1;
}

/*bool dfs(int u, vector<vector<int> > &g, vector<bool>& used, vector<int>& ans) {
	used[u] = 1;
	for (int v : g[u]) {
		if (ans[v] == -1 || (!used[ans[v]] && dfs(ans[v], g, used, ans))) {
			ans[v] = u;
			return true;
		}
	}
	return false;
}*/

struct edge {
	int u = -1, v = -1;
	int flow = 0;
	int p = 0;
};

vector<edge> edges;
vector<vector<int> > g;
vector<int> d;
vector<bool> used;

void add_edge(int u, int v, int p) {
	edges.push_back({ u, v, 0, p });
	g[u].push_back((int)edges.size() - 1);
	edges.push_back({ v, u, 0, 0 });
	g[v].push_back((int)edges.size() - 1);
}

bool bfs(int start, int fin) {
	d.assign(g.size(), 1e9);
	d[start] = 0;
	vector<int> q;
	q.push_back(start);
	for (int i = 0; i < (int)q.size(); i++) {
		int u = q[i];
		for (int ind : g[u]) {
			int v = edges[ind].v;
			if (edges[ind].flow == edges[ind].p) continue;
			if (d[v] > d[u] + 1) {
				d[v] = d[u] + 1;
				q.push_back(v);
			}
		}
	}
	return d[fin] != 1e9;
}

int dfs(int u, int fin, int cur_min) {
	if (u == fin) {
		return cur_min;
	}
	used[u] = 1;
	for (int ind : g[u]) {
		int v = edges[ind].v, f = edges[ind].flow, p = edges[ind].p;
		if (!used[v] && f != p && d[v] == d[u] + 1) {
			int to = dfs(v, fin, min(cur_min, p - f));
			if (to != -1e9) {
				edges[ind].flow += to;
				edges[ind ^ 1].flow -= to;
				return to;
			}
		}
	}
	return -1e9;
}

int main()
{
	ios::sync_with_stdio(0);
	int n, k;
	cin >> n >> k;
	vector<vector<int> > a(n, vector<int>(k));
	vector<vector<pair<int, int> > > ind(k);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			int x;
			cin >> x;
			ind[j].push_back({ x, i });
		}
	}
	for (int j = 0; j < k; j++) {
		nth_element(ind[j].begin(), ind[j].begin() + n / 2, ind[j].end());
		int cur1 = ind[j][n / 2].first;
		nth_element(ind[j].begin(), ind[j].begin() + n / 2 - 1, ind[j].end());
		int cur2 = ind[j][n / 2 - 1].first;
		for (int i = 0; i < n; i++) {
			if (cur1 == cur2 && ind[j][i].first == cur1) a[ind[j][i].second][j] = 2;
			else {
				if (ind[j][i].first < cur1) a[ind[j][i].second][j] = 0;
				else a[ind[j][i].second][j] = 1;
			}
		}
	}
	if (true) {
		/*vector<int> left, right;
		for (int i = 0; i < n; i++) {
			if (a[i][0] == 0) left.push_back(i);
			else right.push_back(i);
		}*/
		/*vector<pair<int, int> > a1(n);
		for (int i = 0; i < n; i++) {
			int cur1 = 0, cur2 = 0;
			for (int j = 0; j < k; j++) {
				cur1 = 2 * cur1 + (a[i][j] % 2);
				cur2 = 2 * cur2 + int(a[i][j] == 2);
			}
			a1[i] = { cur1, cur2 };
		}*/
		int sz3 = (int)pow(3, k), sz2 = (1 << k);
		vector<vector<int> > all(sz3);
		for (int i = 0; i < n; i++) {
			int cur = 0;
			for (int j = 0; j < k; j++) {
				cur = 3 * cur + a[i][j];
			}
			all[cur].push_back(i);
		}
		g.resize(sz3 + sz2 + 2);
		for (int i = 0; i < sz3; i++) {
			if (i < sz3 / 3) {
				add_edge(sz3 + sz2, i, (int)all[i].size());
				//cout << "adding " << sz3 + sz2 << ' ' << i << ' ' << (int)all[i].size() << endl;
				for (int j = 0; j < sz2; j++) {
					if (eq(i, j, k, 0)) {
						add_edge(i, sz3 + j, 1e6);
						//cout << "adding " << i << ' ' << j + sz3 << endl;
					}
				}
			}
			else if (i < 2 * sz3 / 3) {
				add_edge(i, sz3 + sz2 + 1, (int)all[i].size());
				//cout << "adding " << i << ' ' << sz3 + sz2 + 1 << ' ' << (int)all[i].size() << endl;
				for (int j = 0; j < sz2; j++) {
					if (eq(i, j, k, 1)) {
						add_edge(sz3 + j, i, 1e6);
						//cout << "adding " << j + sz3 << ' ' << i << endl;
					}
				}
			}
		}
		used.assign(sz2 + sz3 + 2, 0);
		int start = sz3 + sz2, fin = sz3 + sz2 + 1;
		while (bfs(start, fin)) {
			//cout << "KEK" << endl;
			used.assign(sz3 + sz2 + 2, 0);
			while (dfs(start, fin, 1e9) != -1e9) {
				//cout << "LOL" << endl;
			}
		}
		/*for (int i = 0; i < (int)edges.size(); i++) {
			cout << edges[i].flow << ' ' << edges[i].p << endl;
		}*/
		int max_flow = 0;
		for (int ind : g[start]) {
			max_flow += edges[ind].flow;
		}
		//cout << max_flow << endl;
		if (max_flow != n / 2) {
			cout << "NO" << endl;
			return 0;
		}
		cout << "YES" << endl;
		vector<vector<int> > f1(sz2), f2(sz2);
		for (int i = 0; i < sz3; i++) {
			if (i < sz3 / 3) {
				int j = 0;
				for (int ind : g[i]) {
					for (int t = 0; t < (int)edges[ind].flow; t++) {
						f1[edges[ind].v - sz3].push_back(all[i][j]);
						j++;
					}
				}
			}
			else {
				int j = 0;
				for (int ind : g[i]) {
					for (int t = 0; t < -(int)edges[ind].flow; t++) {
						f2[edges[ind].v - sz3].push_back(all[i][j]);
						j++;
					}
				}
			}
		}
		/*cout << "f1\n";
		for (int i = 0; i < sz2; i++) {
			for (int x : f1[i]) {
				cout << x << ' ';
			}
			cout << endl;
		}
		cout << "f2\n";
		for (int i = 0; i < sz2; i++) {
			for (int x : f2[i]) {
				cout << x << ' ';
			}
			cout << endl;
		}*/
		for (int i = 0; i < sz2; i++) {
			for (int j = 0; j < (int)f1[i].size(); j++) {
				cout << f1[i][j] + 1 << ' ' << f2[i][j] + 1 << '\n';
			}
		}
		/*vector<vector<int> > g(n);
		for (int i = 0; i < (int)left.size(); i++) {
			for (int j = 0; j < (int)right.size(); j++) {
				if (eq(a[left[i]], a[right[j]])) g[i].push_back(j);
			}
		}
		vector<bool> used(n);
		vector<int> ans(n, -1);
		int all = 0;
		for (int i = 0; i < (int)left.size(); i++) {
			if (dfs(i, g, used, ans)) {
				used.assign(n, false);
				all++;
			}
		}
		if (all != n / 2) {
			cout << "NO" << endl;
			return 0;
		}
		cout << "YES" << endl;
		for (int i = 0; i < (int)right.size(); i++) {
			cout << left[ans[i]] + 1 << ' ' << right[i] + 1 << '\n';
		}*/
	}
	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			cout << a[i][j] << ' ';
		}
		cout << endl;
	}*/
	else {
		int sz = (1 << k);
		vector<vector<int> > cnt(sz);
		for (int i = 0; i < n; i++) {
			int cur = 0;
			for (int j = 0; j < k; j++) {
				cur = cur * 2 + a[i][j];
			}
			cnt[cur].push_back(i);
		}
		bool ok = 1;
		for (int i = 0; i < sz; i++) {
			if (cnt[i].size() != cnt[(sz - 1) ^ i].size()) {
				ok = 0;
				break;
			}
		}
		if (!ok) {
			cout << "NO" << endl;
			return 0;
		}
		cout << "YES" << endl;
		for (int i = 0; i < sz; i++) {
			if (i > ((sz - 1) ^ i)) continue;
			auto elem1 = cnt[i], elem2 = cnt[(sz - 1) ^ i];
			for (int j = 0; j < (int)elem1.size(); j++) {
				cout << elem1[j] + 1 << ' ' << elem2[j] + 1 << endl;
			}
		}
	}
	return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
