#include<set>
#include<map>
#include<list>
#include<cmath>
#include<ctime>
#include<vector>
#include<random>
#include<utility>
#include<iostream>
#include<iterator>
#include<algorithm>
using namespace std;

const int N = 401;
vector<int> g[N];

void solve_k1(int n)
{
    vector<pair<int, int>> v(n);

    for (int i = 0; i < n; i++)
    {
        cin >> v[i].first;
        v[i].second = i + 1;
    }

    sort(v.begin(), v.end());
    cout << "YES\n";

    for (int i = 0; i < n / 2; i++)
    {
        cout << v[i].second << ' ' << v[n - i - 1].second << '\n';
    }
}

void solve_n_f(int n, int k, vector<vector<int>> v)
{
    vector<int> perm(n);

    for (int i = 0, x = 0; i < n; i += 2) perm[i] = perm[i + 1] = x++;

    bool f = false;
    do
    {
        vector<vector<vector<int>>> pr(n / 2);
        vector<pair<int, int>> insp(k, { -1e9, 1e9 });
        for (int i = 0; i < n; i++) pr[perm[i]].push_back(v[i]);
        for (int i = 0; i < n / 2; i++)
        {
            for (int j = 0; j < k; j++)
            {
                insp[j].first = max(insp[j].first, min(pr[i][0][j], pr[i][1][j]));
                insp[j].second = min(insp[j].second, max(pr[i][0][j], pr[i][1][j]));
            }
        }

        bool flag = true;

        for (int i = 0; i < k; i++)
        {
            flag = flag && insp[i].second >= insp[i].first;
        }

        if (flag)
        {
            f = true;
            break;
        }

    } while (next_permutation(perm.begin(), perm.end()));

    if (!f)
    {
        cout << "NO";
    }
    else
    {
        vector<vector<int>> ans(n / 2);
        for (int i = 0; i < n; i++) ans[perm[i]].push_back(i + 1);
        cout << "YES\n";
        for (int i = 0; i < n / 2; i++) cout << ans[i][0] << ' ' << ans[i][1] << '\n';
    }
}

int main()
{
    int n, k;
    cin >> n >> k;

    if (k == 1)
    {
        solve_k1(n);
        return 0;
    }

    vector<vector<int>> v(n, vector<int>(k));

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < k; j++)
        {
            cin >> v[i][j];
        }
    }

    solve_n_f(n, k, v);
}