#include <iostream>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <string>

using namespace std;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

typedef long long ll;

long long n;
vector<int> graph[300001];
map<pair<int, int>, int> marked;
long long c[400000];
long long v, e, bl, wh;
ll dp[400000][2];
ll p[400000];

void dfs(int i)
{
    c[i] = 1;
    v++;
    for (int j = 0; j < graph[i].size(); j++)
    {
        int u = graph[i][j];
        if (c[u] == 0)
        {
            dfs(u);
            //marked[{u, i}] = 1;
            //marked[{i, u}] = 1;
            //e++;
        }
        if (!marked[{u, i}])
        {
            e++;
            marked[{u, i}] = 1;
            marked[{i, u}] = 1;
        }
    }
}

void dfs2(int i)
{
    //cout << i << endl;
    c[i] = 2;
    dp[i][1] = 1;
    for (int j = 0; j < graph[i].size(); j++)
    {
        int u = graph[i][j];
        //cout << u << " " << c[u] << endl;
        if (c[u] == 1)
        {
            //cout << '!' << endl;
            dfs2(u);
            dp[i][0] += max(dp[u][0], dp[u][1]);
            dp[i][1] += dp[u][0];
        }
    }
}

void dfs3(int i)
{
    c[i] = 13;
    dp[i][1] = 1;
    for (int j = 0; j < graph[i].size(); j++)
    {
        int u = graph[i][j];
        //cout << u << " " << c[u] << endl;
        if (c[u] == 11 || c[u] == 1)
        {
            //cout << '!' << endl;
            dfs3(u);
            dp[i][0] += max(dp[u][0], dp[u][1]);
            dp[i][1] += dp[u][0];
        }
    }
}

long long solve(int i)
{
    v = 0;
    e = 0;
    bl = 0, wh = 0;
    dfs(i);
    //cout << v << " " << e << endl;
    if (e == v - 1)
    {
        dfs2(i);
        return max(dp[i][0], dp[i][1]);
    }
    while (1)
    {
        c[i] = 11;
        if (c[p[i]] == 11)
            break;
        i = p[i];
    }
    int x = p[i];
    int len = 0;
    vector<int> cycle;
    vector<int> dp0;
    vector<int> dp1;
    while (x != i)
    {
        c[x] = 12;
        cycle.push_back(x);
        len++;
        x = p[x];
    }
    c[i] = 12;
    cycle.push_back(i);
    len++;
    long long ans = 0;
    for (int j = 0; j < cycle.size(); j++)
    {
        //cout << cycle[j] << " ";
        int xx = cycle[j];
        dfs3(xx);
        dp0.push_back(0);
        dp1.push_back(0);
        if (j >= 1)
        {
            dp1[j] = dp0[j - 1] + dp[xx][1];
            dp0[j] = max(dp0[j - 1], dp1[j - 1]) + dp[xx][0];
        }
        else
        {
            dp0[j] = dp[xx][0];
        }
    }
    ans = max(dp0[cycle.size() - 1], dp1[cycle.size() - 1]);
    dp0.resize(0);
    dp1.resize(0);
    for (int j = 0; j < cycle.size(); j++)
    {
        //cout << cycle[j] << " ";
        int xx = cycle[j];
        dfs3(xx);
        dp0.push_back(0);
        dp1.push_back(0);
        if (j >= 1)
        {
            dp1[j] = dp0[j - 1] + dp[xx][1];
            dp0[j] = max(dp0[j - 1], dp1[j - 1]) + dp[xx][0];
        }
        else
        {
            dp0[j] = dp[xx][0];
            dp1[j] = dp[xx][1];
        }
    }
    ans = max(ans, (ll)dp0[cycle.size() - 1]);
    return ans;
}

int main()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        int a;
        cin >> a;
        p[i] = a;
        if (a == -1)
            continue;
        graph[a].push_back(i);
        graph[i].push_back(a);
    }
    long long ans = 0;
    for (int i = 1; i <= n; i++)
    {
        if (c[i] == 0)
        {
            ans += solve(i);
        }
    }
    cout << ans;
    return 0;
}
