#include <iostream>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

typedef long long ll;

int n, k;
double a[220000][20];
vector<int> perm;
int used[400];

vector<int> as[8];
double coords[8];
vector<int> by_mask[1200];

void check()
{
    int t = 1;
    for (int j = 0; j < k; j++)
    {
        vector<pair<ll, ll> > segments;
        for (int i = 0; i < n; i += 2)
        {
            segments.push_back({a[perm[i]][j], a[perm[i + 1]][j]});
        }
        ll mina1 = - 1e9 - 7;
        ll maxa1 = 1e9 + 7;
        for (int i = 0; i < n / 2; i++)
        {
            mina1 = max(mina1, min(segments[i].first, segments[i].second));
            maxa1 = min(maxa1, max(segments[i].first, segments[i].second));
        }
        if (mina1 > maxa1)
        {
            t = 0;
            return;
        }
    }
    if (t)
    {
        cout << "YES\n";
        for (int i = 0; i < perm.size(); i++)
        {
            cout << perm[i] + 1 << " ";
            if (i % 2 == 1)
                cout << "\n";
        }
        exit(0);
    }
}

void rec(int x)
{
    if (x == 0)
    {
        check();
    }
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            used[i] = 1;
            for (int k = 0; k < n; k++)
            {
                if (!used[k])
                {
                    used[k] = 1;
                    perm.push_back(i);
                    perm.push_back(k);
                    rec(x - 1);
                    perm.pop_back();
                    perm.pop_back();
                    used[k] = 0;
                }
            }
            used[i] = 0;
        }
    }
}

const double eps = 1e-7;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    if (k == 1)
    {
        vector<pair<int, int> > ds;
        for (int j = 0; j < n; j++)
        {
            int a;
            cin >> a;
            ds.push_back({a, j + 1});
        }
        sort(ds.begin(), ds.end());
        cout << "YES\n";
        for (int j = 0; j < n / 2; j++)
        {
            cout << ds[j].second << " " << ds[n - j - 1].second << "\n";
        }
        return 0;
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < k; j++)
        {
            cin >> a[i][j];
        }
    }
    if (n <= 10)
    {
        rec(n / 2);
        cout << "NO";
        return 0;
    }
    cout << endl;
    for (int i = 0; i < k; i++)
    {
        for (int j = 0; j < n; j++)
        {
            as[i].push_back(a[j][i]);
        }
        sort(as[i].begin(), as[i].end());
        coords[i] = (double)as[i][n / 2] - 0.5;
        //cout << coords[i] << " ";
    }
    cout << endl;
    for (int i = 0; i < k; i++)
    {
        for (int j = 0; j < n; j++)
        {
            a[j][i] -= coords[i];
        }
    }
    for (int i = 0; i < n; i++)
    {
        ll mask = 0;
        for (int j = 0; j < k; j++)
        {
            mask *= 2;
            if (abs(a[i][j] - 0.5) <= eps)
            {
                int x = by_mask[mask + 1].size();
                int y = by_mask[mask].size();
                if (x >= y)
                {
                    continue;
                }
                else
                {
                    mask++;
                }
            }
            if (a[i][j] > 0)
            {
                mask++;
            }
            if (a[i][j] < 0)
            {
                continue;
            }
            //cout << a[i][j] << " ";
        }
        by_mask[mask].push_back(i + 1);
        //cout << mask << endl;
    }
    for (int i = 0; i < (1 << k); i++)
    {
        if (by_mask[i].size() != by_mask[(1 << k) - i - 1].size())
        {
            cout << "NO";
            return 0;
        }
    }
    cout << "YES\n";
    for (int i = 0; i < (1 << k) / 2; i++)
    {
        for (int j = 0; j < by_mask[i].size(); j++)
        {
            cout << by_mask[i][j] << " " << by_mask[(1 << k) - i - 1][j] << "\n";
        }
    }
}
