#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

const ll MOD = 1e9 + 7;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m, k;
    cin >> n >> m >> k;

    vector<ll> fact(n + 1, 1);
    for (ll i = 1; i <= n; i++)
        fact[i] = (fact[i - 1] * i) % MOD;

    vector<ll> pow(26, 1);
    for (ll i = 1; i < 26; i++)
        pow[i] = (pow[i - 1] * n) % MOD;

    ll ans = 0;
    for (ll last = 0; last <= k; last++)
    {
        ll ones = 0;
        for (ll i = 0; i < 25; i++)
            if (last & (1ll << i))
                ones++;

        ans += pow[ones];
        ans %= MOD;
    }

    cout << ans << endl;

    return 0;
}