#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

vector<vector<int>> g;
vector<int> taken;
vector<int> color;
int iter = 0;

bool dfs(int i)
{
    color[i] = iter;

    for (int x : g[i])
        if (taken[x] == -1)
            return (taken[x] = i), true;

    for (int x : g[i])
        if (color[taken[x]] != iter && dfs(taken[x]))
            return (taken[x] = i), true;

    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    g.resize(n);
    for (int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        a--;

        if (a != -2)
        {
            g[i].push_back(a);
            g[a].push_back(i);
        }
    }

    taken.resize(n, -1);
    color.resize(n, -1);
    for (int i = 0; i < n; i++)
    {
        dfs(i);
        iter++;
    }

    int ans = 0;
    for (int i = 0; i < n; i++)
        if (taken[i] != -1)
            ans++;

    cout << n - (ans + (ans % 2)) / 2 << endl;

    return 0;
}