#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

vector<vector<int>> g;
vector<int> color;
vector<int> ccount;
int flag = -1;

void dfs(int u, int prev)
{
    for (int v : g[u])
    {
        if (color[v] == -1)
        {
            if (color[u] % 2 == 0)
                color[v] = color[u] + 1;
            else
                color[v] = color[u] - 1;
            ccount[color[v]]++;
            dfs(v, u);
        }
        else if (v != prev && color[v] == color[u])
            flag = color[v] - (color[v] % 2);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    g.resize(n);
    for (int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        a--;

        if (a != -2)
        {
            g[i].push_back(a);
            g[a].push_back(i);
        }
    }

    color.resize(n, -1);
    ccount.resize(2 * n, 0);
    int cur = 0;
    for (int i = 0; i < n; i++)
    {
        if (color[i] == -1)
        {
            color[i] = 2 * cur;
            ccount[color[i]]++;
            dfs(i, -1);
            cur++;
        }
    }

    int ans = 0;
    for (int p = 0; p < cur; p += 2)
    {
        ans += max(ccount[p], ccount[p + 1]);
        if (flag == p)
            ans--;
    }

    cout << ans << endl;

    return 0;
}