#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

vector<vector<int>> g;
vector<int> color;
vector<int> ccount;
vector<int> loop;
int until = -1;
int dis = 0;

bool dfs(int u, int prev)
{
    color[u] = 1;
    for (int v : g[u])
    {
        if (v != prev && color[v] == 1)
        {
            loop.push_back(u);
            until = v;
            color[u] = 2;

            return true;
        }
        else if (color[v] == 0 && dfs(v, u))
        {
            loop.push_back(u);
            color[u] = 2;

            return until != u;
        }
    }

    color[u] = 2;
    return false;
}

void dfs(int u)
{
    for (int v : g[u])
    {
        if (v == dis)
            continue;

        if (color[v] == -1)
        {
            if (color[u] % 2 == 0)
                color[v] = color[u] + 1;
            else
                color[v] = color[u] - 1;
            ccount[color[v]]++;
            dfs(v);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    g.resize(n);
    for (int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        a--;

        if (a != -2)
        {
            g[i].push_back(a);
            g[a].push_back(i);
        }
    }

    color.resize(n, 0);
    for (int i = 0; i < n; i++)
        if (color[i] == 0)
            dfs(i, -1);

    color.resize(n, -1);
    ccount.resize(2 * n, 0);

    int gans = 0;
    if (loop.empty())
        loop.push_back(-1);
    else if (loop.size() % 2 == 0)
    {
        loop.clear();
        loop.push_back(-1);
    }
    for (int x : loop)
    {
        dis = x;
        color.assign(n, -1);
        ccount.assign(2 * n, 0);

        int cur = 0;
        for (int i = 0; i < n; i++)
        {
            if (i == dis)
                continue;

            if (color[i] == -1)
            {
                color[i] = cur;
                ccount[color[i]]++;
                dfs(i);
                cur += 2;
            }
        }

        int ans = 0;
        for (int p = 0; p < cur; p += 2)
            ans += max(ccount[p], ccount[p + 1]);

        gans = max(gans, ans);
    }

    cout << gans << endl;

    return 0;
}