#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <unordered_set>

typedef long long ll;

using namespace std;

vector<unordered_set<int>> g;
vector<int> taken;
vector<int> color;
int iter = 0;

bool dfs(int i)
{
    color[i] = iter;

    for (int x : g[i])
        if (taken[x] == -1 && taken[i] != x)
            return (taken[x] = i), true;

    for (int x : g[i])
        if (color[taken[x]] != iter && taken[i] != x && dfs(taken[x]))
            return (taken[x] = i), true;

    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    g.resize(n);
    taken.resize(n, -1);
    color.resize(n, -1);

    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            if (i != j)
                g[i].insert(j);

    for (int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        a--;

        if (a != -2)
        {
            g[i].erase(a);
            g[a].erase(i);
        }
    }

    taken.assign(n, -1);
    color.assign(n, -1);
    vector<bool> takenleft(n, false);
    for (int i = 0; i < n; i++)
    {
        takenleft[i] = dfs(i);
        iter++;
    }

    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        if (taken[i] != -1)// && takenleft[i])
        {
            ans++;
        }
    }

    cout << n - ans << endl;
    //cout << n - (ans + (ans % 2)) / 2 << endl;

    return 0;
}