#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>

typedef long long ll;

using namespace std;

struct object
{
    int idx;
    vector<int> p;
    vector<int> srt;
    vector<bool> good;
};

int n, k;
vector<object> objects;
vector<int> taken;
vector<int> color;
vector<int> boys;
vector<int> girls;
vector<int> pga;
vector<int> pgb;
int iter = 0;

bool can_be_pair(int a, int b)
{
    for (int j = 0; j < k; j++)
        if ((objects[a].p[j] <= pga[j] && objects[b].p[j] <= pga[j]) || (objects[a].p[j] >= pgb[j] && objects[b].p[j] >= pgb[j]))
            return false;
    return true;
}

bool dfs(int i)
{
    color[i] = iter;

    for (int x : girls)
        if (can_be_pair(i, x) && taken[x] == -1 && taken[i] != x)
            return (taken[x] = i), true;

    for (int x : girls)
        if (can_be_pair(i, x) && color[taken[x]] != iter && taken[i] != x && dfs(taken[x]))
            return (taken[x] = i), true;

    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> k;

    objects.resize(n);
    for (int i = 0; i < n; i++)
    {
        objects[i].idx = i;
        objects[i].p.resize(k);
        objects[i].srt.resize(k);
        objects[i].good.resize(k, false);
        for (int j = 0; j < k; j++)
            cin >> objects[i].p[j];
    }

    if (k == 1)
    {
        sort(objects.begin(), objects.end(), [](object a, object b){return a.p[0] < b.p[0];});
        cout << "YES" << endl;
        for (int i = 0; i < n / 2; i++)
            cout << objects[i].idx + 1 << " " << objects[i + n / 2].idx + 1 << endl;
        return 0;
    }

    pga.resize(k);
    pgb.resize(k);
    for (int j = 0; j < k; j++)
    {
        sort(objects.begin(), objects.end(), [j](object a, object b){return a.p[j] < b.p[j];});
        pga[j] = objects[n / 2 - 1].p[j];
        pgb[j] = objects[n / 2].p[j];

        if (j == 0)
        {
            for (int i = 0; i < n / 2; i++)
                boys.push_back(objects[i].idx);
            for (int i = n / 2; i < n; i++)
                girls.push_back(objects[i].idx);
        }
    }

    sort(objects.begin(), objects.end(), [](object a, object b){return a.idx < b.idx;});
    taken.resize(n, -1);
    color.resize(n, -1);
    vector<bool> takenleft(n, false);
    for (int i : boys)
    {
        dfs(i);
        iter++;
    }

    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++)
    {
        if (taken[i] != -1)
        {
            ans.push_back({min(i, taken[i]), max(i, taken[i])});
        }
    }

    if (ans.size() < n / 2)
        cout << "NO" << endl;
    else
    {
        cout << "YES" << endl;
        for (int i = 0; i < n / 2; i++)
            cout << ans[i].first + 1 << " " << ans[i].second + 1 << endl;
    }
    //cout << n - (ans + (ans % 2)) / 2 << endl;

    return 0;
}