#include <bits/stdc++.h>

#define INT_INF (int)(2 * 1e9)
#define LL_INF  (ll)(2 * 1e18)

//#define __LOCAL
#define FAST_IO ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << endl;
#else
#define DBG(X) 
#endif

using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int MAX_N = 3e5 + 666;
const int K = 10000;

set<int> idxs[MAX_N];

int n, m;
vector<int> a, b;

struct Block
{
	vector<pii>* vals = nullptr;
	int min_time = INT_INF;
};

vector<Block> blocks;


int my_pop_front()
{
	auto val = blocks.begin()->vals->front();
	blocks.begin()->vals->erase(blocks.begin()->vals->begin());

	if(blocks.begin()->vals->size() == 0)
	{
		blocks.erase(blocks.begin());
	}
	else
	{
		blocks.begin()->min_time = INT_INF;

		for(auto el: *(blocks.begin()->vals))
			blocks.begin()->min_time = min(blocks.begin()->min_time, el.first);
	}

	return val.second;
}

int my_push(int val, int time)
{
	int tsz = 0;

	if(blocks.empty())
	{
		blocks.push_back(Block());
		blocks[0].min_time = time;
		blocks[0].vals = new vector<pii>();
		blocks[0].vals->push_back(make_pair(time, val));

		return 0;
	}

	for(auto& b: blocks)
		tsz += b.vals->size();

	DBG(tsz);

	int nblocks = blocks.size();
	int j = nblocks - 1;

	while(j > 0 && blocks[j].min_time > time)
	{
		tsz -= blocks[j].vals->size();
		--j;
	}

	int i = blocks[j].vals->size() - 1;

	while(i >= 0 && (*blocks[j].vals)[i].first > time)
	{
		--i;
		--tsz;
	}

	blocks[j].vals->insert(blocks[j].vals->begin() + i + 1, make_pair(time, val));
	blocks[j].min_time = min(blocks[j].min_time, time);

	return tsz;
}

void solve()
{
	cin >> n >> m;

	a.resize(m); b.resize(n);

	for(auto& el: a)
		cin >> el;

	for(auto& el: b)
		cin >> el;

	for(int i = 0; i < m; ++i)
		idxs[a[i]].insert(i);

	for(auto el: b)
		idxs[el].insert(INT_INF);

	blocks.push_back(Block());
	blocks.rbegin()->vals = new vector<pii>();

	for(auto el: b)
	{
		if(blocks.rbegin()->vals->size() >= K)
		{
			blocks.push_back(Block());
			blocks.rbegin()->vals = new vector<pii>();
		}

		int t = *idxs[el].lower_bound(0);

		blocks.rbegin()->vals->emplace_back(t, el);
		blocks.rbegin()->min_time = min(blocks.rbegin()->min_time, t);
	}

	vector<int> ans;
	int cnt = 0;

	for(int i = 0; i < m && cnt++ < 10;)
	{
		/*int val = b[0];
		int ni = n - 1;

		int time = *idxs[val].upper_bound(i);

		while(ni > 0 && *idxs[b[ni]].lower_bound(i) > time)
			--ni;

		DBG(ni);

		b.erase(b.begin());
		b.insert(b.begin() + ni, val);*/

		int val = my_pop_front();
		int ni = my_push(val, *idxs[val].upper_bound(i));
		DBG(ni);

		ans.push_back(ni + 1);

#ifdef __LOCAL
		for(auto b: blocks)
		{
			for(int i = 0; i < b.vals->size(); ++i)
				cout << "[" << (*b.vals)[i].first << " , " << (*b.vals)[i].second << "] ";

			cout << "|";
		}

		cout << endl;
#endif

		if(val == a[i])
			++i;
	}

	cout << ans.size() << endl;

	for(auto el: ans)
		cout << el <<  " ";

	cout << endl;
}

int main()
{
	FAST_IO;
	solve();

	return 0;
}