#include <bits/stdc++.h>

#define INT_INF (int)(2 * 1e9)
#define LL_INF  (ll)(2 * 1e18)

//#define __LOCAL
#define FAST_IO ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << endl;
#else
#define DBG(X) 
#endif

using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const ll mod = 1e9 + 7;
const int MAX_N = 5000;

ll dp[MAX_N][MAX_N][2];
ll pdp[MAX_N][MAX_N][2];

void compute_prefsum(int i, int fl)
{
	for(int j = 1; j < MAX_N; ++j)
		pdp[i][j][fl] = (pdp[i][j - 1][fl] + dp[i][j][fl]) % mod;
}

void solve()
{
	int n, k;
	cin >> n >> k;

	for(int i = 1; i <= n; ++i)
	{
		dp[i][i][0] = 1;
		dp[i][i][1] = 1;

		compute_prefsum(i, 0);
		compute_prefsum(i, 1);
	}

	for(int sm = 1; sm <= n; ++sm)
	{
		for(int f = 1; f < sm; ++f)
		{
			for(int fl = 0; fl < 2; ++fl)
			{
				dp[sm][f][fl] = 0;

				/*for(int nxt = 1; nxt <= sm - f; ++nxt)
					dp[sm][f][fl] = (dp[sm][f] + dp[sm - f][nxt]) % mod;*/

				if(fl == 0)
				{
					/*for(int nxt = f + 1; nxt <= sm - f; ++nxt)
						dp[sm][f][fl] = (dp[sm][f][fl] + dp[sm - f][nxt][1 - fl]) % mod;*/

					if(f + 1 <= sm - f)
					{
						ll dlt = (mod + pdp[sm - f][sm - f][1 - fl] - pdp[sm - f][f][1 - fl]) % mod;

						dp[sm][f][fl] = (dp[sm][f][fl] + dlt) % mod;
					}
				}
				else
				{
					/*for(int nxt = 1; nxt <= sm - f && nxt < f; ++nxt)
						dp[sm][f][fl] = (dp[sm][f][fl] + dp[sm - f][nxt][1 - fl]) % mod;*/

					int e = min(sm - f, f - 1);

					if(1 <= e)
					{
						ll dlt = (mod + pdp[sm - f][e][1 - fl] - pdp[sm - f][0][1 - fl]) % mod;

						dp[sm][f][fl] = (dp[sm][f][fl] + dlt) % mod;
					}
				}
			}
		}

		compute_prefsum(sm, 0);
		compute_prefsum(sm, 1);
	}

#ifdef __LOCAL
	for(int sm = 1; sm <= n; ++sm)
	{
		for(int f = 1; f <= sm; ++f)
		{
			cout << "dp[" << sm << "][" << f << "][0]=" << dp[sm][f][0] << endl;
			cout << "dp[" << sm << "][" << f << "][1]=" << dp[sm][f][1] << endl;
		}
	}
#endif

	if(n == k)
	{
		cout << 1 << endl;
		return;
	}

	cout << (dp[n][k][0] + dp[n][k][1]) % mod << endl;
}

int main()
{
	FAST_IO;
	solve();

	return 0;
}