#include <bits/stdc++.h>

#define INT_INF (int)(2 * 1e9)
#define LL_INF  (ll)(2 * 1e18)

#define __LOCAL
#define FAST_IO ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << endl;
#else
#define DBG(X) 
#endif

using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int MAX_N = 3001111;
const int NONE = MAX_N;

vector<int> g[MAX_N];
int n, dp1[MAX_N][2], dp2[MAX_N][2], dsu[MAX_N], bad1 = -1, bad2 = -1;
bool used1[MAX_N], used2[MAX_N];

int dsu_get(int v)
{
	if(dsu[v] == v)
		return v;

	return (dsu[v] = dsu_get(dsu[v]));
}

void dsu_merge(int u, int v)
{
	u = dsu_get(u);
	v = dsu_get(v);

	if(rand() % 2 == 0)
		swap(u, v);

	dsu[u] = v;
}

void dfs1(int v)
{
	used1[v] = true;

	dp1[v][0] = 0;
	dp1[v][1] = 1;

	for(auto u: g[v])
	{
		if(!used1[u])
		{
			dfs1(u);

			dp1[v][0] += max(dp1[u][1], dp1[u][0]);
			dp1[v][1] += dp1[u][0];
		}
	}

	if(v == bad1)
		dp1[v][1] = 0;
}

void dfs2(int v)
{
	used2[v] = true;

	dp2[v][0] = 0;
	dp2[v][1] = 1;

	for(auto u: g[v])
	{
		if(!used2[u])
		{
			dfs2(u);

			dp2[v][0] += max(dp2[u][1], dp2[u][0]);
			dp2[v][1] += dp2[u][0];
		}
	}

	if(v == bad2)
		dp2[v][1] = 0;
}

void solve()
{
	cin >> n;

	for(int i = 0; i < n; ++i)
		dsu[i] = i;

	set<pii> edges;

	for(int i = 0; i < n; ++i)
	{
		int a;
		cin >> a;

		if(a == -1)
			continue;

		--a;

		edges.insert(make_pair(min(a, i), max(a, i)));
	}

	for(auto ed: edges)
	{
		int a = ed.first, i = ed.second;

		if(a >= 0)
		{
			if(dsu_get(a) != dsu_get(i))
			{
				g[i].push_back(a);
				g[a].push_back(i);

				dsu_merge(a, i);
			}
			else
			{
				bad1 = a, bad2 = i;

				DBG(bad1); DBG(bad2);
			}
		}
	}

	int ans1 = 0;

	for(int v = 0; v < n; ++v)
	{
		if(!used1[v])
		{
			dfs1(v);

			ans1 += max(dp1[v][0], dp1[v][1]);
		}
	}

	int ans2 = 0;

	for(int v = 0; v < n; ++v)
	{
		if(!used2[v])
		{
			dfs2(v);

			ans2 += max(dp2[v][0], dp2[v][1]);
		}
	}

	int ans = max(ans1, ans2);

	cout << ans << endl;
}

int main()
{
	FAST_IO;
	solve();

	return 0;
}