#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

struct Node {
	int x;
	int y;
	int siz;
	Node *L, *R;
	Node(int x1) {
		x = x1;
		siz = 1;
		y = rand();
		L = nullptr;
		R = nullptr;
	}
};

void push(Node* v) {
	v->siz = 1;
	if (v->L) {
		v->siz += v->L->siz;
	}
	if (v->R) {
		v->siz += v->R->siz;
	}
}

Node* merge(Node *v, Node *t) {
	if (!v && !t) {
		return nullptr;
	}
	if (!v) {
		return t;
	}
	if (!t) {
		return v;
	}
	if (v->y > t->y) {
		auto p = merge(v->R, t);
		v->R = p;
		push(v);
		push(t);
		return v;
	}
	else {
		auto p = merge(v, t->L);
		t->L = p;
		push(v);
		push(t);
		return t;
	}
}

pair<Node*, Node*> split(Node *v, int k) {
	if (!v) {
		return {nullptr, nullptr};
	}
	int a = 0;
	if (v->L) {
		a = v->L->siz;
	}
	if (k > a) {
		auto p = split(v->R, k - a - 1);
		v->R = p.first;
		push(v);
		return {v, p.second};
	}
	else {
		auto p = split(v->L, k);
		v->L = p.second;
		push(v);
		return {p.first, v};
	}
	
}

vector<int> dir;

void dfs(Node* t) {
	if (!t) {
		return;
	}
	dfs(t->L);
	dir.push_back(t->x);
	//cout << t->x << " ";
	dfs(t->R);
}

void deg(Node* t) {
	if (!t) {
		return;
	}
	deg(t->L);
	//dir.push_back(t->x);
	cout << t->x << " ";
	deg(t->R);
}

Node* change(Node* t, int x, int to) {
	auto p = split(t, x);
	auto v = split(p.second, to);
	t = merge(v.first, merge(p.first, v.second));
	return t;
}

int main() {
	int n, m;
	cin >> n >> m;
	vector<int> quest(m);
	map<int, set<int>> mapi;
	for (int i = 0; i < m; i++) {
		int a;
		cin >> a;
		quest[i] = a;
		mapi[a].insert(i);
	}
	Node* t = nullptr;
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		t = merge(t, new Node(a));
	}
	vector<int> ans;
	int ind = 0;

	while (ind < m) {
		dir.clear();
		dfs(t);
		int now = dir[0];
		int res = -1;
		if (quest[ind] == now) {
			if (mapi[quest[ind]].size() == 1) {
				res = n;
				t = change(t, 1, n - 1);
			}
			else {
				int l;
				for (int i : mapi[quest[ind]]) {
					l = i;
					break;
				}
				mapi[quest[ind]].erase(l);
				set<int> seti;
				int r;
				for (int i : mapi[quest[ind]]) {
					r = i;
					break;
				}
				
				for (int i = l + 1; i < r; i++) {
					seti.insert(quest[i]);
				}
				for (int i = 0; i < n; i++) {
					if (seti.find(dir[i]) != seti.end()) {
						res = i;
					}
				}
				if (res == -1) {
					res = 0;
				}
				res++;
				t = change(t, 1, res - 1);
			}
			ind++;
		}
		else {
			if (mapi[now].size() == 0) {
				res = n;
				t = change(t, 1, n - 1);
			}
			else {
				int r;
				for (int i : mapi[now]) {
					r = i;
					break;
				}
				set<int> seti;
				for (int i = ind; i < r; i++) {
					seti.insert(quest[i]);
				}
				for (int i = 0; i < n; i++) {
					if (seti.find(dir[i]) != seti.end()) {
						res = i;
					}
				}
				res++;
				t = change(t, 1, res - 1);
			}
		}
		//deg(t);
		//cout << "\n";
		ans.push_back(res);
		//cout << res << " ";
	}
	cout << ans.size() << "\n";
	for (int i : ans) {
		cout << i << " ";
	}

	return 0;
}

