#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

typedef long long llt;
typedef pair<int, int> pii;
vector<int> para, used;
map<int, set<int>> m;

bool dfs(int v) {
	if (used[v] == 1) {
		return false;
	}
	used[v] = 1;
	for (int u : m[v]) {
		if (para[u] == -1 || dfs(para[u])) {
			para[u] = v;
			return true;
		}
	}
	return false;
}

int main() {
	int n, k;
	cin >> n >> k;
	vector<pii> w(n);
	vector<vector<pii>> art(k, vector<pii> (n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			int a;
			cin >> a;
			art[j][i] = { a, i };
		}
	}
	sort(art[0].begin(), art[0].end());
	if (k == 1) {
		cout << "YES" << "\n";
		for (int i = 0; i < n / 2; i++) {
			cout << art[0][i].second + 1 << " " << art[0][n / 2 + i].second + 1 << "\n";
		}
		return 0;
	}
	
	set<int> half;
	for (int i = n / 2; i < n; i++) {
		half.insert(art[0][i].second);
	}
	for (int i = 0; i < n; i++) {
		if (half.find(i) == half.end()) {
			for (int j : half) {
				m[i].insert(j);
			}
		}
	}

	for (int j = 1; j < k; j++) {
		sort(art[j].begin(), art[j].end());
		set<int> one, two;
		for (int i = n / 2; i < n; i++) {
			int t = art[j][i].second;
			if (half.find(t) == half.end()) {
				one.insert(t);
			}
			else {
				two.insert(t);
			}
		}
		set<int> two_2;
		for (int i = 0; i < n; i++) {
			if (two.find(i) == two.end() && half.find(i) != half.end()) {
				two_2.insert(i);
			}
		}
		for (int i = 0; i < n; i++) {
			if (half.find(i) == half.end()) {
				if (one.find(i) == one.end()) {
					for (int y : two_2) {
						m[i].erase(y);
					}
				}
				else {
					for (int y : two) {
						m[i].erase(y);
					}
				}
			}
		}
	}

	para.resize(n, -1);
	used.resize(n);
	for (int i = 0; i < n; i++) {
		if (half.find(i) != half.end()) {
			continue;
		}
		if (dfs(i)) {
			for (int j = 0; j < n; j++) {
				if (half.find(j) == half.end()) {
					used[j] = 0;
				}
			}
		}
	}

	for (int i : half) {
		if (para[i] == -1) {
			cout << "NO";
			return 0;
		}
	}
	cout << "YES" << "\n";
	for (int i : half) {
		cout << para[i] + 1 << " " << i + 1 << "\n";
	}

	return 0;
}