#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <cassert>

using namespace std;

#define int long long

#define LATER(limit) if(1000 * clock() / CLOCKS_PER_SEC > limit)

int fast_pow(int n, int k) {
	if(k == 1) {
		return n;
	} else if(k == 0) {
		return 1;
	} else if(k % 2 == 1) {
		return fast_pow(n, k - 1) * n;
	} else {
		int x = fast_pow(n, k / 2);
		return x * x;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, k;
	cin >> n >> m >> k;

	vector<int> a(n, -1);
	for(int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		l--; r--;
		a[r] = max(a[r], l);
	}

	int b = log2(k) + 1;
	int ans = 0;
	int cnt_one = 0;
	for(int i = b - 1; i >= 0; i--) {
		if((k & (1 << i)) == 0) {
			continue;
		}
		// Case 1. Bit I is not set => all other bits can contain anything
		ans += fast_pow(n + 1, i) * fast_pow(n, cnt_one);
		// Case 2. Bit I is set, handled in next iterations
		cnt_one++;
	}
	ans += fast_pow(n, cnt_one);

	cout << ans;

	return 0;
}
