#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <cassert>

using namespace std;

#define int long long

#define LATER(limit) if(1000 * clock() / CLOCKS_PER_SEC > limit)

int intsqrt(int n) {
	if(n == 0) {
		return 0;
	}
	int fl = sqrt(n);
	for(int i = max(0LL, fl - 100); i < fl + 100; i++) {
		if(i * i > n) {
			return i - 1;
		}
	}
	assert(false);
}

int solve(int k) {
	if(k == 0) {
		return 0;
	}

	if(k % 2 == 0 && k % 4 != 0) {
		return -1;
	}
	bool even = false;
	if(k % 4 == 0) {
		even = true;
		k /= 4;
	}
	bool neg = false;
	if(k < 0) {
		neg = true;
		k = -k;
	}

	bitset<1000002> dp;
	dp[1] = true;

	vector<int> f;
	int k1 = k;
	int sq = intsqrt(k);
	int d = 1;
	for(int i = 2; i * i <= k1; i++) {
		//if(i % 10000000 == 0) {
		//	cerr << (float)(100000*i*i/k1)/1000 << "%, please wait..." << endl;
		//}
		while(k1 % i == 0) {
			int j = sq / i;
			for(int l = j * i; j >= 0; l -= i, j--) {
				dp[l] = dp[l] || dp[j];
				if(dp[l]) {
					d = max(d, l);
				}
			}
			k1 /= i;
		}
	}
	if(k1 > 1) {
		int j = sq / k1;
		for(int l = j * k1; j >= 0; l -= k1, j--) {
			dp[l] = dp[l] || dp[j];
			if(dp[l]) {
				d = max(d, l);
			}
		}
		k1 = 1;
	}

	if(even) {
		k *= 4;
		d *= 2;
	}

	int a = abs((d - k / d) / 2);
	int b = abs((d + k / d) / 2);
	if(neg) {
		return a;
	} else {
		return b;
	}
}

int ok(int k) {
	int i = 1;

	int tries = 0;
	while(true) {
		if(k >= 0) {
			int sq = intsqrt(k);
			if(sq * sq == k) {
				return sq;
			}
		}

		tries++;
		if(tries >= 1000000) {
			return -1;
		}

		k += i;
		i += 2;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k;
	cin >> k;
	//k = 934567890123LL;

	//cout << ok(k) << endl;
	//cout << solve(k) << endl;

	int ans = solve(k);
	if(ans == -1) {
		cout << "none";
	} else {
		cout << ans;
	}

	return 0;
}