#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <random>
#include <algorithm>

using namespace std;

vector< vector<int> > adj;
set<int> loop_vertexes;
vector<bool> used;

pair<int, int> dfs(int v) {
	used[v] = true;

	int ans1 = 0, ans2 = 1;
	for(int u: adj[v]) {
		if(loop_vertexes.count(u)) {
			continue;
		}

		pair<int, int> p = dfs(u);
		ans1 += max(p.first, p.second);
		ans2 += p.first;
	}
	return make_pair(ans1, ans2);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	vector<int> a(n);
	adj.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> a[i];
		if(a[i] != -1) {
			a[i]--;
			adj[a[i]].push_back(i);
		}
	}

	used.resize(n);
	int ans = 0;
	for(int i = 0; i < n; i++) {
		if(used[i]) {
			continue;
		}

		used[i] = true;

		int j = i;
		set<int> items;
		vector<int> item_list;
		vector<int> loop;
		loop_vertexes.clear();
		while(a[j] != -1) {
			j = a[j];
			used[j] = true;
			if(items.count(j)) {
				// Found loop
				int idx = find(item_list.begin(), item_list.end(), j) - item_list.begin();
				for(int k = idx; k < item_list.size(); k++) {
					loop.push_back(item_list[k]);
					loop_vertexes.insert(item_list[k]);
				}
				break;
			}
			item_list.push_back(j);
			items.insert(j);
		}

		if(loop.size()) {
			vector< pair<int, int> > anses;
			int sum = 0;
			for(int v: loop) {
				// cerr << "[" << v + 1 << "] ";
				anses.push_back(dfs(v));
				sum += anses.back().first;
			}
			// cerr << endl;

			int ans1 = 0, ans2 = 0;
			for(int i = 0; i < (int)loop.size() - 1; i += 2) {
				ans1 += max(anses[i].second - anses[i].first, 0) + 1;
			}
			for(int i = 1; i < (int)loop.size(); i += 2) {
				ans2 += max(anses[i].second - anses[i].first, 0) + 1;
			}
			ans += max(ans1, ans2) + sum;
		} else {
			pair<int, int> p = dfs(j);
			ans += max(p.first, p.second);
		}
	}

	cout << ans;

	return 0;
}