#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <random>
#include <algorithm>

using namespace std;

vector< vector<int> > adj;
set<int> loop_vertexes;
vector<bool> used;

pair<int, int> dfs(int v) {
	used[v] = true;

	int ans1 = 0, ans2 = 1;
	for(int u: adj[v]) {
		if(loop_vertexes.count(u)) {
			continue;
		}

		pair<int, int> p = dfs(u);
		ans1 += max(p.first, p.second);
		ans2 += p.first;
	}
	return make_pair(ans1, ans2);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	vector<int> a(n);
	adj.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> a[i];
		if(a[i] != -1) {
			a[i]--;
			adj[a[i]].push_back(i);
		}
	}

	used.resize(n);
	int ans = 0;
	for(int i = 0; i < n; i++) {
		if(used[i]) {
			continue;
		}

		used[i] = true;

		int j = i;
		set<int> items;
		vector<int> item_list;
		vector<int> loop;
		loop_vertexes.clear();
		while(a[j] != -1) {
			j = a[j];
			used[j] = true;
			if(items.count(j)) {
				// Found loop
				int idx = find(item_list.begin(), item_list.end(), j) - item_list.begin();
				for(int k = idx; k < item_list.size(); k++) {
					loop.push_back(item_list[k]);
					loop_vertexes.insert(item_list[k]);
				}
				break;
			}
			item_list.push_back(j);
			items.insert(j);
		}

		if(loop.size()) {
			vector<int> anses;
			int sum = 0;
			for(int v: loop) {
				pair<int, int> p = dfs(v);
				anses.push_back(max(p.second - p.first, 0));
				sum += p.first;
				// cerr << p.first << "/" << p.second << endl;
			}

			vector<int> dp(loop.size());
			dp[0] = anses[0];
			dp[1] = anses[0];
			for(int i = 2; i < loop.size() - 1; i++) {
				dp[i] = max(anses[i] + dp[i - 2], dp[i - 1]);
			}
			int ans1 = dp[loop.size() - 2];

			dp[0] = 0;
			dp[1] = anses[1];
			for(int i = 2; i < loop.size(); i++) {
				dp[i] = max(anses[i] + dp[i - 2], dp[i - 1]);
			}
			int ans2 = dp.back();

			ans += max(ans1, ans2) + sum;
			// cerr << "+" << ans1 << "/" << ans2 << " +" << sum << endl;
		} else {
			pair<int, int> p = dfs(j);
			ans += max(p.first, p.second);
		}
	}

	cout << ans;

	return 0;
}