#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <unordered_set>
#include <string>
#include <cmath>
#include <ctime>
#include <random>
#include <algorithm>

using namespace std;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, k;
	cin >> n >> k;

	vector< pair< vector<int>, int > > a(n, pair< vector<int>, int>(vector<int>(k), 0));
	for(int i = 0; i < n; i++) {
		a[i].second = i;
		for(int j = 0; j < k; j++) {
			cin >> a[i].first[j];
		}
	}



	if(n <= 10) {
		vector<int> p;
		for(int i = 0; i < n; i++) {
			p.push_back(i);
		}
		do {
			bool good = true;
			for(int j = 0; j < k; j++) {
				int ll = -10000000000LL, rr = 10000000000LL;
				for(int i = 0; i < n; i += 2) {
					int x = p[i];
					int y = p[i + 1];

					int l = a[x].first[j];
					int r = a[y].first[j];
					if(l > r) {
						swap(l, r);
					}
					ll = max(l, ll);
					rr = min(r, rr);
				}
				if(ll > rr) {
					good = false;
					break;
				}
			}
			if(good) {
				cout << "YES" << endl;
				for(int i = 0; i < n; i += 2) {
					int x = p[i];
					int y = p[i + 1];
					cout << x + 1 << " " << y + 1 << endl;
				}
				return 0;
			}
		} while(next_permutation(p.begin(), p.end()));
		cout << "NO";
		return 0;
	}




	sort(a.begin(), a.end());

	// First, map least n/2 elements to any of greatest n/2 elements
	vector<int> mapping(n, -1);
	vector< vector<int> > maps;
	maps.emplace_back();
	for(int i = n / 2; i < n; i++) {
		maps.back().push_back(a[i].second);
	}
	for(int i = 0; i < n / 2; i++) {
		mapping[a[i].second] = 0;
	}

	vector<int> ra(n);
	for(int i = 1; i < k; i++) {
		random_shuffle(a.begin(), a.end());
		sort(a.begin(), a.end(), [&](pair< vector<int>, int > p1, pair< vector<int>, int > p2) {
			return p1.first[i] < p2.first[i];
		});
		for(int j = 0; j < n; j++) {
			ra[a[j].second] = j;
			// cerr << "Sorted by 2nd parameter. " << j << ": (real) " << a[j].second << endl;
		}

		// Intersect maps with low and high halves
		for(int l = 0, cnt = maps.size(); l < cnt; l++) {
			// cerr << "Intersecting map [ ";
			// for(int j = 0; j < maps[l].size(); j++) {
			// 	cerr << maps[l][j] << " ";
			// }
			// cerr << "]" << endl;

			vector<int> low, high;
			for(int j: maps[l]) {
				if(ra[j] < n / 2) {
					low.push_back(j);
				} else {
					high.push_back(j);
				}
			}
			maps[l] = low;
			maps.push_back(high);
		}

		for(int j = 0; j < n / 2; j++) {
			int realidx = a[j].second;
			if(mapping[realidx] != -1) {
				mapping[realidx] += maps.size() / 2;
			}
		}
	}

	// for(int i = 0; i < n; i++) {
	// 	cerr << i << " -> " << mapping[i] << endl;
	// }
	// cerr << "Maps:";
	// for(vector<int> map: maps) {
	// 	for(int x: map) {
	// 		cerr << x << " ";
	// 	}
	// 	cerr << endl;
	// }

	vector< vector<int> > holders_per_map(maps.size());
	for(int i = 0; i < n; i++) {
		if(mapping[i] == -1) {
			continue;
		}

		if(maps[mapping[i]].size() == 0) {
			cout << "NO";
			return 0;
		}
		holders_per_map[mapping[i]].push_back(i);
	}

	cout << "YES" << endl;
	for(int i = 0; i < maps.size(); i++) {
		sort(holders_per_map[i].rbegin(), holders_per_map[i].rend(), [&](int x, int y) {
			return a[ra[x]].first[0] < a[ra[y]].first[0];
		});

		for(int j = 0; j < maps[i].size(); j++) {
			int from = holders_per_map[i][j];
			int to = maps[i][j];
			if(from > to) {
				swap(from, to);
			}
			cout << from + 1 << " " << to + 1 << endl;
		}
	}

	return 0;
}