#pragma GCC target("tune=native")
#include <bits/stdc++.h>

using namespace std;
using i32 = int32_t;
using u32 = uint32_t;
using i64 = int64_t;

namespace trandom {
    struct random {
        u32 seed = chrono::high_resolution_clock::now().time_since_epoch().count() ^ (u32)(make_unique<i32>().get() - (i32 *)0);
        mt19937 engine;
        uniform_int_distribution<i32> dist;

        random(i32 l = numeric_limits<i32>::min(), i32 r = numeric_limits<i32>::max()):
            engine(seed),
            dist(l, r) {

        }

        i32 operator() () {
            return dist(engine);
        }
    } next;
}

int main() {
#ifdef DEBUG
    assert(freopen("input", "r", stdin));
    assert(freopen("output", "a", stdout));
#endif
    cin.tie(nullptr)->sync_with_stdio(false);

    i64 k;
    go: assert(cin >> k);

    if (k == 0) {
        cout << 0 << endl;
    }

    i64 n;
    if (k < 0) {
        n = -k;
    } else {
        n = k;
    }

    i64 min_first = -1;
    i64 min_last = -1;
    for (i64 i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            i64 middle = n / i;
            i64 size = i;

            i64 first = middle - size + 1;
            if (first % 2 == 1) {
                min_first = first;
                min_last = first + size * 2 - 2;
            }
        }
    }

    if (min_first == -1) {
        cout << "none" << endl;
    } else {
        if (k < 0) {
            cout << (min_first) / 2 << endl; 
        } else {
            cout << (min_last + 1) / 2 << endl;
        }
    }
#ifdef DEBUG
    goto go;
#endif
}