#pragma GCC target("tune=native")
#include <bits/stdc++.h>

using namespace std;
using i32 = int32_t;
using u32 = uint32_t;
using i64 = int64_t;

namespace trandom {
    struct random {
        u32 seed = chrono::high_resolution_clock::now().time_since_epoch().count() ^ (u32)(make_unique<i32>().get() - (i32 *)0);
        mt19937 engine;
        uniform_int_distribution<i32> dist;

        random(i32 l = numeric_limits<i32>::min(), i32 r = numeric_limits<i32>::max()):
            engine(seed),
            dist(l, r) {

        }

        i32 operator() () {
            return dist(engine);
        }
    } next;
}

int main() {
#ifdef DEBUG
    assert(freopen("input", "r", stdin));
    assert(freopen("output", "w", stdout));
#endif
    cin.tie(nullptr)->sync_with_stdio(false);

    i64 a, b, c;
    cin >> a >> b >> c;
    assert(a % c != 0 && b % c != 0);

    i64 n = b - a;

    if (c % 2 == 0) {
        cout << n / 2 + n % 2 << endl;
    } else {
        i64 first = (a + c - 1) / c * c;
        i64 last = b / c * c;
        i64 dist = last - first;

        i64 ans = 0;
        ans += (first + 2 - a) / 2;
        ans += (b - last) / 2;
        ans += dist / c * ((c + 1) / 2);

        cout << ans << endl;
    }
}