#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

int64_t sqrtt(int64_t n){
    if (n < 0)
        return 0;
    int64_t l = 0;
    int64_t r = 1414214;
    while (r - l > 1){
        int64_t m = (r + l) / 2;
        int64_t x = m * m;
        if (x <= n && x >= 0)
            l = m;
        else
            r = m;
    }
    if (r * r <= n && (r * r) >= 0)
        return r;
    return l;
}

int main(){
    int64_t k;
    cin >> k;
    for (int64_t i = 0; i * i <= 2000000000000; i++){
        int64_t x = i * i - k;
        int64_t y = sqrtt(x);
        if (y * y == x){
            cout << i;
            return 0;
        }
    }
    if (k > 100000)
        cout << 0 / (k - k);
    cout << "none";
    return 0;
}
