#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int inf = 1e9;

void gener(int n, int k, int v, vector<int>& pairs, vector<vector<int>>& info) {
	if (v == n) {
		for (int i = 0; i < k; ++i) {
			bool good = true;
			int left = -inf, right = inf;
			for (int j = 0; j < n; ++j) {
				int num_1 = info[j][i];
				int num_2 = info[pairs[j]][i];
				left = max(left, min(num_1, num_2));
				right = min(right, max(num_1, num_2));
			}
			if (left > right)
				return;
		}
		cout << "YES\n";
		for (int i = 0; i < n; ++i)
			if (pairs[i] > i)
				cout << i + 1 << " " << pairs[i] + 1 << "\n";
		exit(0);
	}
	else if (pairs[v] == -1) {
		for (int to = v + 1; to < n; ++to)
			if (pairs[to] == -1) {
				pairs[v] = to;
				pairs[to] = v;
				gener(n, k, v + 1, pairs, info);
				pairs[v] = -1;
				pairs[to] = -1;
			}
	}
	else
		gener(n, k, v + 1, pairs, info);
}

void sol1(int n, int k, vector<vector<int>>& info) {
	if (n > 10)
		return;
	vector<int> pairs(n, -1);
	gener(n, k, 0, pairs, info);
	cout << "NO";
	exit(0);
}

void sol2(int n, int k, vector<vector<int>>& info) {
	if (k != 1)
		return;
	vector<pair<int, int>> new_info(n);
	for (int i = 0; i < n; ++i) {
		new_info[i].first == info[i][0];
		new_info[i].second = i;
	}
	sort(new_info.begin(), new_info.end());
	if (new_info[n / 2 - 1] <= new_info[n / 2]) {
		cout << "YES\n";
		for (int i = 0; i < n / 2; ++i)
			cout << new_info[i].second << " " << new_info[n - i - 1].second << "\n";
	}
	else
		cout << "NO";
	exit(0);
}

int main() {
	int n, k;
	cin >> n >> k;
	vector<vector<int>> info(n, vector<int>(k));
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < k; ++j)
			cin >> info[i][j];
	sol1(n, k, info);
	sol2(n, k, info);
}
