import java.io.*;
import java.util.*;


public class Main {

    public void solve() throws IOException {
        long mod = 1000000007;
        int n = nextInt();
        int m = nextInt();
        int k = nextInt() + 1;
        long [][] dp = new long[n][k];

        for (int i = 0; i < k; i++) {
            dp[0][i] = 1;
        }

        for (int i = 1; i < n; i++) {
            for (int j = 0; j < k; j++) {
                dp[i][j] = 0;
                for (int q = 0; q < k; q++) {
                    if ((q & j) == q) {
                        dp[i][j] += dp[i - 1][q];
                    }
                }
            }
        }

        int count = 0;
        for (int i = 0; i < k; i++) {
            count += dp[n - 1][i];
        }

        out.println(count);

//        for (int i = 0; i < n; i++) {
//            for (int j = 0; j < k; j++) {
//                System.out.print(dp[i][j] + " ");
//            }
//            System.out.println();
//        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new Main().run();
    }

}

