import java.io.*;
import java.util.*;


public class Main {

    Thing [] q;
    public void solution(int n) throws IOException{
        int k = nextInt();
        q = new Thing[n];
        for (int i = 0; i < n; i++) {
            q[i] = new Thing(k);
            for (int j = 0; j < k; j++) {
                q[i].q[j] = nextInt();
            }
        }
        Arrays.sort(q);
        used = new boolean[n];
        pair = new int[n / 2];
        if(func(0, n, k)) {
            out.println("YES");
            for (int i = 0; i < n / 2; i++) {
                out.println(i + 1 + " " + (pair[i] + 1));
            }
        } else {
            out.println("NO");
        }
    }

    boolean [] used;
    int [] pair;
    public boolean func(int k, int n, int k2) {
        if (k == n) {
            int q1 = Integer.MAX_VALUE;
            int q2 = Integer.MIN_VALUE;
            boolean mist = false;
            for (int t = 0; t < k2; t++) {
                for (int i = 0; i < n / 2; i++) {
                    q1 = Math.min(Math.max(q[i].q[t], q[pair[i]].q[t]), q1);
                    q2 = Math.max(Math.min(q[i].q[t], q[pair[i]].q[t]), q2);
                }
                if (q1 < q2) {
                    mist = true;
                }
            }
            if (mist) {
                return false;
            }
            return true;
        }

        for (int i = 0; i < n / 2; i++) {
            for (int j = n / 2; j < n; j++) {
                if (!used[i] && !used[j]) {
                    pair[i] = j;
                    used[i] = true;
                    used[j] = true;
                    if(func(k + 2, n, k2)) {
                        return true;
                    }
                    used[i] = false;
                    used[j] = false;
                }
            }
        }
        return false;
    }

    public class Thing implements Comparable{

        int [] q;
        int n;

        public Thing(int n) {
            this.n = n;
            q = new int[n];
        }

        @Override
        public int compareTo(Object o) {
            Thing t = (Thing) o;
            for (int i = 0; i < n; i++) {
                if (q[i] - t.q[i] == 0) {
                    continue;
                }
                return q[i] - t.q[i];
            }
            return 0;
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        if (n <= 10) {
            solution(n);
            return;
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new Main().run();
    }

}


