#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <cmath>


using namespace std;

long long int K, L, M, N;

vector<vector<int>> graf;
vector <bool> used;
vector <vector<int>> dp;

void DFS(int v) {
	if (used[v]) return;
	used[v] = 1;
	int cnt0, cnt1;
	cnt0 = cnt1 = 0;
	for (auto to : graf[v]) {
		DFS(to);
		cnt0 += dp[1][to];
		cnt1 += dp[0][to];
	}
	dp[0][v] = cnt0;
	dp[1][v] = cnt1;
	dp[1][v] += 1;
}

vector <int> color;

bool cycle_check(int v) {
	if (color[v]) return 1;
	color[v] = 1;
	bool answ = 0;
	for (auto to : graf[v]) {
		answ = answ || cycle_check(to);
	}
	return answ;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	long long n;
	cin >> n;
	graf = vector<vector<int>>(n);
	vector <int> roots;
	for (int i = 0; i < n; i++) {
		int whom;
		cin >> whom;
		if (whom == -1) {
			roots.push_back(i);
		}
		else {
			whom--;
			graf[whom].push_back(i);
		}
	}
	dp = vector <vector<int>>(2, vector<int> (n));
	int sum = 0;
	used = vector<bool>(n);

	for (auto i : roots) {
		DFS(i);
		sum += max(dp[0][i], dp[1][i]);
	}

	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			color = vector <int>(n);
			if (cycle_check(i)) {
				DFS(i);
				sum += dp[0][i];
			}
		}
	}

	cout << sum;
	return 0;
}
