#include <bits/stdc++.h>
#define u unsigned
#define ll long long
#define ld long double
#define vec vector
#define sz(v) (ll)v.size()
#define rep(i, a, b) for(ll i = a; i < b; ++i)
#define x first
#define y second
#define endl '\n'
using namespace std;

template<class T> inline istream &operator>>(istream &_in, vec<T> &_v)
{
    rep(i, 0, sz(_v))
    {
        _in >> _v[i];
    }
    return _in;
}

template<class T1, class T2> inline istream &operator>>(istream &_in, pair<T1, T2> &_p)
{
    _in >> _p.x >> " " >> _p.y;
    return _in;
}

template<class T> inline ostream &operator<<(ostream &_out, const vec<T> &_v)
{
    if(!sz(_v))
        return _out;
    _out >> *_v.begin();
    for(auto i = ++_v.begin(); i < _v.end(); ++i)
        _out << " " << *i;
    return _out;
}

template<class T1, class T2> inline ostream &operator<<(ostream &_out, const pair<T1, T2> &_p)
{
    _out << _p.x << " " << _p.y;
    return _out;
}

const ld EPS = 1e-9;

ll solve(ll k)
{
    if(abs(k) % 4 == 2)
    {
        return -1;
    }
    if(k > 0)
    {
        bool ok = true;
        for(ll x = 3; x * x <= k; ++x, ++x)
        {
            if(k % x == 0)
            {
                ok = 0;
                break;
            }
        }
        if(ok)
        {
            if(k % 2 != 0)
            {
                return (k + 1) / 2;
            }
            ll pow = 2;
            ll n = 0;
            for(; k % pow == 0; pow <<= 1, ++n);
            pow >>= 1;
            return k + n;
        }
    }
    rep(a, (k < 0) ? (ll)(sqrt(abs(k))) : 0, LLONG_MAX)
    {
        ld sq = sqrt(k + a * a);
        if(abs(sq - int(sq)) <= EPS)
        {
            return sq;
        }
    }
}

ll solve2(ll k)
{
    if(abs(k) % 4 == 2)
    {
        return -1;
    }
    rep(a, (k < 0) ? (ll)(sqrt(abs(k))) : 0, LLONG_MAX)
    {
        ld sq = sqrt(k + a * a);
        if(abs(sq - int(sq)) <= EPS)
        {
            return sq;
        }
    }
}

ll slow_solve(ll k)
{
    if(abs(k) % 4 == 2)
    {
        return -1;
    }
    ll shift = 1;
    ll now = k;
    for(;; now += shift, ++shift, ++shift)
    {
        if(now < 0)
            continue;
        auto sq = sqrt(now);
        if(abs(sq - (ll)sq) <= EPS)
        {
            return sq;
        }
    }
}

int main() {
    ll k;
    cin >> k;
    ll lu = slow_solve(k);
    if(lu == -1)
    {
        cout << "none" << endl;
    }
    else
    {
        cout << lu << endl;
    }
}

int debug()
{
    srand(time(NULL));
    while(true)
    {
        auto n = rand() % 1000;
        if(solve(n) != solve2(n))
        {
            cout << n << endl;
        }
    }
}

int debil()
{
    cout << solve(1389956917) << endl << solve2(1389956917) << endl;
}