//{

#include <bits/stdc++.h>

#define all(x) (x).begin (), (x).end ()
#define rall(x) (x).rbegin (), (x).rend ()

#define LOCAL

using namespace std;

using lli = long long;
using ld = long double;

mt19937 rnd (time (nullptr));

//}

vector <vector <int>> graph, graph_t;
vector <bool> used;
vector <int> order;
vector <int> comp;
vector <vector <int>> buffer;
vector <int> sz;
vector <vector <int>> dp;

void DFS1 (int v)
{
    used[v] = true;
    for (int u : graph[v])
    {
        if (!used[u])
            DFS1 (u);
    }
    order.push_back (v);
}

void DFS2 (int v, int c)
{
    used[v] = true;
    comp[v] = c;
    buffer.back ().push_back (v);
    sz[c]++;
    for (int u : graph_t[v])
    {
        if (!used[u])
            DFS2 (u, c);
    }
}

void DFS3 (int v)
{
    dp[v][1] = 1;
    for (int u : graph[v])
    {
        assert (sz[comp[u]] == 1);
        DFS3 (u);
        dp[v][1] += dp[u][0];
        dp[v][0] += max (dp[u][0], dp[u][1]);
    }
}

inline void Solve ()
{
    int n = 0;
    cin >> n;
    graph.resize (n);
    graph_t.resize (n);
    used.resize (n);
    comp.resize (n);
    for (int i = 0; i < n; i++)
    {
        int p = 0;
        cin >> p;
        if (p == -1)
            continue;
        p--;
        graph[p].push_back (i);
        graph_t[i].push_back (p);
    }

    for (int i = 0; i < n; i++)
    {
        if (!used[i])
            DFS1 (i);
    }
    reverse (all (order));
    used.assign (n, false);
    int color = 0;
    for (int v : order)
    {
        if (!used[v])
        {
            buffer.push_back (vector <int> ());
            sz.push_back (0);
            DFS2 (v, color);
            color++;
        }
    }

    dp.resize (n, vector <int> (2));
    for (int i = 0; i < n; i++)
    {
        if (sz[comp[i]] >= 2)
        {
            dp[i][0] = 0;
            dp[i][1] = 1;
            for (int u : graph[i])
            {
                if (sz[comp[u]] == 1)
                {
                    DFS3 (u);
                    dp[i][1] += dp[u][0];
                    dp[i][0] += max (dp[u][0], dp[u][1]);
                }
            }
            //cout << i + 1 << ' ' << dp[i][0] << ' ' << dp[i][1] << '\n';
        }
        else if (sz[comp[i]] == 1)
        {
            DFS3 (i);
        }
    }

    int result = 0;
    for (int i = 0; i < buffer.size (); i++)
    {
        if (buffer[i].size () == 1)
        {
            int v = buffer[i][0];
            //cout << v + 1 << ' ' << graph_t[v].size () << '\n';
            if (graph_t[v].empty ())
                result += max (dp[v][0], dp[v][1]);
            continue;
        }
        int ans1 = 0;
        {
            // y/n
            int first = dp[buffer[i][0]][1], second = dp[buffer[i][0]][0];
            for (int j = 1; j < buffer[i].size (); j++)
            {
                int v = buffer[i][j];
                int f = first, s = second;
                second = max (f, s) + dp[v][0];
                if ((buffer[i].size () % 2 != 0) && (j + 1 == buffer[i].size ()))
                    continue;
                first = s + dp[v][1];
            }
            ans1 = max (first, second);
        }
        int ans2 = 0;
        {
            // y/n
            int first = dp[buffer[i][0]][0], second = dp[buffer[i][0]][0];
            for (int j = 1; j < buffer[i].size (); j++)
            {
                int v = buffer[i][j];
                int f = first, s = second;
                second = max (f, s) + dp[v][0];
                first = s + dp[v][1];
            }
            ans2 = max (first, second);
        }
        result += max (ans1, ans2);
    }
    cout << result;
}

signed main ()
{
#ifndef LOCAL
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    cout.tie (nullptr);
#endif
    Solve ();
    return 0;
}
