#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 2e5 + 1;

void get_div(int a, vector <int> &div) {
    int i = 1;
    while (i * i <= a) {
        if (a % i == 0) {
            div.push_back(i);
            if (i != a / i) {
                div.push_back(a / i);
            }
        }
        ++i;
    }
}

void get_prime(int a, vector <int> &div) {
    int i = 2;
    while (i * i <= a) {
        if (a % i == 0) {
            div.push_back(i);
            while (a % i == 0) {
                a /= i;
            }
        }
        ++i;
    }
    if (a != 1) {
        div.push_back(a);
    }
}

void print(vector <int> &a) {
    for (auto i : a) {
        cout << i << " ";
    }
    cout << "\n";
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    int n, m;
    cin >> n >> m;

    vector <int> a(m), b(n);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    if (n == m) {
        bool t1 = 1, t2 = 1;
        for (int i = 0; i < n; ++i) {
            if (a[i] != b[i]) {
                t1 = 0;
            }
            if (a[i] != b[n - i - 1]) {
                t2 = 0;
            }
        }

        if (t1) {
            cout << n << "\n";
            for (int i = 0; i < n; ++i) {
                cout << n << " ";
            }
        }
        else if (t2) {
            cout << 2 * n << "\n";
            for (int i = 0; i < n; ++i) {
                cout << n - i << " ";
            }
            for (int i = 0; i < n; ++i) {
                cout << n << " ";
            }
        }
    }
    return 0;
}
