#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <bitset>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 2e5 + 1;
const int MOD = 1e9 + 7;

void print(vector <int> &a) {
    for (auto i : a) {
        cout << i << " ";
    }
    cout << "\n";
}

void print_cur(vector <int> &pos) {
    int n = pos.size();
    vector <int> cur(n);
    for (int i = 0; i < n; ++i) {
        cur[pos[i]] = i;
    }

    for (auto i : cur) {
        cout << i + 1 << " ";
    }
    cout << endl;
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    int n, m;
    cin >> n >> m;

    vector <int> a(m), b(n);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
        --a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        --b[i];
    }

    /*if (n == m) {
        bool t1 = 1, t2 = 1;
        for (int i = 0; i < n; ++i) {
            if (a[i] != b[i]) {
                t1 = 0;
            }
            if (a[i] != b[n - i - 1]) {
                t2 = 0;
            }
        }

        if (t1) {
            cout << n << "\n";
            for (int i = 0; i < n; ++i) {
                cout << n << " ";
            }
            return 0;
        }
        else if (t2) {
            cout << 2 * n - 1 << "\n";
            for (int i = 0; i < n - 1; ++i) {
                cout << n - i << " ";
            }
            for (int i = 0; i < n; ++i) {
                cout << n << " ";
            }
            return 0;
        }
    }*/

    vector <int> L(n, -1), R(n, -1);
    for (int i = 0; i < m; ++i) {
        if (i - 1 >= 0) {
            L[a[i]] = a[i - 1];
        }
        if (i + 1 < m) {
            R[a[i]] = a[i + 1];
        }
    }

    vector <int> ans, pos(n, -1);
    int ind = 0;
    for (int i = 0; i < n; ++i) {
        pos[b[i]] = i;
        if (b[i] == a[0]) {
            ind = i;
        }
    }

    for (int i = 0; i < ind; ++i) {
        for (int j = 0; j < n; ++j) {
            --pos[j];
        }

        if (L[b[i]] != -1 && pos[L[b[i]]] >= pos[a[0]]) {
            pos[b[i]] = pos[L[b[i]]] + 1;
        }
        else if (R[b[i]]!= -1 && pos[R[b[i]]] > pos[a[0]]) {
            pos[b[i]] = pos[R[b[i]]] - 1;
        }
        else {
            pos[b[i]] = n - 1;
        }
        for (int j = 0; j < n; ++j) {
            if (j != b[i] && pos[j] >= pos[b[i]]) {
                ++pos[j];
            }
        }
        ans.push_back(pos[b[i]]);
    }
    int j = 0;

    vector <int> cur(n);
    for (int i = 0; i < n; ++i) {
        cur[pos[i]] = i;
    }

    for (int i = 0; i < n; ++i) {
        if (cur[i] == a[j]) {
            ++j;
            if (j == m) {
                ans.push_back(n - 1);
                break;
            }
        }
        ans.push_back(n - 1);
    }

    cout << ans.size() << "\n";
    for (auto i : ans) {
        cout << i + 1 << ' ';
    }
    return 0;
}
