#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <bitset>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 2e5 + 1;
const int MOD = 1e9 + 7;

void print(vector <int> &a) {
    for (auto i : a) {
        cout << i << " ";
    }
    cout << "\n";
}

int n, m;
ll k, ans = 0;

vector <int> num(ll a) {
    vector <int> ans;
    for (int i = 40; i >= 0; --i) {
        if (a - (1 << i) >= 0) {
            ans.push_back(1);
        }
        else if (ans.size()) {
            ans.push_back(0);
        }
    }
    return ans;
}

bool leq(vector <int> &n1, vector <int> &n2) {
    if (n1.size() == n2.size()) {
        for (int i = n1.size() - 1; i >= 0; --i) {
            if (n1[i] == n2[i]) continue;
            return (n1[i] < n2[i]);
        }
        return 1;
    }
    return n1.size() < n2.size();
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    cin >> n >> m >> k;

    if (m == 0) {
        if (k == 0) {
            cout << 1;
            return 0;
        }

        vector <ll> dp1(k + 1, 0);
        vector <ll> dp2(k + 1, 0);
        for (int i = 0; i <= k; ++i) {
            dp1[i] = 1;
        }
        for (int i = 1; i < n; ++i) {
            for (int j = 0; j <= k; ++j) {
                for (int u = 0; u <= j; ++u) {
                    if ((u & j) == u) {
                        dp2[j] += dp1[u];
                        dp2[j] %= MOD;
                    }
                }
            }
            dp1 = dp2;
            dp2.clear();
            dp2.resize(k + 1, 0);
        }
        ll res = 0;
        for (int i = 0; i <= k; ++i) {
            res += dp1[i];
            res %= MOD;
        }
        cout << res;
        return 0;
    }

    return 0;
}
