#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 5004;
const int MOD = 1e9 + 7;

void print(vector <int> &a) {
    for (auto i : a) {
        cout << i << " ";
    }
    cout << "\n";
}

void z_fun(string &s, vector <int> &z) {
    int n = s.size();
    z.clear();
    z.resize(n);

    int l = 0, r = -1;
    z[0] = n;

    for (int i = 1; i < n; ++i) {
        z[i] = 0;
        if (i <= r) {
            z[i] = min(z[i - l], r - i + 1);
        }
        while (z[i] + i < n && s[z[i] + i] == s[z[i]]) {
            ++z[i];
        }
        if (i + z[i] - 1 > r) {
            l = i;
            r = i + z[i] - 1;
        }
    }
}

void find_sub(string t, string s) {
    int sz = t.size();
    string cur = t + '#' + s;
    vector <int> z;

    z_fun(cur, z);

    for (int i = sz; i < z.size(); ++i) {
        if (z[i] == sz) {
            cout << i << " ";
        }
    }

}

int dp[MAXON][MAXON][2];
int p0[MAXON][MAXON];
int p1[MAXON][MAXON];

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    int n, k;
    cin >> n >> k;

    dp[k][k][0] = 1; //down
    dp[k][k][1] = 1; //up

    p0[k][k] = 1;
    p1[k][k] = 1;
    for (int sum = k; sum <= n; ++sum) {
        for (int last = 1; last <= sum; ++last) {
            if (sum == last && last == k) {
                continue;
            }
            dp[sum][last][1] = p0[sum - last][min(last - 1, sum - last)] % MOD;
            if (sum - last >= (last + 1)) {
                dp[sum][last][0] = ((p1[sum - last][sum - last] - p1[sum - last][last]) % MOD + MOD) % MOD;
            }

            p0[sum][last] = p0[sum][last - 1] + dp[sum][last][0];
            p1[sum][last] = p1[sum][last - 1] + dp[sum][last][1];

            p0[sum][last] %= MOD;
            p1[sum][last] %= MOD;

            /*for (int i = 1; i <= sum - last; ++i) {
                if (i < last) {
                    dp[sum][last][1] += dp[sum - last][i][0];
                    dp[sum][last][1] %= MOD;
                }
                else if (i > last) {
                    dp[sum][last][0] += dp[sum - last][i][1];
                    dp[sum][last][0] %= MOD;
                }
            }*/
        }
    }

    /*for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= i; ++j) {
            cout << "sum " << i << " last " << j << " (up) " << dp[i][j][1] << endl;
            cout << "sum " << i << " last " << j << " (down) " << dp[i][j][0] << endl;
        }
    }*/

    ll ans = 0;
    for (int last = 1; last <= n; ++last) {
        if (n == last && last == k) {
            ++ans;
            ans %= MOD;
            continue;
        }
        ans += dp[n][last][0];
        ans %= MOD;
        ans += dp[n][last][1];
        ans %= MOD;
    }
    cout << ans;
    return 0;
}
