#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 5004;
const int MOD = 1e9 + 7;

vector <vector <int>> g;
vector <int> color;
int cnt = 0, c;

void dfs(int v) {
    color[v] = c;
    ++cnt;
    for (auto i : g[v]) {
        if (color[i] == 0) {
            dfs(i);
        }
    }
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    int n;
    cin >> n;

    g.resize(n);
    color.resize(n, 0);
    set <pair <int, int>> s;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        if (x >= 0) {
            s.insert({min(i, x), max(i, x)});
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (s.count({i, j})) {
                continue;
            }
            g[i].push_back(j);
            g[j].push_back(i);
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (color[i] == 0) {
            ++c;
            cnt = 0;
            dfs(i);
            ans = max(ans, cnt);
        }
    }
    cout << ans;

    return 0;
}
