#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 5004;
const int MOD = 1e9 + 7;

int cnt(ll num, int n) {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += ((num >> i) & 1);
    }
    return ans;
}

void p(ll num, int n) {
    for (int i = 0; i < n; ++i) {
        cout << ((num >> i) & 1);
    }
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    int n;
    cin >> n;

    if (n <= 20) {
        vector <int> a(n);
        vector <set <int>> s(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            --a[i];
            if (a[i] >= 0){
                s[a[i]].insert(i);
            }
        }

        vector <bool> dp((1LL << n), 0);
        dp[0] = 1;
        for (ll mask = 0; mask < (1LL << n); ++mask) {
            if (dp[mask]) {
                for (int i = 0; i < n; ++i) {
                    if (a[i] == -1 || ((1LL << a[i]) & mask) == 0) {
                        bool good = 1;
                        for (auto elem : s[i]) {
                            if ((1LL << elem) & mask) {
                                good = 0;
                                break;
                            }
                        }
                        if (good) {
                            dp[mask | (1LL << i)] = 1;
                        }
                    }
                }
            }
        }
        int ans = 0;
        for (ll mask = 0; mask < (1LL << n); ++mask) {
            if (dp[mask]) {
                ans = max(ans, cnt(mask, n));
            }
        }
        cout << ans;
        return 0;
    }

    vector <int> a(n);
    bool good = 1, cool = 1;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (i && a[i] != i) {
            good = 0;
        }
        if (a[0] != -1) {
            good = 0;
        }
        --a[i];
        if (a[i] >= i) {
            cool = 0;
        }
    }
    /*if (good) {
        cout << (n + 1) / 2;
        return 0;
    }*/

    int color = 1;
    vector <int> used(n, 0);
    for (int i = 0; i < n; ++i) {
        if (a[i] == -2) {
            used[i] = color;
            color += 2;
        }
        else {
            if (used[a[i]] % 2) {
                used[i] = used[a[i]] + 1;
            }
            else {
                used[i] = used[a[i]] - 1;
            }
        }
    }

    vector <int> cnt(color + 2, 0);
    for (auto i : used) {
        cnt[i]++;
    }
    int ans = 0;
    for (int i = 1; i + 1 < cnt.size(); i += 2) {
        ans += max(cnt[i], cnt[i + 1]);
    }
    cout << ans;
    return 0;
}
