#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <sstream>
#include <iomanip>
#include <random>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define FIXED cout << fixed << setprecision(20)
#define RANDOM srand(23423)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define eps 1e-9
#define mod 1000000007
#define inf 4000000000000000007ll
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f first
#define s second
#define shuffle(a) \
	for (int i = 0; i < sz(a); ++i) \
		swap(a[i], a[rand() % sz(a)])

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &a) { return str >> a.f >> a.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }
struct zet {
	int val;
	zet(ll k = 0) { val = k; }
	zet operator+=(const zet &v) { val += v.val; if (val >= mod) val -= mod; return *this; }
	zet operator-=(const zet &v) { val -= v.val; if (val < 0) val += mod; return *this; }
	zet operator*=(const zet &v) { val = (val * (ll)v.val) % mod; return *this; }

	friend zet operator+(zet a, const zet &b) {
		return a += b;
	}
	friend zet operator-(zet a, const zet &b) {
		return a -= b;
	}
	friend zet operator*(zet a, const zet &b) {
		return a *= b;
	}
	friend zet mpow(zet a, ll n) {
		zet ans = 1;
		for (; n > 0; a *= a, n >>= 1) 
			if (n & 1) ans *= a;
		return ans;
	}
	friend zet inv(const zet &a) {
		return mpow(a, mod - 2);
	}
	friend zet operator/(zet a, const zet &b) {
		return a *= inv(b);
	}
	friend istream& operator>>(istream& str, zet &z) {
		ll k;
		str >> k;
		z = zet(k);
		return str;
	}
	friend ostream& operator<<(ostream& str, const zet &z) {
		return str << z.val;
	}
};

zet solveup(int n, int k) {
	vector<vector<vector<zet>>> dp(n, vector<vector<zet>>(n + 1, vector<zet>(n + 1)));
	dp[0][k][k] = 1;
	for (int i = 1; i < n; ++i)
		for (int last = 1; last <= n; ++last)
			for (int sum = 1; sum <= n; ++sum) 
				if (i & 1) {
					for (int t = last + 1; sum + t <= n; ++t)
						dp[i][t][sum + t] += dp[i - 1][last][sum];
				} else {
					for (int t = min(n - sum, last - 1); t > 0; --t)
						dp[i][t][sum + t] += dp[i - 1][last][sum];
				}
	zet ans = 0;
	for (auto i : dp)
		for (auto j : i)
			ans += j[n];
	return ans;
}

zet solvedown(int n, int k) {
	vector<vector<vector<zet>>> dp(n, vector<vector<zet>>(n + 1, vector<zet>(n + 1)));
	dp[0][k][k] = 1;
	for (int i = 1; i < n; ++i)
		for (int last = 1; last <= n; ++last)
			for (int sum = 1; sum <= n; ++sum) 
				if (i & 1) {
					for (int t = min(n - sum, last - 1); t > 0; --t)
						dp[i][t][sum + t] += dp[i - 1][last][sum];
				} else {
					for (int t = last + 1; sum + t <= n; ++t)
						dp[i][t][sum + t] += dp[i - 1][last][sum];
				}
	zet ans = 0;
	for (auto i : dp)
		for (auto j : i)
			ans += j[n];
	return ans;
}

signed main() {
	FAST; FIXED; RANDOM;
	int n, k;
	cin >> n >> k;
	if (n == k) {
		cout << 1;
		return 0;
	}
	cout << solveup(n, k) + solvedown(n, k);
	return 0;
}