#include <stdio.h>
#include <vector>
#include <random>
#include <utility>

using std::pair;

int n, m, root = -1, *a, *b;

struct node {
	int l = -1, r = -1, p = -1, sz = 1, y;
	node(): y(rand()) {}
};

std::vector<node> tr;

void update(int n1) {
	if (n1 == -1) {
		return;
	}
	tr[n1].sz = 1;
	if (tr[n1].l != -1) {
		tr[n1].sz += tr[tr[n1].l].sz;
		tr[tr[n1].l].p = n1;
	}
	if (tr[n1].r != -1) {
		tr[n1].sz += tr[tr[n1].r].sz;
		tr[tr[n1].r].p = n1;
	}
}

int merge(int n1, int n2) {
	if (n1 == -1) {return n2;}
	if (n2 == -1) {return n1;}
	if (tr[n1].y > tr[n2].y) {
		if (tr[n1].r != -1) {
			tr[tr[n1].r].p = -1;
		}
		tr[n1].r = merge(tr[n1].r, n2);
		update(n1);
		return n1;
	}
	if (tr[n2].l != -1) {
		tr[tr[n2].l].p = -1;
	}
	tr[n2].l = merge(n1, tr[n2].l);
	update(n2);
	return n2;
}

pair<int, int> split(int n1) {
	pair<int, int> ans(tr[n1].l, tr[n1].r);
	if (tr[n1].l != -1) {
		tr[tr[n1].l].p = -1;
	}
	if (tr[n1].r != -1) {
		tr[tr[n1].r].p = -1;
	}
	tr[n1].l = tr[n1].r = -1;
	update(n1);
	bool ft = true;
	int nn1 = n1;
	while (tr[n1].p != -1) {
		if (tr[tr[n1].p].r == n1)  {
			if (n1 == ans.second || ft) {
				tr[tr[n1].p].r = ans.first;
				int n2 = n1;
				n1 = tr[n1].p;
				tr[n2].p = -1;
			} else {
				n1 = tr[n1].p;
			}
			update(n1);
			ans.first = n1;
		} else {
			if (n1 == ans.first || ft) {
				tr[tr[n1].p].l = ans.second;
				int n2 = n1;
				n1 = tr[n1].p;
				tr[n2].p = -1;
			} else {
				n1 = tr[n1].p;
			}
			update(n1);
			ans.second = n1;
		}
		ft = false;
	}
	tr[nn1].p = -1;
	update(nn1);
	update(ans.first);
	update(ans.second);
	return ans;
}

void print(int no, int cn) {
	if (no == -1) return;
	print(tr[no].l, cn + 3);
	for (int i = 0; i < cn; i++) {
		printf(" ");
	}
	printf("%d/%d\n", no, tr[no].sz);
	print(tr[no].r, cn + 3);
}

void up(int no, std::vector<int> &ans) {
	pair<int, int> pa = split(no);
	if (pa.first != -1) {
		ans.push_back(tr[pa.first].sz + 1);
	} else {
		ans.push_back(1);
	}
	root = merge(no, pa.first);
	root = merge(root, pa.second);
}

void solve() {
	int cnt[n];
	for (int i = 0; i < n; i++) {
		cnt[i] = 0;
	}
	tr.assign(n, node());
	for (int i = 0; i < n; i++) {
		root = merge(root, b[i]);
	}
	for (int i = 0; i < m; i++) {
		cnt[a[i]]++;
	}
	std::vector<int> ans;
	int last = n - 1;
	while (last >= 0 && cnt[b[last]] == 0) {
		last--;
	}
	for (int i = m - 1; i >= 0; i--) {
		cnt[a[i]]--;
		up(a[i], ans);
		if (a[i] == b[last]) {
			last--;
			while (last >= 0 && cnt[b[last]] == 0) {
				up(b[last], ans);
				last--;
			}
		}
	}
	printf("%d\n", (int)ans.size());
	for (int i = (int)ans.size() - 1; i >= 0; i--) {
		printf("%d ", ans[i]);
	}
}

void solvesq() {
	int num[n];
	int ze = b[0];
	for (int i = 0; i < n; i++) {
		num[b[i]] = i;
	}
	std::vector<int> ans;
	for (int i = 0; i < m; i++) {
		while (ze != a[i]) {
			int de = num[a[i]];
			for (int j = i + 1; j < m; j++) {
				if (a[j] == ze) {
					break;
				} else if (de < num[a[j]]) {
					de = num[a[j]];
				}
			}
			if (de < 0) {
				return;
			}
			num[ze] = de + 1;
			int ze1 = -1;
			for (int j = 0; j < n; j++) {
				if (num[j] <= de) {
					num[j]--;
				}
				if (num[j] == 0) {
					ze1 = j;
				}
			}
			num[ze]--;
			ze = ze1;
			ans.push_back(de + 1);
		}
		if (i == m - 1 || a[i] == a[i + 1]) {
			ans.push_back(1);
		}
	}
	printf("%d\n", (int)ans.size());
	for (int i : ans) {
		printf("%d ", i);
	}
}

bool solve1() {
	if (n != m) {
		return false;
	}
	for (int i = 0; i < n; i++) {
		if (a[i] != b[i]) {
			return false;
		}
	}
	printf("%d\n", n);
	for (int i = 0; i < n; i++) {
		printf("%d ", n);
	}
	return true;
}

bool solve2() {
	if (n != m) {
		return false;
	}
	for (int i = 0; i < n; i++) {
		if (a[i] != b[n - i - 1]) {
			return false;
		}
	}
	printf("%d\n", 2 * n - 1);
	for (int i = 0; i < n - 1; i++) {
		printf("%d ", n - i);
	}
	for (int i = 0; i < n; i++) {
		printf("%d ", n);
	}
	return true;
}

int main() {
	scanf("%d%d", &n, &m);
	a = new int[m];
	b = new int[n];
	for (int i = 0; i < m; i++) {
		scanf("%d", &a[i]);
		a[i]--;
	}
	for (int i = 0; i < n; i++) {
		scanf("%d", &b[i]);
		b[i]--;
	}
	if (solve1()) {return 0;}
	if (solve2()) {return 0;}
	if (m <= 2000 && n <= 2000) {
		solvesq();
		return 0;
	}
	solve();
	return 0;
}
