#include <stdio.h>
#include <vector>
#include <utility>

const int WHITE = 1, GRAY = 2, BLACK = 3;

std::vector<int> *graph;
int *used, color = 4, uu, vv;
bool *bad;

bool ch(int u, int v) {
	return (u != uu || v != vv) && (u != vv || v != uu);
}

void dfs(int v) {
	used[v] = 1;
	for (int u : graph[v]) {
		if (used[u] == 0) {
			dfs(u);
		}
	}
}

bool cycle(int v, int p) {
	used[v] = GRAY;
	for (int u : graph[v]) {
		if (used[u] == GRAY && u != p) {
			uu = u;
			vv = v;
			return true;
		} else if (used[u] == WHITE && cycle(u, v)) {
			return true;
		}
	}
	return false;
}

std::pair<int, bool> indset(int v) {
	used[v] = color;
	int ans = 0;
	bool flag = !bad[v];
	int cnt = 0;
	for (int u : graph[v]) {
		if (!ch(u, v)) {
			cnt++;
		}
		if (used[u] != color && (cnt >= 2 || ch(u, v))) {
			std::pair<int, bool> p = indset(u);
			flag &= !p.second;
			ans += p.first;
		}
	}
	return std::make_pair(ans + flag, flag);
}

int main() {
	int n;
	scanf("%d", &n);
	graph = new std::vector<int>[n];
	used = new int[n]();
	bad = new bool[n]();
	for (int i = 0; i < n; i++) {
		int a;
		scanf("%d", &a);
		if (a != -1) {
			a--;
			graph[i].push_back(a);
			graph[a].push_back(i);
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		if (used[i] == 0) {
			dfs(i);
			if (cycle(i, -1)) {
				bad[uu] = true, bad[vv] = true;
				int a1 = indset(i).first;
				bad[uu] = false;
				color++;
				int a2 = indset(i).first;
				a1 = a2 > a1 ? a2 : a1;
				bad[uu] = true, bad[vv] = false;
				color++;
				int a3 = indset(i).first;
				color++;
				ans += a3 > a1 ? a3 : a1;
			} else {
				ans += indset(i).first;
				color++;
			}
		}
	}
	printf("%d", ans);
	return 0;
}
