#include <stdio.h>
#include <algorithm>
#include <vector>
#include <set>
#include <random>

int n, k, *bo, **arr, *pa, *used, color = 1, *p;
std::vector<int> sec;
std::set<int> nus, us;

bool check(int u, int v) {
	for (int i = 0; i < k; i++) {
		if ((arr[p[u]][i] < bo[i] && arr[p[v]][i] < bo[i]) || (arr[p[u]][i] > bo[i] && arr[p[v]][i] > bo[i])) {
			return false;
		}
	}
	return true;
}

bool try_kuhn(int v) {
	used[v] = color;
	/*for (int u : sec) {
		if (check(u, v) && (pa[u] == -1 || (used[pa[u]] != color && try_kuhn(pa[u])))) {
			pa[u] = v;
			return true;
		}
	}*/
	for (int u : nus) {
		if (check(u, v) && pa[u] == -1) {
			pa[u] = v;
			nus.erase(u);
			us.insert(u);
			return true;
		}
	}
	for (int u : us) {
		if (check(u, v) && (used[pa[u]] != color && try_kuhn(pa[u]))) {
			pa[u] = v;
			return true;
		}
	}
	return false;
}

int main() {
	scanf("%d%d", &n, &k);
	srand(n * 179 + k);
	arr = new int*[n];
	used = new int[n]();
	pa = new int[n];
	bo = new int[k];
	p = new int[n];
	for (int i = 0; i < n; i++) {
		pa[i] = -1;
		p[i] = i;
		arr[i] = new int[k];
		for (int j = 0; j < k; j++) {
			scanf("%d", &arr[i][j]);
		}
	}
	std::random_shuffle(p, p + n);
	for (int i = 0; i < k; i++) {
		int a[n];
		for (int j = 0; j < n; j++) {
			a[j] = arr[j][i];
		}
		std::nth_element(a, a + n / 2, a + n);
		bo[i] = a[n / 2];
	}
	sec.reserve(n / 2);
	for (int i = 0; i < n; i++) {
		if (arr[p[i]][0] >= bo[0]) {
			sec.push_back(i);
			nus.insert(i);
		}
	}
	for (int i = 0; i < n; i++) {
		if (arr[p[i]][0] < bo[0]) {
			if (!try_kuhn(i)) {
				printf("NO");
				return 0;
			}
			color++;
		}
	}
	printf("YES\n");
	for (int i = 0; i < n; i++) {
		if (pa[i] != -1) {
			printf("%d %d\n", p[i] + 1, p[pa[i]] + 1);
		}
	}
	return 0;
}
