#include <iostream>
#include <vector>
#include <cmath>
#include <climits>
using namespace std;

typedef long long ll;
typedef long double lld;

ll sqr(ll x) {
    if (x < 0)
        return 0;
    ll l = 0, r = 3ll*1e9, m;
    while (l < r - 1ll) {
        m = (l + r) >> 1;
        if (m * m > x)
            r = m;
        else
            l = m;
    }
    return l;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll k, x, n, s;
    long double sq;
    cin >> k;

    if (k < 0) {
        n = 0;
    } else {
        n = sqrt((lld)k);
        if (n * n < k)
            ++n;
    }
    ll end_ = 2*1e9;
    if (end_ - n > 1e8)
        end_ = n + 1e8;
    for (int p = 1; p < 1e7; ++p, ++n) {
        s = sqr(n * n - k);
        if (s*s == n*n - k) {
            cout << n << endl;
            return 0;
        }
    }
    cout << "none\n";
    return 0;
}
