#pragma GCC(optimize, "Ofast, unroll-loops")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <numeric>
#include <functional>
#include <iomanip>
#include <random>
#include <string>
#include <math.h>
#include <bitset>
#define pb push_back
#define pf push_front
#define sz(a) (ll)((a).size())
#define all(a) ((a).begin(), (a).end())
#define popb pop_back
#define popf pop_front
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#define endl "\n"
#define heap priority_queue
#define hash_set unordered_set
#define hash_map unordered_map
#define ft first
#define sd second
#define die(f) if (f) for (;;) {}
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef vector<ll> vll;
typedef vector<ld> vld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
const ll inf = numeric_limits<ll>::max() / 2;
const ld pi = acosl(-1);
const ld eps = 1e-9;
template<typename T> ll mineq(T& a, T b) { if (a > b) return a = b, 1; return 0; }
template<typename T> ll maxeq(T& a, T b) { if (a < b) return a = b, 1; return 0; }

inline void read(), solve();

signed main() {
	fast;
	read();
	solve();
	return 0;
}

struct graph {
	ll n;
	vector<vll> adj;
	graph() {}
	graph(ll n_) {
		n = n_;
		adj.resize(n);
	}
	void add(ll v, ll u) {
		adj[v].pb(u);
		adj[u].pb(v);
	}
};

ll n;
vll a;
graph g;
vll used;
vll mt;
ll mark = 0;

void build() {
	g = graph(2 * n);
	for (ll v = 0; v < n; v++) {
		ll u = a[v];
		if (u == -2) {
			continue;
		}
		g.add(v, n + u);
	}
}

ll kuhn(ll v) {
	if (used[v] == mark) {
		return 0;
	}
	used[v] = mark;
	for (ll u : g.adj[v]) {
		if (mt[u] == -1) {
			mt[v] = u;
			mt[u] = v;
			return 1;
		}
	}
	for (ll u : g.adj[v]) {
		if (kuhn(mt[u])) {
			mt[v] = u;
			mt[u] = v;
			return 1;
		}
	}
	return 0;
}

void matching() {
	used.assign(g.n, 0);
	mark = 1;
	mt.assign(g.n, -1);
	for (ll v = 0; v < n; v++) {
		if (kuhn(v)) {
			++mark;
		}
	}
}

void dfs(ll v, ll f) {
	used[v] = 1;
	for (ll u : g.adj[v]) {
		if (used[u]) {
			continue;
		}
		if (!f && mt[v] == u) {
			continue;
		}
		if (f && mt[v] != u) {
			continue;
		}
		dfs(u, !f);
	}
}

vll cnt;
vll ans;
void max_is() {
	used.assign(g.n, 0);
	for (ll v = 0; v < n; v++) {
		if (!used[v] && mt[v] == -1) {
			dfs(v, 0);
		}
	}
	cnt.assign(n, 0);
	for (ll v = 0; v < n; v++) {
		if (used[v]) {
			++cnt[v];
		}
	}
	for (ll v = n; v < 2 * n; v++) {
		if (!used[v]) {
			++cnt[v - n];
		}
	}
	for (ll v = 0; v < n; v++) {
		if (cnt[v] == 2) {
			ans.pb(v);
		}
	}
}

vll dp;

inline void solve() {
	dp.assign(n, 0);
	dp[0] = 1;
	vll used(n, 0);
	for (ll i = 1; i < n; i++) {
		if (a[i] == -2) {
			continue;
		}
		used[a[i]] = 1;
		dp[i] = dp[a[i]] + 1;
	}
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		if (!used[i]) {
			ans += (dp[i] + 1) / 2;
		}
	}
	cout << ans << endl;
}

inline void read() {
	cin >> n;
	a.resize(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		--a[i];
	}
}
