#define ll long long
#define forrange(i, a, b) for (ll i = a; i < b; ++i)
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

struct {
	bool operator()(pair<ll, ll> a, pair<ll, ll> b) const
	{
		return a.first < b.first;
	}
} customLess;

struct triplet
{
	ll f, s, ind;
	triplet(ll a, ll b, ll c) : f(a), s(b), ind(c) {};
};

struct {
	bool operator()(triplet a, triplet b) const
	{
		return a.f < b.f;
	}
} customMoreFirst;

struct {
	bool operator()(triplet a, triplet b) const
	{
		return a.s < b.s;
	}
} customMoreSec;

vector<int> goodorder;

bool checkPairs(vector<int> &order, vector<vector<ll>> &artif, int n, int k)
{
	vector<pair<ll, ll>> b(k, make_pair(-(10E10), 10E10));
	for (int i = 0; i < n; i+=2)
	{
		for (int j = 0; j < k; ++j)
		{
			b[j].first = fmax(fmin(artif[order[i]][j], artif[order[i+1]][j]), b[j].first);
			b[j].second = fmin(fmax(artif[order[i]][j], artif[order[i+1]][j]), b[j].second);
		}
	}

	for (int i = 0; i < k; ++i)
	{
		if (b[i].first > b[i].second) return false;
	}
	return true;
}

void makePairs(int i, vector<bool> &free, vector<int> &order, vector<vector<ll>> &artif, int n, int k)
{
	if (goodorder.size() > 0) return;
	if (i == n)
	{
		if (checkPairs(order, artif, n, k))
		{
			goodorder = order;
			return;
		}
	}
	for (int j = 0; j < n; ++j)
	{
		if (free[j])
		{
			free[j] = false;
			order.push_back(j);
			makePairs(i + 1, free, order, artif, n, k);
			order.pop_back();
			free[j] = true;
		}
	}
	return;
}

int main()
{
	ll n, k;
	cin >> n >> k;

	//1 
	if (n <= 10)
	{
		ll temp;
		vector<vector<ll>> artif;
		for (int i = 0; i < n; ++i)
		{
			for (int j = 0; j < k; ++j)
			{
				cin >> temp;
				artif.push_back({});
				artif[i].push_back(temp);
			}
		}

		vector<bool> free(n, true);
		vector<int> order;

		makePairs(0, free, order, artif, n, k);
		if (goodorder.size() > 0)
		{
			cout << "YES" << endl;
			for (int i = 0; i < n; i += 2)
			{
				cout << goodorder[i]+1 << " " << goodorder[i + 1]+1 << endl;
			}
		}
		else cout << "NO";
		return 0;
	}

	//2 
	if (k == 1)
	{
		ll temp;
		vector<pair<ll, ll>> artif;
		for (ll i = 1; i <= n; ++i)
		{
			cin >> temp;
			artif.push_back(make_pair(temp, i));
		}
		sort(artif.begin(), artif.end(), customLess);
		cout << "YES" << endl;
		for (ll i = 0; i <= n / 2 - 1; ++i)
		{
			cout << artif[i].second << " " << artif[n - 1 - i].second << endl;
		}
		return 0;
	}

	//4 
	if (k == 2)
	{
		ll temp1, temp2;
		vector<triplet> artif;
		for (ll i = 1; i <= n; ++i)
		{
			cin >> temp1 >> temp2;
			artif.push_back(triplet(temp1, temp2, i));
		}
		sort(artif.begin(), artif.end(), customMoreFirst);

		vector<bool> group1(n+1, false);
		for (ll i = 0; i <= n / 2 - 1; ++i)
		{
			group1[artif[i].ind] = true;
		}
		sort(artif.begin(), artif.end(), customMoreSec);
		
		vector<int> ff, fs, sf, ss;
		for (ll i = 0; i <= n / 2 - 1; ++i)
		{
			if (group1[artif[i].ind]) ff.push_back(artif[i].ind);
			else sf.push_back(artif[i].ind);
		}
		for (ll i = n/2; i < n; ++i)
		{
			if (group1[artif[i].ind]) fs.push_back(artif[i].ind);
			else ss.push_back(artif[i].ind);
		}
		cout << "YES" << endl;
		for (int i = 0; i < ff.size(); ++i) cout << ff[i] << " " << ss[i] << endl;
		for (int i = 0; i < fs.size(); ++i) cout << fs[i] << " " << sf[i] << endl;

		return 0;
	}
	return 0;
}