#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <queue>
#include <deque>
#include <cassert>
#include <cstring>
#include <string>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}


template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

struct fenwick {
	vector<int> t;
	int n;

	fenwick(int _n) {
		n = _n;
		t.resize(n);
	}

	void update(int pos, int val) {
		//cerr << "update " << pos << " " << val << endl;
		while (pos < n) {
			t[pos] += val;
			pos = (pos | (pos + 1));
		}
	}

	int get(int r) {
		int res = 0;
		while (r >= 0) {
			res += t[r];
			r = (r & (r + 1)) - 1;
		}
		return res;
	}

	int get(int l, int r) {
		return get(r) - get(l - 1);
	}
};

const int mx = 6e5 + 228;
int n, m, sz, a[mx], b[mx], used[mx], rpos[mx], pos[mx], ans[mx];
vector<int> c, ev[mx];

void scanline() {
	fenwick f(sz + 1);
	for (int i = 0; i <= sz; ++i) {
		for (auto id : ev[i]) {
			//cerr << "ans " << id << " += get " << i << " " << sz << endl;
			ans[id] += f.get(i, sz);
		}
		if (i < sz) {
			ans[i] -= f.get(rpos[i], sz);
			ev[rpos[i]].push_back(i);
			f.update(rpos[i], 1);
		}
	}
}

int main() {
	fast_io();
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		b[i]--;
	}
	int ptr = 0;
	for (int i = 0; i < m; ++i) {
		if (used[a[i]]) {
			c.push_back(a[i]);
		}
		else {
			while (!used[a[i]]) {
				c.push_back(b[ptr]);
				used[b[ptr++]] = 1;
			}
		}
	}

	sz = c.size();

	fill(pos, pos + n, sz);
	for (int i = sz - 1; i >= 0; --i) {
		rpos[i] = pos[c[i]];
		pos[c[i]] = i;
	}

	//output(all(c));
	scanline();
	cout << c.size() << endl;
	for (int i = 0; i < c.size(); ++i) {
		cout << ans[i] << " ";
	}
	cout << endl;
}
