#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <queue>
#include <deque>
#include <cassert>
#include <cstring>
#include <string>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}


template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const ll MOD = 1e9 + 7;
const int mx = 3e5 + 228;
//TODO : change
const int lg = 61;

vector<ll> get_bits_cnt(ll k) {
	vector<ll> dp(lg + 1);
	int cnt = 0;
	for (int i = lg; i >= 0; --i) {
		for (int j = lg; j > 0; --j) {
			dp[j] = (dp[j - 1] + dp[j]) % MOD;
		}
		if ((k >> i) & 1LL) {
			dp[cnt] = (dp[cnt] + 1) % MOD;
			cnt++;
		}
	}
	dp[cnt]++;
	return dp;
}

int n, m, p[mx];
ll k, dp[lg + 1][mx], pref[lg + 1][mx];
vector<ll> bits_cnt;

void read() {
	cin >> n >> m >> k;

	fill(p, p + n, -1);
	for (int i = 0; i < m; ++i) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		chkmax(p[r], l);
	}

	for (int i = 1; i < n; ++i) {
		chkmax(p[i], p[i - 1]);
	}
}

void calc_dp() {
	for (int i = 1; i <= lg; ++i) {
		for (int j = 0; j < n; ++j) {
			dp[i][j] = (pref[i - 1][j] - pref[i - 1][max(p[j], 0)] + MOD) % MOD;
			if (i == 1 && p[j] == -1) {
				dp[i][j] = (dp[i][j] + 1) % MOD;
			}
			pref[i][j + 1] = (pref[i][j] + dp[i][j]) % MOD;
		}
	}
}

void calc_bits_cnt() {
	bits_cnt = get_bits_cnt(k);
}

ll C[lg][lg], dp2[lg + 1][lg];

void calc_C() {
	for (int i = 0; i < lg; ++i) {
		for (int j = 0; j < lg; ++j) {
			if (j == 0) {
				C[i][j] = 1;
				continue;
			}
			if (i == 0) {
				C[i][j] = 0;
				continue;
			}
			C[i][j] = (C[i - 1][j] + C[i - 1][j - 1]) % MOD;
		}
	}
}

void calc_dp2() {
	for (int i = 1; i <= lg; ++i) {
		for (int j = 0; j < lg; ++j) {
			if (i == 1) {
				dp2[i][j] = 1;
				continue;
			}
			for (int cnt = 1; cnt <= j; ++cnt) {
				dp2[i][j] = (dp2[i][j] + dp2[i - 1][j - cnt] * C[j][cnt]) % MOD;
			}
		}
	}
}

ll ans;

void calc_ans() {
	for (int i = 1; i <= lg; ++i) {
		for (int j = 0; j < lg; ++j) {
			ll adding = (dp[i][n - 1] * bits_cnt[j]) % MOD;
			adding = (adding * dp2[i][j]) % MOD;
			ans = (ans + adding) % MOD;
		}
	}

	cout << ans << endl;
}

int main() {
	fast_io();
	read();
	calc_dp();
	calc_bits_cnt();
	calc_C();
	calc_dp2();

	/*cerr << "dp" << endl;
	for (int i = 1; i <= lg; ++i) {
		cerr << dp[i][n - 1] << " ";
	}
	cerr << endl;

	cerr << "bits_cnt" << endl;
	output(all(bits_cnt));

	cerr << "C" << endl;
	for (int i = 0; i < lg; ++i) {
		for (int j = 0; j < lg; ++j) {
			cerr << C[i][j] << " ";
		}
		cerr << endl;
	}

	cerr << "dp2" << endl;
	for (int i = 1; i <= lg; ++i) {
		for (int j = 0; j < lg; ++j) {
			cerr << dp2[i][j] << " ";
		}
		cerr << endl;
	}*/

	calc_ans();
}
