#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <queue>
#include <deque>
#include <cassert>
#include <cstring>
#include <string>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}


template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const ll MOD = 1e9 + 7;
const int mx = 5010;
int n, k;
int dp[mx][mx][2], pref[mx][mx], suf[mx][mx];

void calc_pref_sum(int s) {
	for (int i = 1; i <= n; ++i) {
		pref[s][i] = (pref[s][i - 1] + dp[s][i - 1][0]) % MOD;
	}
	for (int i = n - 1; i >= 0; --i) {
		suf[s][i] = (suf[s][i + 1] + dp[s][i + 1][1]) % MOD;
	}
}

void calc_dp() {
	for (int s = k + 1; s <= n; ++s) {
		for (int l = s; l >= 1; --l) {
			dp[s][l][0] = suf[s - l][l];
		}
		for (int l = 1; l <= s; ++l) {
			dp[s][l][1] = pref[s - l][l];
		}
		calc_pref_sum(s);
	}
}

int main() {
	fast_io();
	cin >> n >> k;

	if (n == k) {
		cout << 1 << endl;
		return 0;
	}

	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	calc_pref_sum(k);
	calc_dp();
	ll ans = 0;

	for (int i = 1; i <= n; ++i) {
		ans = (ans + dp[n][i][0] + dp[n][i][1]) % MOD;
	}
	cout << ans << endl;
}
