#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <queue>
#include <deque>
#include <cassert>
#include <cstring>
#include <string>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}


template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int K = 7;
const int mx = 2e5 + 228;
int n, k, a[mx][K];
vector<int> val[K];

void read() {
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
			val[j].push_back(a[i][j]);
		}
	}
}

void compress() {
	for (int i = 0; i < k; ++i) {
		sort(all(val[i]));
	}

	for (int i = 0; i < n; ++i) {
		if (a[i][0] <= val[0][n / 2 - 1]) {
			a[i][0] = 0;
		}
		else {
			a[i][0] = 1;
		}
		for (int j = 1; j < k; ++j) {
			if (i > 0 && a[i][j] == val[j][n / 2 - 1] && val[j][n / 2 - 1] == val[j][n / 2]) {
				a[i][j] = 1;
				continue;
			}
			if (a[i][j] > val[j][n / 2 - 1]) {
				a[i][j] = 2;
			}
			else {
				a[i][j] = 0;
			}
		}
	}
}

int main() {
	read();
	compress();

	vector<int> perm(n);
	iota(all(perm), 0);

	while (true) {
		int ok = 1;
		for (int i = 0; i < n; ++i) {
			if (perm[perm[i]] != i) {
				ok = 0;
				break;
			}
		}
		if (ok) {
			for (int i = 0; i < n; ++i) {
				if (a[i][0] == a[perm[i]][0]) {
					ok = 0;
					break;
				}
				for (int j = 1; j < k; ++j) {
					if (a[i][j] == 0 && a[perm[i]][j] == 0) {
						ok = 0;
						break;
					}
					if (a[i][j] == 2 && a[perm[i]][j] == 2) {
						ok = 0;
						break;
					}
				}
				if (ok == 0) {
					break;
				}
			}
		}

		if (ok) {
			cout << "YES\n";
			for (int i = 0; i < n; ++i) {
				if (perm[i] > i) {
					cout << i + 1 << " " << perm[i] + 1 << endl;
				}
			}
			exit(0);
		}
		
		if (!next_permutation(all(perm))) {
			break;
		}
	}

	cout << "NO\n";
}
