#include <iostream>
#include <cmath>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

const int SZ = 3e5 + 10;

int n, m;
vector<int> A, B;
int L;

vector<int> res;

void read_all()
{
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        A.push_back(x);
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        B.push_back(x);
    }
}

void action()
{
    set<int> st;
    if (B[0] == A[L])
        L++;
    for (int i = L; i < A.size(); i++) {
        if (A[i] == B[0])
            break;
        st.insert(A[i]);
    }
    int ind = 0;
    while (!st.empty()) {
        swap(B[ind], B[ind + 1]);
        st.erase(B[ind]);
        ind++;
    }
    res.push_back(ind + 1);
}

int tree[SZ * 4];
int pos_A[SZ], pos_B[SZ];
bool used[SZ];
int sz = 1;

void upd(int ind, int x)
{
    ind += sz;
    tree[ind] = x;
    while (ind > 1) {
        ind >>= 1;
        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
    }
}

void add(int ind, int x)
{
    ind += sz;
    tree[ind] += x;
    while (ind > 1) {
        ind >>= 1;
        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
    }
}

int get_sum(int L, int R)
{
    L += sz;
    R += sz;
    int ans = 0;
    while (L <= R) {
        if (L & 1)
            ans += tree[L++];
        if (~R & 1)
            ans += tree[R--];
        L >>= 1;
        R >>= 1;
    }
    return ans;
}

void dis_action()
{
    L = 0;
    swap(n, m);
    while (sz < n)
        sz <<= 1;
    for (int i = 1; i <= m; i++)
        pos_A[i] = -1;
    for (int i = 0; i < n; i++)
        pos_A[A[i]] = i;
    for (int i = 0; i < m; i++)
        pos_B[B[i]] = i;
    int M = 0;
    for (int i = 0; i < n; i++)
        M = max(M, pos_B[A[i]]);
    add(pos_A[B[M]], 1);
    int U = m - M - 1;     //count of useless in the end
    int now = pos_A[B[M]];
    while (true) {
        if (M == 0)
            break;
        if (pos_A[B[M - 1]] == -1) {
            add(pos_A[B[M]], 1);
            M--;
        }
        else if (pos_A[B[M - 1]] < now) {
            add(pos_A[B[M - 1]], 1);
            M--;
        }
        else
            break;
    }

    int sum = 0;
    for (int i = 0; i < M; i++) {
        if (B[i] == A[L]) {
            res.push_back(m);
            sum++;
            U++;
            L++;
            upd(L, 0);
            continue;
        }
        if (pos_A[B[i]] == -1) {
            res.push_back(m);
            U++;
            continue;
        }
        res.push_back(m - U - get_sum(pos_A[B[i]], n - 1));
        upd(pos_A[B[i]], 1);
    }
    for (int i = 0; i < n - sum; i++)
        res.push_back(m);
}

int get_one_res()
{
    m = A.size(), n = B.size();
    res.clear();
    L = 0;
    while (L < A.size())
        action();
    return res.size();
    /*
    cout << res.size() << "\n";
    for (int x : res)
        cout << x << ' ';
    */
}

int get_two_res()
{
    m = A.size(), n = B.size();
    res.clear();
    L = 0;
    dis_action();
    return res.size();
}

void stress()
{
    n = 6, m = 5;
    for (int i = 0; i < m; i++)
        A.push_back(i + 1);
    for (int i = 0; i < n; i++)
        B.push_back(i + 1);
    while (true) {
        random_shuffle(A.begin(), A.end());
        random_shuffle(B.begin(), B.end());
        vector<int> cop_B = B;
        int a = get_one_res();
        B = cop_B;
        int b = get_two_res();
        if (a != b) {
            cout << a << ' ' << b << endl;
            cout << "MUR!\n";
            cout << "A : ";
            for (int x : A)
                cout << x << ' ';
            cout << endl;
            cout << "B : ";
            for (int x : B)
                cout << x << ' ';
            cout << endl;
            return;
        }
    }
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    //stress();
    read_all();
    if (n > 2000) {
        dis_action();
        cout << res.size() << "\n";
        for (int x : res)
            cout << x << ' ';
        return 0;
    }
    while (L < A.size())
        action();
    cout << res.size() << "\n";
    for (int x : res)
        cout << x << ' ';
    return 0;
}
