#include <iostream>
#include <cmath>
#include <set>
#include <vector>

using namespace std;

const long long MOD = 1e9 + 7;

long long n, m, k;

long long get_step(long long a, long long b)
{
    long long dop = 1;
    while (b > 1) {
        if (b & 1)
            dop *= a;
        a *= a;
        b >>= 1;
        a %= MOD;
        dop %= MOD;
    }
    return a * dop;
}

long long get_obr(long long a)
{
    return get_step(a, MOD - 2);
}

long long fact(long long a)
{
    long long res = 1;
    for (long long i = 2; i <= a; i++) {
        res *= i;
        res %= MOD;
    }
    return res;
}

long long get_C(long long n, long long k)
{
    long long res = fact(n) * get_obr(fact(k)) % MOD * get_obr(fact(n - k)) % MOD;
}

long long get_bit_cnt(long long x)
{
    long long res = 0;
    while (x > 0) {
        res += x & 1;
        x >>= 1;
    }
    return res;
}

long long action(long long x)
{
    long long bit = get_bit_cnt(x);
    long long res = 0;
    for (long long len = 1; len <= bit + 1; len++) {
        res += get_C(n - 1, len - 1) * get_C(bit, len - 1) % MOD * fact(len - 1) % MOD;
        res %= MOD;
    }
    return res;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k;
    long long res = 0;
    for (long long i = 0; i <= k; i++)
        res += action(i);
    cout << res;
    return 0;
}
