#include <iostream>
#include <cmath>
#include <set>
#include <vector>

using namespace std;

const long long BIT_SZ = 100;
const long long SZ = 3e5 + 10;
const long long MOD = 1e9 + 7;

long long n, m, k;

long long fact[SZ];
long long obr[SZ];

long long get_step(long long a, long long b)
{
    long long dop = 1;
    while (b > 1) {
        if (b & 1)
            dop *= a;
        a *= a;
        b >>= 1;
        a %= MOD;
        dop %= MOD;
    }
    return a * dop % MOD;
}

void build_fact()
{
    fact[0] = 1;
    for (long long i = 1; i <= 3e5; i++)
        fact[i] = fact[i - 1] * i % MOD;
    for (long long i = 0; i <= 3e5; i++)
        obr[i] = get_step(fact[i], MOD - 2);
}

long long get_C(long long n, long long k)
{
    return fact[n] * obr[k] % MOD * obr[n - k] % MOD;
}

long long get_bit_cnt(long long x)
{
    long long res = 0;
    while (x > 0) {
        res += x & 1;
        x >>= 1;
    }
    return res;
}

long long path_cnt[BIT_SZ][SZ];
long long cnt[SZ];

void build_path_cnt()
{
    path_cnt[1][0] = 1;
    cnt[1] = 1;
    for (long long i = 1; i <= k; i++) {
        path_cnt[1][i] = 1;
        path_cnt[2][i] = 1;
        for (long long j = i; j > 0; j = i & (j - 1)) {
            if (j == i)
                continue;
            for (long long len = 2; len <= 60; len++) {
                path_cnt[len][i] += path_cnt[len - 1][j];
                path_cnt[len][i] %= MOD;
            }
        }
        for (long long len = 1; len <= 60; len++) {
            cnt[len] += path_cnt[len][i];
            cnt[len] %= MOD;
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    build_fact();
    cin >> n >> m >> k;
    build_path_cnt();
    long long res = 0;
    for (long long i = 1; i <= 60; i++) {
        res += cnt[i] * get_C(n - 1, i - 1);
        res %= MOD;
    }
    cout << res;
    return 0;
}
