#include <iostream>

using namespace std;

const int SZ = 5e3 + 10;
const int MOD = 1e9 + 7;

int n, k;
int dp[2][SZ][SZ];

void build_dp()
{
    dp[1][1][1] = dp[0][1][1] = 1;
    for (int sum = 2; sum <= n; sum++) {
        dp[0][sum][sum] = dp[1][sum][sum] = 1;
        for (int fir = 1; fir < sum; fir++) {
            for (int k = 1; k < fir; k++) {
                dp[0][sum][fir] += dp[1][sum - fir][k];
                dp[0][sum][fir] %= MOD;
            }
            for (int k = fir + 1; k <= sum - fir; k++) {
                dp[1][sum][fir] += dp[0][sum - fir][k];
                dp[1][sum][fir] %= MOD;
            }
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> k;
    build_dp();
    if (n == k)
        cout << 1;
    else
        cout << (dp[0][n][k] + dp[1][n][k]) % MOD;
    return 0;
}
