#include <iostream>
#include <vector>

using namespace std;

const int SZ = 3e5 + 10;

int n;
vector<int> graph[SZ];
int used[SZ];

void read_all()
{
    cin >> n;
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        if (x == -1)
            continue;
        graph[i].push_back(x);
        graph[x].push_back(i);
    }
}

vector<int> now_comp;

int get_comp(int v)
{
    now_comp.push_back(v);
    used[v] = 1;
    int now_edges = 0;
    for (int to : graph[v]) {
        now_edges++;
        if (!used[to])
            now_edges += get_comp(to);
    }
    return now_edges;
}

pair<int, int> tree_action(int v)
{
    used[v] = 2;
    vector<pair<int, int> > now;
    for (int to : graph[v]) {
        if (used[to] == 2)
            continue;
        now.push_back(tree_action(to));
    }
    pair<int, int> vans = {0, 1};
    for (auto to : now) {
        vans.first += max(to.first, to.second);
        vans.second += to.first;
    }
    return vans;
}

int cycle_action()
{

}

int action(int v)
{
    now_comp.clear();
    int cnt_edges = get_comp(v) / 2;
    if (cnt_edges == now_comp.size() - 1) {
        pair<int, int> now = tree_action(v);
        return max(now.first, now.second);
    }
    else {
        cycle_action();
        return 0;
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read_all();
    int res = 0;
    for (int v = 1; v <= n; v++) {
        if (!used[v])
            res += action(v);
    }
    cout << res;
    return 0;
}
