#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int SZ = 3e5 + 10;

int n;
vector<int> graph[SZ];
int used[SZ];

void read_all()
{
    cin >> n;
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        if (x == -1)
            continue;
        graph[i].push_back(x);
        graph[x].push_back(i);
    }
}

vector<int> now_comp;

int get_comp(int v)
{
    now_comp.push_back(v);
    used[v] = 1;
    int now_edges = 0;
    for (int to : graph[v]) {
        now_edges++;
        if (!used[to])
            now_edges += get_comp(to);
    }
    return now_edges;
}

pair<int, int> tree_action(int v)
{
    used[v] = 2;
    vector<pair<int, int> > now;
    for (int to : graph[v]) {
        if (used[to] == 2)
            continue;
        now.push_back(tree_action(to));
    }
    pair<int, int> vans = {0, 1};
    for (auto to : now) {
        vans.first += max(to.first, to.second);
        vans.second += to.first;
    }
    return vans;
}

vector<int> vect;
vector<int> cycle;
int pos[SZ];

bool cycle_dfs(int from, int v)
{
    pos[v] = vect.size();
    vect.push_back(v);
    used[v] = 2;
    for (int to : graph[v]) {
        if (to == from)
            continue;
        if (used[to] != 2) {
            if (cycle_dfs(v, to))
                return true;
        }
        if (used[to] == 2) {
            for (int i = pos[to]; i < vect.size(); i++)
                cycle.push_back(vect[i]);
            return true;
        }
    }
    vect.pop_back();
    return false;
}

int get_cnt(int v)
{
    used[v] = 3;
    int ans = 1;
    for (int to : graph[v]) {
        if (used[to] == 3)
            continue;
        ans += get_cnt(to);
    }
    return ans;
}

int get_ans()
{
    vector<pair<int, int> > dp;
    for (int i = 0; i < vect.size(); i++)
        dp.push_back({0, 0});
    dp[0] = {vect[0] / 2, (vect[0] + 1) / 2};
    for (int i = 1; i < vect.size(); i++) {
        dp[i].first = max(dp[i - 1].first, dp[i - 1].second) + vect[i] / 2;
        dp[i].second = dp[i - 1].first + (vect[i] + 1) / 2;
    }
    dp.pop_back();
    return max(dp.back().first, dp.back().second);
}

int cycle_action(int v)
{
    vect.clear();
    cycle.clear();
    cycle_dfs(0, v);
    vect.clear();

    for (int v : cycle)
        used[v] = 3;
    for (int v : cycle)
        vect.push_back(get_cnt(v));

    int ans = get_ans();
//    reverse(vect.begin(), vect.end());
//    ans = max(ans, get_ans());
//    return ans;
    return ans;
}

int action(int v)
{
    now_comp.clear();
    int cnt_edges = get_comp(v) / 2;
    if (cnt_edges == now_comp.size() - 1) {
        pair<int, int> now = tree_action(v);
        return max(now.first, now.second);
    }
    else
        return cycle_action(v);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read_all();
    int res = 0;
    for (int v = 1; v <= n; v++) {
        if (!used[v])
            res += action(v);
    }
    cout << res;
    return 0;
}
