#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int SZ = 3e5 + 10;

int n;
int arr[SZ];
vector<int> graph[SZ];
vector<int> rev_graph[SZ];

void read_all()
{
    set<pair<int, int> > st;
    cin >> n;
    for (int v = 1; v <= n; v++) {
        int to;
        cin >> to;
        arr[v] = to;
        if (to == -1 || st.count({v, to})) {
            arr[v] = -1;
            continue;
        }
        st.insert({to, v});
        rev_graph[to].push_back(v);
        graph[v].push_back(to);
        graph[to].push_back(v);
    }
}

bool there_used[SZ];

bool theres_cycle(int v)
{
    while (v != -1 && !there_used[v]) {
        there_used[v] = true;
        v = arr[v];
    }
    if (v == -1)
        return false;
    return true;
}

pair<int, int> tree_action(int from, int v)
{
    pair<int, int> ans = {0, 1};
    for (int to : graph[v]) {
        if (to == from)
            continue;
        pair<int, int> h = tree_action(v, to);
        ans.first += max(h.first, h.second);
        ans.second += h.first;
    }
    return ans;
}

bool used[SZ];

pair<int, int> rev_tree_action(int v)
{
    used[v] = true;
    pair<int, int> ans = {0, 1};
    for (int to : rev_graph[v]) {
        if (used[to])
            continue;
        pair<int, int> now = rev_tree_action(to);
        ans.first += max(now.first, now.second);
        ans.second += now.first;
    }
    return ans;
}

vector<pair<int, int> > vect;
vector<int> cycle;

int get_one_ans()
{
    vector<pair<int, int> > dp;
    for (int i = 0; i < vect.size(); i++)
        dp.push_back({0, 0});
    dp[0] = vect[0];
    for (int i = 1; i < (int)vect.size(); i++) {
        dp[i].first = max(dp[i - 1].first, dp[i - 1].second) + vect[i].first;
        dp[i].second = dp[i - 1].first + vect[i].second;
    }
    return dp.back().first;
}

int get_ans()
{
    int ans = 0;
    ans = get_one_ans();
    reverse(vect.begin(), vect.end());
    ans = max(ans, get_one_ans());
    return ans;
}

bool cyc_used[SZ];

void get_cycle(int v)
{
    while (!cyc_used[v]) {
        cyc_used[v] = true;
        v = arr[v];
    }
    while (cycle.empty() || cycle[0] != v) {
        cycle.push_back(v);
        v = arr[v];
    }
}

int cycle_action(int v)
{
    cycle.clear();
    vect.clear();
    get_cycle(v);

    for (int u : cycle)
        used[u] = true;
    for (int u : cycle)
        vect.push_back(rev_tree_action(u));
    return get_ans();
}

bool comp_used[SZ];

void dfs(int v)
{
    comp_used[v] = true;
    for (int to : graph[v]) {
        if (!comp_used[to])
            dfs(to);
    }
}

int action(int v)
{
    dfs(v);
    if (theres_cycle(v))
        return cycle_action(v);
    pair<int, int> ans = tree_action(0, v);
    return max(ans.first, ans.second);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read_all();
    int res = 0;
    for (int i = 1; i <= n; i++) {
        if (!comp_used[i])
            res += action(i);
    }
    cout << res;
    return 0;
}
