#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int SZ = 2e5 + 10;
const int INF = 2e9;

int n, k;
vector<int> vect[SZ];

void read_all()
{
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            vect[i].push_back(x);
        }
    }
}

vector<int> res;

bool is_correct()
{
    for (int i = 0; i < k; i++) {
        int L = -INF, R = INF;
        for (int j = 0; j < n; j += 2) {
            int a = res[j], b = res[j + 1];
            int nowL = min(vect[a][i], vect[b][i]);
            int nowR = max(vect[a][i], vect[b][i]);
            L = max(L, nowL);
            R = min(R, nowR);
        }
        if (L > R)
            return false;
    }
    return true;
}

bool first_solve()
{
    for (int i = 0; i < n; i++)
        res.push_back(i);
    if (is_correct())
        return true;
    while (next_permutation(res.begin(), res.end())) {
        if (is_correct())
            return true;
    }
    return false;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read_all();
    if (first_solve()) {
        cout << "YES\n";
        for (int i = 0; i < n; i += 2)
            cout << res[i] + 1 << ' ' << res[i + 1] + 1 << "\n";
    }
    else
        cout << "NO\n";
    return 0;
}
