#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

const int SZ = 2e5 + 10;
const int INF = 2e9;

int n, k;
vector<int> vect[SZ];

void read_all()
{
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            vect[i].push_back(x);
        }
    }
}

vector<int> res;

bool is_correct()
{
    for (int i = 0; i < k; i++) {
        int L = -INF, R = INF;
        for (int j = 0; j < n; j += 2) {
            int a = res[j], b = res[j + 1];
            int nowL = min(vect[a][i], vect[b][i]);
            int nowR = max(vect[a][i], vect[b][i]);
            L = max(L, nowL);
            R = min(R, nowR);
        }
        if (L > R)
            return false;
    }
    return true;
}

void print_YES_ans()
{
    cout << "YES\n";
    for (int i = 0; i < n; i += 2)
        cout << res[i] + 1 << ' ' << res[i + 1] + 1 << "\n";
}

void first_solve()
{
    for (int i = 0; i < n; i++)
        res.push_back(i);
    if (is_correct()) {
        print_YES_ans();
        return;
    }
    while (next_permutation(res.begin(), res.end())) {
        if (is_correct()) {
            print_YES_ans();
            return;
        }
    }
    cout << "NO\n";
    return;
}

void second_solve()
{
    vector<pair<int, int> > now;
    for (int i = 0; i < n; i++)
        now.push_back({vect[i][0], i});
    sort(now.begin(), now.end());
    cout << "YES\n";
    for (int i = 0; i < n / 2; i++)
        cout << now[i].second + 1 << ' ' << now[n - i - 1].second + 1 << "\n";
}

void third_solve()
{
    for (int i = 0; i < k; i++) {
        vector<pair<int, int> > now;
        for (int j = 0; j < n; j++)
            now.push_back({vect[j][i], j});
        sort(now.begin(), now.end());
        for (int j = 0; j < n; j++) {
            if (j < n / 2)
                vect[now[j].second][i] = 0;
            else
                vect[now[j].second][i] = 1;
        }
    }
    vector<int> now;
    for (int i = 0; i < n; i++) {
        int numb = 0;
        for (int j = 0; j < k; j++)
            numb = numb * 2 + vect[i][j];
        now.push_back(numb);
    }
    map<int, vector<int> > mp;
    for (int i = 0; i < n; i++) {
        int a = now[i];
        int b = a ^ ((1 << k) - 1);
        if (mp.count(b)) {
            res.push_back(i);
            res.push_back(mp[b].back());
            mp[b].pop_back();
            if (mp[b].empty())
                mp.erase(b);
        }
        else
            mp[a].push_back(i);
    }
    if (res.size() == n)
        print_YES_ans();
    else
        cout << "NO\n";
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read_all();
    if (n <= 1)
        first_solve();
    else if (k == 1)
        second_solve();
    else
        third_solve();
    return 0;
}
