#include <iostream>
#include <map>
#include <vector>
#include<functional>
using namespace std;
int min(int a, int b)
{
	return a < b ? a : b;
}
int max(int a, int b)
{
	return a > b ? a : b;
}
void doWithK1(int n)
{
	multimap<int, int> arts;
	for (int i = 0; i < n; ++i)
	{
		int a;
		cin >> a;
		arts.insert(std::pair<int, int>(a, i + 1));
	}
	cout << "YES" << endl;
	int counter = 0;
	for (auto it = arts.begin(), ite = --arts.end(); counter < n / 2; ++counter, ++it, --ite)
	{
		cout << it->second << ' ' << ite->second << endl;
	}
}
bool isMatch(vector<pair<int, int>> pairs, vector<vector<int>> & arts)
{
	vector<int> lb(arts[0].size()), rb(arts[0].size());
	for (int i = 0; i < arts[0].size(); ++i)
	{
		lb[i] = -1000000000;
		rb[i] = 1000000000;
		for (auto &it : pairs)
		{
			lb[i] = max(min(arts[it.first - 1][i], arts[it.second - 1][i]), lb[i]);
			rb[i] = min(max(arts[it.first - 1][i], arts[it.second - 1][i]), rb[i]);
		}
		if (lb[i] > rb[i])
			return false;
	}
	return true;
}
int findInd(vector<bool> & was_used, int n, int m)
{
	int missed = 0;
	for (int i = 0; i < was_used.size(); ++i)
	{
		if (!was_used[i] && missed == m)
			return i + n / 2 + 1;
		if (!was_used[i])
			missed++;
	}
}
bool recursiveMatching(int lvl, vector<pair<int, int>> & pairs, vector<vector<int>> & arts, int n, vector<bool> & was_used)
{
	if (lvl == n/2 && isMatch(pairs, arts))
		return true;
	for (int i = lvl; i < n/2; ++i)
	{
		int ind = findInd(was_used, n, i - lvl);
		pairs[lvl].second = ind;
		was_used[ind - n / 2 - 1] = true;
		if (recursiveMatching(lvl + 1, pairs, arts, n, was_used))
			return true;
		was_used[ind - n / 2 - 1] = false;
	}
	
	return false;
}
void doWithK(int n, int k)
{
	vector<vector<int>> arts(n);
	for (int i = 0; i < n; ++i)
	{
		arts[i] = vector<int>(k);
		for (int j = 0; j < k; ++j)
		{
			cin >> arts[i][j];
		}
	}
	vector<pair<int, int>> pairs(n/2);
	for (int i = 0; i < n / 2; ++i)
	{
		pairs[i].first = i + 1;
	}
	vector<bool> was_used(n / 2, false);
	if (recursiveMatching(0, pairs, arts, n, was_used))
	{
		cout << "YES" << endl;
		for (auto &it : pairs)
			cout << it.first << ' ' << it.second << ' ' << endl;
	}
	else
		cout << "NO";
	
}
int main()
{
	int n, k;
	cin >> n >> k;
	if (k == 1)
	{
		doWithK1(n);
	}
	else
	{
		doWithK(n, k);
	}
	//system("pause");
	return 0;
}