#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define endl '\n'

using namespace std;

const long long MOD = 1e9 + 7;

void mod(long long& x) {
	x %= MOD;
}

void add(vector<long long>& fen, long long i, long long x, long long n) {
	for (; i < n; i |= (i + 1)) {
		fen[i] += x;
		mod(fen[i]);
	}
}

long long get(vector<long long>& fen, long long i) {
	if (i < 0) return 0;
	long long ans = 0;
	for (; i >= 0; i = (i & (i + 1)) - 1) {
		ans += fen[i];
		mod(ans);
	}
	return ans;
}

long long sum(vector<long long>& fen, long long l, long long r) {
	return (get(fen, r) - get(fen, l - 1) + MOD) % MOD;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	long long n, k;
	cin >> n >> k;
	if (k == n) {
		cout << 1;
		return 0;
	}

	vector<vector<vector<long long> > > dp(n + 1, vector<vector<long long> >(n + 1, vector<long long>(2)));
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	vector<vector<vector<long long> > > fen(n + 1, vector<vector<long long> >(2, vector<long long>(n + 1)));
	add(fen[k][0], k, 1, n + 1);
	add(fen[k][1], k, 1, n + 1);

	for (long long i = 0; i <= n; i++) {
		for (long long k = 1; k <= i; k++) {
			dp[i][k][1] = sum(fen[i - k][0], 0, k - 1);
			if (k < n) {
				dp[i][k][0] = sum(fen[i - k][1], k + 1, n);
			}
			add(fen[i][1], k, dp[i][k][1], n + 1);
			add(fen[i][0], k, dp[i][k][0], n + 1);
		}
	}

	long long ans = 0;
	for (long long k = 1; k <= n; k++) {
		ans += dp[n][k][0] + dp[n][k][1];
		mod(ans);
	}
	cout << ans;
}