#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define endl '\n'

using namespace std;

const int MAXON = 3e5;
int to[MAXON];
bool used[MAXON];
vector<vector<int> > cycles;
vector<int> ind;
vector<int> num;
int cnt[MAXON][2];
int ans = 0;
vector<int> q;
int d[MAXON];

void dfs0(int v) {
	used[v] = true;
	if (to[v] != -1 && !used[to[v]]) {
		dfs0(to[v]);
	}
	q.push_back(v);
}

void dfs(int v) {
	vector<int> order;
	while (!used[v]) {
		order.push_back(v);
		used[v] = true;
		if (to[v] == -1) break;
		v = to[v];
	}

	if (ind[v] == -1 && num[v] == -1) {
		cycles.resize(cycles.size() + 1);
		bool f = false;
		while (!f) {
			f = order.back() == v;
			ind[order.back()] = cycles.size() - 1;
			cycles.back().push_back(order.back());
			order.pop_back();
		}
		reverse(cycles.back().begin(), cycles.back().end());
		int dist = 1;
		while (order.size()) {
			num[order.back()] = v;
			d[order.back()] = dist;
			if (dist % 2) {
				cnt[v][1]++;
			}
			else {
				cnt[v][0]++;
			}
			order.pop_back();
			dist++;
		}
	}
	else if (num[v] != -1) {
		int dist = d[v] + 1;
		while (order.size()) {
			d[order.back()] = dist;
			num[order.back()] = num[v];
			if (dist % 2) {
				cnt[v][1]++;
			}
			else {
				cnt[v][0]++;
			}
			order.pop_back();
			dist++;
		}
	}
	else {
		int dist = 1;
		while (order.size()) {
			d[order.back()] = dist;
			num[order.back()] = v;
			if (dist % 2) {
				cnt[v][1]++;
			}
			else {
				cnt[v][0]++;
			}
			order.pop_back();
			dist++;
		}
	}
}

int count(vector<int>& cycle, int ind, bool first) {
	int i = 0;
	if (!first) {
		i = 1;
		cycle.push_back(cycle[0]);
	}

	int res = 0;
	bool take = true;
	for (; i < cycle.size(); i++) {
		if (take && (i != cycle.size() - 1 || cycle.size() == 1)) {
			res += cnt[cycle[i]][0];
			res++;
		}
		else {
			res += cnt[cycle[i]][1];
		}
		take = !take;
	}
	cycle.pop_back();
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;
	ind.resize(n, -1);
	num.resize(n, -1);
	for (int i = 0; i < n; i++) {
		cin >> to[i];
		if (to[i] != -1) {
			to[i]--;
		}
	}

	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs0(i);
		}
	}
	for (int i = 0; i < n; i++) {
		used[i] = false;
	}

	for (int i = q.size() - 1; i >= 0; i--) {
		if (!used[q[i]]) {
			dfs(q[i]);
		}
	}

	for (int i = 0; i < cycles.size(); i++) {
		ans += max(count(cycles[i], i, 1), count(cycles[i], i, 0));
	}
	cout << ans;
}