#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


vector<vector<int>> graph;
vector<int> used, cycles;
vector<int> dp[2];
int ver = 0;


void dfs(int v) {
    used[v] = ver;

    dp[0][v] = 0;
    dp[1][v] = 1;

    bool leaf = true;
    for (int u : graph[v]) {
        if (used[u] == ver) {
            continue;
        }

        leaf = false;

        dfs(u);

        dp[0][v] += max(dp[0][u], dp[1][u]);
        dp[1][v] += dp[0][u];
    }
}


void get_cycles(int v, vector<int> &c) {
    used[v] = ver;

    if (cycles[v]) {
        c.push_back(v);
    }

    for (int u : graph[v]) {
        if (used[u] != ver) {
            get_cycles(u, c);
        }
    }
}


const bool TEST = false;
const int MAXN = (int)3e3;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;

    if (TEST) {
        n = MAXN;
    } else {
        cin >> n;
    }

    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        if (TEST) {
            p[i] = i - 1;
        } else {
            cin >> p[i];

            if (p[i] > 0) {
                --p[i];
            }
        }
    }

    graph.resize(n);

    for (int i = 0; i < n; ++i) {
        if (p[i] != -1) {
            graph[i].push_back(p[i]);
            graph[p[i]].push_back(i);
        }
    }

    used.resize(n);

    cycles.resize(n);
    for (int i = 0; i < n; ++i) {
        if (used[i] == 2) {
            continue;
        }

        vector<int> ccl;
        ccl.push_back(i);

        int j = i;
        used[j] = true;
        while (p[j] != -1 && used[p[j]] == 0) {
            j = p[j];
            used[j] = 1;
            ccl.push_back(j);
        }

        if (p[j] == -1 || used[p[j]] == 2) {
            for (int x : ccl) {
                used[x] = 2;
            }

            continue;
        }

        for (int x : ccl) {
            used[x] = 2;
        }

        cycles[i] = cycles[p[i]] = true;
    }

    dp[0].resize(n);
    dp[1].resize(n);

    used.assign(n, 0);
    ver = 0;

    int answ = 0;

    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            continue;
        }

        ++ver;
        vector<int> cc;
        get_cycles(i, cc);

        if (cc.empty()) {
            ++ver;
            dfs(i);

            answ += max(dp[0][i], dp[1][i]);

            continue;
        }

        int maxt = 0;
        for (int cv : cc) {
            ++ver;
            used[cv] = ver;

            int curt = 0;
            for (int v : graph[cv]) {
                if (used[v] == ver) {
                    continue;
                }

                dfs(v);

                curt += max(dp[0][v], dp[1][v]);
            }

            if (curt > maxt) {
                maxt = curt;
            }
        }

        answ += maxt;
    }

    cout << answ;

    return 0;
}