#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    vector<int> queries;
    map<int, int> pos;

    cin >> n >> m;
    queries.resize(m);
    for (int i = 0; i < m; ++i) {
        int x;
        cin >> x;
        queries[i] = x - 1;
    }
    int pick = 0;
    for (int j = 0; j < n; ++j) {
        int card;
        cin >> card;
        pos[card - 1] = j;
        if (j == 0)
            pick = card - 1;
    }

    if (m <= 2000 && n <= 2000) {
        vector<multiset<int>> pref;
        pref.emplace_back();
        for (int i = 1; i < m + 1; ++i) {
            auto new_set = pref[i - 1];
            new_set.insert(queries[i - 1]);
            pref.push_back(new_set);
        }

        vector<vector<int>> all_inc(n);
        for (int i = 0; i < m; ++i) {
            int cur = queries[i];
            all_inc[cur].emplace_back(i);
        }

        int ans = 0;
        vector<int> actions;
        vector<int> cur_pos(n);
        for (int i = 0; i < m; ++i) {
            while (pick != queries[i]) {
                // pick
                ++ans;
                int max_index = 0;
                if (all_inc[pick].size() <= cur_pos[pick])
                    max_index = n - 1;
                else {
                    vector<int> res;
                    auto fir = pref[all_inc[pick][cur_pos[pick]]];
                    set_difference(fir.begin(), fir.end(), pref[i].begin(), pref[i].end(), inserter(res, res.begin()));
                    for (auto card : res)
                        max_index = max(max_index, pos[card]);
                }
                // insert
                pos[pick] = max_index;
                int pick_backup = pick;
                actions.emplace_back(max_index + 1);
                for (auto el : pos) {
                    if (el.second <= max_index && el.first != pick_backup) {
                        --pos[el.first];
                        if (pos[el.first] == 0)
                            pick = el.first;
                    }
                }
            }
            // see next
            ++cur_pos[pick];
            // pick
            ++ans;
            int max_index = 0;
            if (all_inc[pick].size() <= cur_pos[pick])
                max_index = n - 1;
            else {
                vector<int> res;
                auto fir = pref[all_inc[pick][cur_pos[pick]]];
                set_difference(fir.begin(), fir.end(), pref[i].begin(), pref[i].end(), inserter(res, res.begin()));
                for (auto card : res)
                    max_index = max(max_index, pos[card]);
            }
            // insert
            pos[pick] = max_index;
            int pick_backup = pick;
            actions.emplace_back(max_index + 1);
            for (auto el : pos) {
                if (el.second <= max_index && el.first != pick_backup) {
                    --pos[el.first];
                    if (pos[el.first] == 0)
                        pick = el.first;
                }
            }
        }

        cout << actions.size() << endl;
        for (auto action : actions) cout << action << " ";
        cout << endl;
    }

    return 0;
}