#include <iostream>
#include <vector>
#include <set>

using namespace std;

bool dfs(int v, int init, vector<bool> &used, vector<vector<int>> &g, vector<int> &match) {
    if (!used[v]) {
        used[v] = true;
        for (int u : g[v]) {
            if (u != init && match[u] == -1) {
                match[u] = v;
                match[v] = u;
                return true;
            }
        }
        for (int u : g[v]) {
            if (u != init && dfs(match[u], v, used, g, match)) {
                match[u] = v;
                match[v] = u;
                return true;
            }
        }
    }
    return false;
}

int main() {
    int n;
    vector<vector<int>> g;

    cin >> n;
    g.resize(n);

    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x != -1) {
            g[i].emplace_back(x - 1);
            g[x - 1].emplace_back(i);
        }
    }

    vector<bool> used(n);
    vector<int> match(n, -1);
    for (int i = 0; i < n; ++i) {
        used.assign(n, false);
        dfs(i, -1, used, g, match);
    }

    set<pair<int, int>> pairs;
    for (int i = 0; i < n; ++i) {
        pairs.insert({min(match[i], i), max(match[i], i)});
    }

    cout << pairs.size() << endl;

    return 0;
}