#include <iostream>
#include <vector>

using namespace std;

pair<int, int> color_dfs(int v, bool color, vector<vector<int>> &g, vector<int> &colors) {
    colors[v] = color;
    int count_1 = 1;
    int count_2 = 0;
    bool recalc = false;
    for (int u : g[v]) {
        if (colors[u] == -1) {
            auto p = color_dfs(u, !color, g, colors);
            count_1 += p.second;
            count_2 += p.first;
        } else if (color && colors[u] == color) {
            color = !color;
            recalc = true;
            count_1 -= 1;
            count_2 += 1;
            break;
        }
    }
    if (recalc) {
        int count_1 = 0;
        int count_2 = 1;
        for (int u : g[v]) {
            if (colors[u] == -1) {
                auto p = color_dfs(u, !color, g, colors);
                count_2 += p.second;
                count_1 += p.first;
            }
        }
    }
    return {count_1, count_2};
}

int main() {
    int n;
    vector<vector<int>> g;

    cin >> n;
    g.resize(n);

    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x != -1) {
            g[i].emplace_back(x - 1);
            g[x - 1].emplace_back(i);
        }
    }

    int ans = 0;
    for (int fir = 0; fir < n; ++fir) {
        vector<int> colors(n, -1);
        int cur_ans = 0;
        for (int i = fir; i < n + fir; ++i) {
            if (colors[i] == -1) {
                auto res = color_dfs(i, true, g, colors);
                cur_ans += res.first;
            }
        }
        ans = max(ans, cur_ans);
    }

    cout << ans << endl;

    return 0;
}