#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const long double EPS = 1e-9;
const long long INF = 1e9;

using namespace std;

long long n, m, k;
vector <vector <char>> vec;
vector <bool> used;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll lsqrt(ll n) {
	ll l = 0, r = n + 1;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		if (m * m <= n) {
			l = m;
		}
		else {
			r = m;
		}
	}
	if (l * l == n) {
		return l;
	}
	else {
		return -1;
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> k;
	if (k % 2 == 0) {
		ll t = lsqrt(k);
		if (t != -1 && t * t != k) {
			cout << "none";
			return 0;
		}
	}
	ll last = 0;
	for (ll x = 0; x < 8e6; ++x) {
		ll cur = x * x + k;
		if (cur < 0) continue;
		else {
			ll l = last, r = cur + 1;
			while (r - l > 1) {
				ll m = (l + r) / 2;
				if (m * m <= cur) {
					l = m;
				}
				else {
					r = m;	
				}
			}	
			if (l * l == cur) {
				cout << l;
				return 0;
			}
			last = l;
		}		
	}
	cout << "none";
	return 0;
}