#include <iostream>
#include <set>
#include <vector>

const int MAX_N = 300000;

int MoveToNewPlace(int a[], int b[], int n, int aId, std::vector < std::vector <int> > &bMeets);

int main(void) {
    int n = 0, m = 0;
    std::cin >> n >> m;
    int *a = new int[m];
    int *b = new int[n];
    std::vector < std::vector <int> > bMeets(n);
    for (int i = 0; i < m; i++) {
        std::cin >> a[i];
        a[i]--;
        bMeets[a[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        std::cin >> b[i];
        b[i]--;
    }

    std::vector <int> moves = {};
    for (int aId = 0; aId < m; aId++) {
        bMeets[a[aId]].erase(bMeets[a[aId]].begin());
        while (b[0] != a[aId])
            moves.push_back(MoveToNewPlace(a, b, n, aId, bMeets));
        moves.push_back(MoveToNewPlace(a, b, n, aId, bMeets));
    }

    std::cout << moves.size() << std::endl;
    for (unsigned int i = 0; i < moves.size(); i++)
        std::cout << ((i != 0) ? " " : "") << moves[i];
    std::cout << std::endl;

    delete[] a;
    delete[] b;
    return 0;
}

int MoveToNewPlace(int a[], int b[], int n, int aId, std::vector < std::vector <int> > &bMeets) {
    if (bMeets[b[0]].size() == 0) {
        int tempB = b[0];
        for (int i = 0; i < n - 1; i++)
            b[i] = b[i + 1];
        b[n - 1] = tempB;
        return n;
    }

    int nextA = bMeets[b[0]][0];
    std::set <int> otherB;
    otherB.clear();
    for (int i = aId; i <= nextA; i++)
        otherB.insert(a[i]);
    otherB.erase(b[0]);
    int pos = 0;
    int tempB = b[0];
    while (!otherB.empty() && pos < n - 1) {
        b[pos] = b[pos + 1];
        if (otherB.find(b[pos]) != otherB.end())
            otherB.erase(b[pos]);
        pos++;
    }
    b[pos] = tempB;
    return pos + 1;
}
