#include <iostream>
#include <stdio.h>
#include <vector>

#pragma GCC optimize("O3")

const int MAX_N = 300000,
          MEM = 10000000;

int MoveToNewPlace(int a[], int b[], int &startI, int n, int aId, std::vector < std::vector <int> > &bMeets);

int main(void) {
    int n = 0, m = 0;
    std::cin >> n >> m;
    int *a = new int[m];
    int *b = new int[n];
    std::vector < std::vector <int> > bMeets(n);
    for (int i = 0; i < m; i++) {
        scanf("%d", &(a[i]));
        a[i]--;
        bMeets[a[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        scanf("%d", &(b[i]));
        b[i]--;
    }

    bool part2 = 1;
    for (int i = 0; i < n; i++)
        if (a[i] != b[n - i - 1]) {
            part2 = 0;
            break;
        }

    std::vector <int> moves(MEM);
    moves.clear();

    if (!part2) {
        int startI = 0;
        for (int aId = 0; aId < m; aId++) {
            bMeets[a[aId]].erase(bMeets[a[aId]].begin());
            while (b[startI] != a[aId])
                moves.push_back(MoveToNewPlace(a, b, startI, n, aId, bMeets));
            moves.push_back(MoveToNewPlace(a, b, startI, n, aId, bMeets));
        }
    }
    else {
        for (int i = 0; i < n - 1; i++)
            moves.push_back(n - i);
        for (int i = 0; i < n; i++)
            moves.push_back(n);
    }

    std::cout << moves.size() << '\n';
    for (unsigned int i = 0; i < moves.size(); i++)
        printf("%d ", moves[i]);
    std::cout << std::endl;

    return 0;
}

int MoveToNewPlace(int a[], int b[], int &startI, int n, int aId, std::vector < std::vector <int> > &bMeets) {
    if (bMeets[b[startI]].empty()) {
        startI++;
        return n;
    }

    int nextA = bMeets[b[startI]][0];
    std::vector <bool> otherB(n);
    otherB.clear();
    int otherBCount = 0;
    for (int i = aId; i < nextA; i++) {
        otherBCount += (otherB[a[i]] == 0);
        otherB[a[i]] = 1;
    }
    otherBCount -= (otherB[b[startI]] == 1);
    otherB[b[startI]] = 0;
    int pos = startI;
    int tempB = b[startI];
    while (otherBCount > 0 && pos < n - 1) {
        b[pos] = b[pos + 1];
        otherBCount -= (otherB[b[pos]] == 1);
        otherB[b[pos]] = 0;
        pos++;
    }
    b[pos] = tempB;
    return pos + 1 - startI;
}
