#include <iostream>
#include <vector>

const int MAX_N = 300000;

int MoveToNewPlace(int a[], int b[], int &startI, int n, int aId, std::vector < std::vector <int> > &bMeets);

int main(void) {
    int n = 0, m = 0;
    std::cin >> n >> m;
    int *a = new int[m];
    int *b = new int[n];
    std::vector < std::vector <int> > bMeets(n);
    for (int i = 0; i < m; i++) {
        std::cin >> a[i];
        a[i]--;
        bMeets[a[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        std::cin >> b[i];
        b[i]--;
    }

    bool part2 = 1;
    for (int i = 0; i < n; i++)
        if (a[i] != b[n - i - 1]) {
            part2 = 0;
            break;
        }
    bool part4 = 1;
    for (int i = 0; i < n; i++)
        if (bMeets[a[i]].size() > 1) {
            part4 = 0;
            break;
        }

    std::vector <int> moves = {};
    moves.clear();

    if (!part2) {
        if (!part4) {
            int startI = 0;
            for (int aId = 0; aId < m; aId++) {
                bMeets[a[aId]].erase(bMeets[a[aId]].begin());
                while (b[startI] != a[aId])
                    moves.push_back(MoveToNewPlace(a, b, startI, n, aId, bMeets));
                moves.push_back(MoveToNewPlace(a, b, startI, n, aId, bMeets));
            }
        }
        else {
            std::vector <int> goodPos(n);
            goodPos.clear();
            for (int i = 0; i < m; i++)
                goodPos[a[i]] = i;
            std::vector <int> inBadPos(n);
            std::vector <bool> bGot(n);
            bGot.clear();
            inBadPos.clear();
            if (b[0] != a[0])
                inBadPos[0] = 1;
            bGot[b[0]] = 1;
            for (int i = 1; i < n; i++) {
                inBadPos[i] = inBadPos[i - 1];
                if (bGot[a[i]])
                    inBadPos[i]--;
                if (goodPos[b[i]] > i)
                    inBadPos[i]++;
            }

            for (int i = 0; i < n; i++)
                moves.push_back(goodPos[b[i]] + inBadPos[goodPos[b[i]]]);
        }
    }
    else {
        for (int i = 0; i < n - 1; i++)
            moves.push_back(n - i);
        for (int i = 0; i < n; i++)
            moves.push_back(n);
    }

    std::cout << moves.size() << std::endl;
    for (unsigned int i = 0; i < moves.size(); i++)
        std::cout << ((i != 0) ? " " : "") << moves[i];
    std::cout << std::endl;

    delete[] a;
    delete[] b;
    return 0;
}

int MoveToNewPlace(int a[], int b[], int &startI, int n, int aId, std::vector < std::vector <int> > &bMeets) {
    if (bMeets[b[startI]].empty()) {
        startI++;
        return n;
    }

    int nextA = bMeets[b[startI]][0];
    std::vector <bool> otherB(n);
    otherB.clear();
    int otherBCount = 0;
    for (int i = aId; i < nextA; i++) {
        otherBCount += (otherB[a[i]] == 0);
        otherB[a[i]] = 1;
    }
    otherBCount -= (otherB[b[startI]] == 1);
    otherB[b[startI]] = 0;
    int pos = startI;
    int tempB = b[startI];
    while (otherBCount > 0 && pos < n - 1) {
        b[pos] = b[pos + 1];
        otherBCount -= (otherB[b[pos]] == 1);
        otherB[b[pos]] = 0;
        pos++;
    }
    b[pos] = tempB;
    return pos + 1 - startI;
}
