#include <iostream>

const int MAX_N = 5000 + 1;
const long long MOD = 1000000000 + 7;

int main(void) {
    long long *dpUp[MAX_N] = {}, *dpDown[MAX_N] = {};
    long long *prefixUp[MAX_N] = {}, *prefixDown[MAX_N] = {};
    int n = 0, k = 0;
    std::cin >> n >> k;

    for (int i = 0; i <= n; i++) {
        dpUp[i] = new long long[n + 1];
        prefixUp[i] = new long long[n + 1];
        dpDown[i] = new long long[n + 1];
        prefixDown[i] = new long long[n + 1];
        for (int j = 0; j <= n; j++)
            dpUp[i][j] = dpDown[i][j] = prefixUp[i][j] = prefixDown[i][j] = 0;
    }

    for (int i = 1; i <= n; i++) {
        dpDown[i][i] = 1;
        for (int j = i; j <= n; j++)
            prefixDown[j][i] = 1;
    }
    for (int n1 = 1; n1 <= n; n1++) {
        for (int k1 = 1; k1 < n1; k1++) {
            long long sumUp = prefixDown[n1 - k1][n1 - k1] - prefixDown[k1][n1 - k1];
            if (sumUp < 0) {
                if (n1 - k1 > k1)
                    sumUp += MOD;
                else
                    sumUp = 0;
            }
            dpUp[k1][n1] = sumUp;
            prefixUp[k1][n1] = (prefixUp[k1 - 1][n1] + dpUp[k1][n1]) % MOD;
            long long sumDown = 0;
            for (int i = 1; i <= k1 - 1; i++) {
                if (i != n1 - k1)
                    sumDown = (sumDown + dpUp[i][n1 - k1]) % MOD;
                else
                    sumDown = (sumDown + 1) % MOD;
            }
            dpDown[k1][n1] = sumDown;
            prefixDown[k1][n1] = (prefixDown[k1 - 1][n1] + dpDown[k1][n1]) % MOD;
        }
        for (int k1 = 1; k1 <= n; k1++) {
            prefixUp[k1][n1] = (prefixUp[k1 - 1][n1] + prefixUp[k1][n1]) % MOD;
            prefixDown[k1][n1] = (prefixDown[k1 - 1][n1] + prefixDown[k1][n1]) % MOD;
        }
    }

    /*for (int k1 = 0; k1 <= n; k1++) {
        for (int n1 = 0; n1 <= n; n1++)
            std::cout << dpUp[k1][n1] << "|" << dpDown[k1][n1] << "|" << prefixUp[k1][n1] << "|" << prefixDown[k1][n1] << " ";
        std::cout << std::endl;
    }*/

    std::cout << ((dpUp[k][n] + dpDown[k][n]) % MOD) << std::endl;

    for (int i = 0; i <= n; i++) {
        delete[] dpUp[i];
        delete[] dpDown[i];
    }
    return 0;
}
