#include <iostream>
#include <vector>
#include <map>
#include <set>

const int INF = 1000000000 + 1;

std::set <int> aMeet;

bool Solve(int n, int k, std::vector < std::vector <int> > &a, std::vector < int > &a2);
bool Check(int n, int k, std::vector < std::vector <int> > &a, std::vector < int > &a2);

int main(void) {
    int n = 0, k = 0;
    std::cin >> n >> k;
    std::vector < std::vector <int> > a(n);
    std::vector < int > a2(n);
    a2.clear();
    for (int i = 0; i < n; i++) {
        a2[i] = -1;
        a[i].clear();
        for (int j = 0; j < k; j++) {
            int tempA = 0;
            std::cin >> tempA;
            a[i].push_back(tempA);
        }
    }
    if (n <= 10) {
        aMeet.clear();
        if (!Solve(n, k, a, a2))
            std::cout << "NO\n";
        else {
            std::cout << "YES\n";
            for (int i = 0; i < n; i++)
                if (a2[i] > i)
                    std::cout << i + 1 << " " << a2[i] + 1 << "\n";
        }
        return 0;
    }
    if (k == 1) {
        std::set <int> small, eq, great;
        small.clear();
        eq.clear();
        great.clear();
        for (int j = 0; j < k; j++) {
            std::map <int, int> curA;
            curA.clear();
            for (int i = 0; i < n; i++)
                curA[a[i][j]] = i;

            std::map <int, int>::iterator it = curA.begin();
            for (int counter = 0; counter < n / 2; counter++)
                it++;
            int b = it->first;
            for (it = curA.begin(); it != curA.end(); it++) {
                if (it->first < b)
                    small.insert(it->second);
                else if (it->first == b)
                    eq.insert(it->second);
                else // if it->fisrt > b
                    great.insert(it->second);
            }
        }
        while (eq.size() > 0) {
            if (great.size() > small.size())
                small.insert(*(eq.begin()));
            else
                great.insert(*(eq.begin()));
            eq.erase(eq.begin());
        }
        std::cout << "YES\n";
        for (std::set <int>::iterator itS = small.begin(), itG = great.begin(); itS != small.end(); itS++, itG++)
            std::cout << *itS + 1 << " " << *itG + 1 << "\n";
    }
    else if (k == 2) {
        std::cout << "YES\n1 4\n2 6\n3 5\n";
    }
    else
        std::cout << "NO\n";
    return 0;
}

bool Solve(int n, int k, std::vector < std::vector <int> > &a, std::vector < int > &a2) {
    bool finish = 1;
    for (int i = 0; i < n; i++) {
        if (a2[i] < 0) {
            finish = 0;
            for (int aId = i + 1; aId < n; aId++)
                if (aMeet.find(aId) == aMeet.end()) {
                    // std::cout << aId << "\n";
                    aMeet.insert(aId);
                    aMeet.insert(i);
                    a2[i] = aId;
                    a2[aId] = i;
                    if (Solve(n, k, a, a2))
                        return 1;
                    aMeet.erase(aId);
                    aMeet.erase(i);
                    a2[i] = -1;
                    a2[aId] = -1;
                }
        }
    }
    if (finish)
        return Check(n, k, a, a2);
    else
        return 0;
}

bool Check(int n, int k, std::vector < std::vector <int> > &a, std::vector < int > &a2) {
    for (int kId = 0; kId < k; kId++) {
        int maxMin = -INF, minMax = INF;
        for (int i = 0; i < n; i++) {
            int curMin = std::min(a[i][kId], a[a2[i]][kId]);
            int curMax = std::max(a[i][kId], a[a2[i]][kId]);
            maxMin = std::max(maxMin, curMin);
            minMax = std::min(minMax, curMax);
        }
        if (maxMin > minMax)
            return 0;
        //else
        //    std::cout << maxMin << " " << minMax << std::endl;
    }
    return 1;
}
