#include <iostream>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int INF = 1 << 30;
const ll LLINF = 1LL << 60;

template <class T>
istream& operator>>(istream &in, vector<T> &ar) {
    for (int i = 0; i < ar.size(); ++i)
        in >> ar[i];
    return in;
}

template <class T>
ostream& operator<<(ostream &out, vector<T> &ar) {
    for (T x : ar)
        out << x << ' ';
    return out;
}

ll biggestPrime(ll x) {
    ll ans = 1;
    for (ll i = 2; i * i <= x; ++i) {
        if (x % i == 0)
            ans = i;
        while (x % i == 0)
            x /= i;
    }
    if (x > 1)
        ans = x;
    return ans;
}

int main() {
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    ll k;
    cin >> k;
    if (k == 0) {
        cout << "0\n";
        return 0;
    }
    ll mk = abs(k);
    swap(mk, k);
    if (k % 2 == 0 && k % 4 != 0) {
        cout << "none\n";
        return 0;
    }
    ll p = biggestPrime(k);
    ll a = p, b = 0;
    while (1) {
        //cout << a << '_' << b << '\n';
        while (a * a - b * b > k)
            b += p;
        if (a * a - b * b == k) {
            if (mk < 0)
                cout << b << '\n';
            else
                cout << a << '\n';
            return 0;
        }
        if (a == b)
            break;
        ++a;
        ++b;
    }
    a = p / 2, b = p - p / 2;
    while (1) {
        //cout << a << '-' << b << '\n';
        while (a * a - b * b > k)
            b += p;
        if (a * a - b * b == k) {
            if (mk < 0)
                cout << b << '\n';
            else
                cout << a << '\n';
            return 0;
        }
        ++a;
        --b;
    }
}
