#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1 << 30;

template<class T>
istream& operator>>(istream &in, vector<T> &ar) {
    for (int i = 0; i < ar.size(); ++i)
        in >> ar[i];
    return in;
}

template<class T>
ostream& operator<<(ostream &out, vector<T> &ar) {
    for (T x : ar)
        out << x << ' ';
    return out;
}

int factorial(int x) {
    if (x == 0)
        return 1;
    return factorial(x - 1) * x;
}

int main() {
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        vector<pii> ar(n);
        for (int i = 0; i < n; ++i) {
            cin >> ar[i].first;
            ar[i].second = i;
        }
        sort(ar.begin(), ar.end());
        cout << "YES\n";
        for (int i = 0; i < n / 2; ++i)
            cout << min(ar[i].second + 1, ar[n - i - 1].second + 1) << ' ' << max(ar[i].second + 1, ar[n - i - 1].second + 1) << '\n';
        return 0;
    }
    else {
        vector<vector<int>> ar(n, vector<int>(k));
        cin >> ar;
        vector<int> ind(n);
        for (int i = 0; i < n; ++i)
            ind[i] = i;
        int t = factorial(n);
        for (int iter = 0; iter < t; ++iter) {
            vector<pii> minmax(k, {-INF, INF});
            for (int i = 0; i < n; i += 2) {
                for (int j = 0; j < k; ++j) {
                    minmax[j].first = max(minmax[j].first, min(ar[ind[i]][j], ar[ind[i + 1]][j]));
                    minmax[j].second = min(minmax[j].second, max(ar[ind[i]][j], ar[ind[i + 1]][j]));
                }
            }
            bool ok = 1;
            for (int j = 0; j < k; ++j)
                ok = ok && (minmax[j].first <= minmax[j].second);
            if (ok) {
                cout << "YES\n";
                for (int j = 0; j < n; j += 2)
                    cout << min(ind[j] + 1, ind[j + 1] + 1) << ' ' << max(ind[j] + 1, ind[j + 1] + 1) << '\n';
                return 0;
            }
            next_permutation(ind.begin(), ind.end());
        }
    }
    cout << "NO\n";
}
