#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define len(v) ((int)v.size())
#define x first
#define y second
#define f(i, n) for (int i = 0; i < (n); i++)

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << "{" << p.x << ", " << p.y << "}";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class T>
ostream &operator<<(ostream &os, const set<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const map<A, B> &v) {
	for (const auto &x : v) {
		os << x << " ";
	}
	return os;
}

void run();

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

mt19937 gen(1337);

struct Node {
	Node *l = NULL, *r = NULL, *pref = NULL;

	int value;
	int _min;
	int prior;
	int size = 1;

	Node() {}
	Node(int _value) {
		value = _value;
		_min = value;
		prior = gen();
	}
};

int get_size(Node *node) {
	return node ? node->size : 0;
}

int get_min(Node *node) {
	return node ? node->_min : 1e9;
}

void update(Node *node) {
	assert(node);
	node->size = get_size(node->l) + get_size(node->r) + 1;
	node->_min = min(min(get_min(node->l), get_min(node->r)), node->value);
	if (node->l) node->l->pref = node;
	if (node->r) node->r->pref = node;
}

Node *merge(Node *a, Node *b) {
	if (!a) return b;
	if (!b) return a;
	if (a->prior > b->prior) {
		a->r = merge(a->r, b);
		update(a);
		return a;
	} else {
		b->l = merge(a, b->l);
		update(b);
		return b;
	}
}

pair<Node*, Node*> split(Node *node, int j) {
	if (!node) return mp(node, node);
	int id = get_size(node->l);
	if (j <= id) {
		if (node->l) node->l->pref = NULL;
		auto t = split(node->l, j);

		node->l = NULL;
		update(node);

		return mp(t.x, merge(t.y, node));
	} else {
		if (node->r) node->r->pref = NULL;
		auto t = split(node->r, j - id - 1);

		node->r = NULL;
		update(node);

		return mp(merge(node, t.x), t.y);
	}
}

int R(Node *node, int bar) {
	if (!node) return -1;
	int F = R(node->r, bar);
	if (F != -1) return 1 + get_size(node->l) + F;
	if (node->value < bar) return get_size(node->l);
	return R(node->l, bar);
}

int n, m;

vector<deque<int>> times;
vector<int> order;

void run() {
	cin >> n >> m;	
	times.resize(n + 1);
	vector<int> seq;
	f(i, m) {
		int x;
		cin >> x;
		seq.pb(x);
		times[x].pb(i);
	}
	f(i, n + 1) {
		times[i].pb(1e9);
	}
	order.resize(n);
	cin >> order;
	vector<Node*> where(n + 1, NULL);
	Node *root = NULL;
	for (int i = 0; i < n; i++) {
		where[order[i]] = new Node(times[order[i]][0]);
		root = merge(root, where[order[i]]);
	}
	vector<int> acts;
	int wait = 0;
	while (wait < len(seq)) {
		auto t = split(root, 1);
		// cout << t.first->value;
		// cout << get_size(t.first) << " ";
		// cout << get_size(t.second) << " ";
		if (t.first->value == 1e9) {
			acts.pb(n);
			root = t.second;
		} else {
			if (t.first->value == wait) {
				int id = seq[wait];
				wait++;
				times[id].pop_front();
				t.first->value = times[id][0];
			}
			{
				int I = R(t.second, t.first->value);
				auto t2 = split(t.second, I + 1);
				// cout << mp(I, get_size(t2.first)) << " ";
				root = merge(t2.first, merge(t.first, t2.second));
				acts.pb(I + 2);
			}
		}
	}
	cout << len(acts) << endl;
	cout << acts << endl;
}