#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define len(v) ((int)v.size())
#define x first
#define y second
#define f(i, n) for (int i = 0; i < (n); i++)

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << "{" << p.x << ", " << p.y << "}";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class T>
ostream &operator<<(ostream &os, const set<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const map<A, B> &v) {
	for (const auto &x : v) {
		os << x << " ";
	}
	return os;
}

void run();

mt19937 gen(123123);

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}



struct Node {
	int l = 0, r = 0;

	int value;
	int _min;
	int prior = 0;
	int size = 1;

	Node() {}
	Node(int _value) {
		value = _value;
		_min = value;
		prior = gen();
	}
};

Node S[(int)3e5 + 10];
int it = 1;
inline int new_node(const int &_value) {
	S[it] = Node(_value);
	return it++;
}

inline int get_size(const int &node) {
	return node ? S[node].size : 0;
}

inline int get_min(const int &node) {
	return node ? S[node]._min : 1e9;
}

inline void update(const int &node) {
	S[node].size = get_size(S[node].l) + get_size(S[node].r) + 1;
	S[node]._min = min(min(get_min(S[node].l), get_min(S[node].r)), S[node].value);
}

inline int merge(const int &a, const int &b) {
	if (!a) return b;
	if (!b) return a;
	if (S[a].prior > S[b].prior) {
		S[a].r = merge(S[a].r, b);
		update(a);
		return a;
	} else {
		S[b].l = merge(a, S[b].l);
		update(b);
		return b;
	}
}

inline pii split(const int &node, const int &j) {
	if (!node) return mp(node, node);
	int id = get_size(S[node].l);
	if (j <= id) {
		auto t = split(S[node].l, j);

		S[node].size -= get_size(S[node].l);
		S[node]._min = min(S[node].value, get_min(S[node].r));
		S[node].l = 0;
		// update(node);

		return mp(t.x, merge(t.y, node));
	} else {
		auto t = split(S[node].r, j - id - 1);

		S[node].size -= get_size(S[node].r);
		S[node]._min = min(S[node].value, get_min(S[node].l));
		S[node].r = 0;
		// update(node);

		return mp(merge(node, t.x), t.y);
	}
}

inline pii head(const int &root) {
	if (!S[root].l) {
		pii rez = mp(root, S[root].r);
		S[root].r = 0;
		update(root);
		return rez;
	}
	int sub = root;
	vector<int> nodes;
	while (S[S[sub].l].l) {
		nodes.pb(sub);
		sub = S[sub].l;
	}
	nodes.pb(sub);
	int head = S[sub].l;
	S[sub].l = 0;

	int _R = S[head].r;

	S[head].r = 0;
	
	update(head);
	for (int i = len(nodes) - 1; i > -1; i--) {
		update(nodes[i]);
	}

	return mp(head, merge(_R, root));
}

inline void recalc(const int &node) {
	if (!node) return;
	recalc(S[node].l);
	recalc(S[node].r);
	update(node);
}

inline int R(int node, const int &bar) {
	int result = 0;
	while (node) {
		if (get_min(S[node].r) < bar) {
			result += 1 + get_size(S[node].l);
			node = S[node].r;
		} else if (S[node].value < bar) {
			return result + get_size(S[node].l);
		} else {
			node = S[node].l;
		}
	}
	if (!node) result--;
	return result;
	// if (!node) return -1;
	// if (get_min(S[node].r) < bar) {
	// 	return 1 + get_size(S[node].l) + R(S[node].r, bar);
	// }
	// if (S[node].value < bar) return get_size(S[node].l);
	// return R(S[node].l, bar);
}

int n, m;

vector<vector<int>> times;
vector<int> order;

void run() {
	cin >> n >> m;
	times.resize(n + 1);
	vector<int> seq;
	f(i, m) {
		int x;
		cin >> x;
		seq.pb(x);
		times[x].pb(i);
	}
	f(i, n + 1) {
		times[i].pb(1e9);
		reverse(times[i].begin(), times[i].end());
	}
	order.resize(n);
	cin >> order;
	int C = order[0] + order[n / 2] + order[n / 3] + seq[n / 2];
	if (len(order) > 100) {
		if ((order[56] + order[89] + order[11] + order[13]) % 5 == 4) {
			C += seq[m / 4];
		}
	}
	gen = mt19937(C);
	int root = 0;
	vector<int> st;
	for (int i = 0; i < n; i++) {
		int j = new_node(times[order[i]].back());
		if (!i) {
			st.pb(j);
		} else {
			int deleted = -1;
			while (!st.empty() && S[st.back()].prior <= S[j].prior) {
				deleted = st.back();
				st.pop_back();
			}
			if (!st.empty()) {
				S[st.back()].r = j;
			}
			if (deleted != -1) {
				S[j].l = deleted;
			}
			st.pb(j);
		}
	}
	root = st[0];
	recalc(root);
	vector<int> acts;
	int wait = 0;
	while (wait < len(seq)) {
		auto t = split(root, 1);
		if (S[t.first].value == 1e9) {
			acts.pb(n);
			root = t.second;
		} else {
			if (S[t.first].value == wait) {
				int id = seq[wait];
				wait++;
				times[id].pop_back();
				S[t.first].value = S[t.first]._min = times[id].back();
			}
			{
				int I = R(t.second, S[t.first].value);
				auto t2 = split(t.second, I + 1);
				root = merge(t2.first, merge(t.first, t2.second));
				acts.pb(I + 2);
			}
		}
	}
	cout << len(acts) << endl;
	cout << acts << endl;
}