#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define len(v) ((int)v.size())
#define x first
#define y second
#define f(i, n) for (int i = 0; i < (n); i++)

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << "{" << p.x << ", " << p.y << "}";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class T>
ostream &operator<<(ostream &os, const set<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const map<A, B> &v) {
	for (const auto &x : v) {
		os << x << " ";
	}
	return os;
}

void run();

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

const ll MOD = 1e9 + 7;

int n, m;
ll k;

vector<vector<ll>>  mem_binom(500, vector<ll>(500, -1));
ll binom(ll n, ll k) {
	if (k > n) return 0;
	if (n == 0 || k == 0) return 1;
	if (mem_binom[n][k] != -1) return mem_binom[n][k];
	return mem_binom[n][k] = (binom(n - 1, k - 1) + binom(n - 1, k)) % MOD;
}

vector<vector<ll>> mem_enjoy(500, vector<ll>(500, -1));
ll enjoy(int g, int ones) {
	if (g == 1) return 1;
	if (mem_enjoy[g][ones] != -1) return mem_enjoy[g][ones];
	ll rez = 0;
	for (ll next = 0; next < ones; next++) {
		rez += enjoy(g - 1, next) * binom(ones, ones - next);
		rez %= MOD;
	}
	return mem_enjoy[g][ones] = rez;
}

vector<vector<vector<ll>>> mem(100, vector<vector<ll>>(100, vector<ll>(2, -1)));
ll digit(int i, int ones, bool can_ovf) {
	if (i == -1) return ones == 0;
	if (ones < 0) return 0;
	if (mem[i][ones][can_ovf] != -1) return mem[i][ones][can_ovf];
	ll rez = digit(i - 1, ones, can_ovf || ((1LL << i) & k));
	if (((1LL << i) & k) || can_ovf) {
		rez += digit(i - 1, ones - 1, can_ovf);
	}
	return mem[i][ones][can_ovf] = rez % MOD;
}

#define less oehuth
ll less(int ones, ll bar) {	
	return digit(62, ones, false);
}

void run() {
	cin >> n >> m >> k;
	vector<int> left(n, 1e9);
	f(i, m) {
		int l, r;
		cin >> l >> r;
		l--;r--;
		left[l] = min(left[l], r);
	}
	for (int i = n - 2; i > -1; i--) {
		left[i] = min(left[i], left[i + 1]);
	}
	vector<vector<ll>> dp(70, vector<ll>(n));
	for (int i = n - 1; i > -1; i--) {
		if (left[i] == 1e9) {
			dp[1][i] = 1;	
		} else {
			dp[1][i] = 0;
		}
	}
	for (int g = 2; g < 70; g++) {
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j <= min(left[i], n - 1); j++) {
				dp[g][i] += dp[g - 1][j];
				dp[g][i] %= MOD;
			}
		}
	}
	// cout << dp[1] << endl;
	// cout << dp[2][0] << endl;
	ll final = 0;
	for (int g = 1; g < 70; g++) {
		for (int ones = g - 1; ones < 62; ones++) {
			final += ((dp[g][0] * enjoy(g, ones)) % MOD) * less(ones, k);
			final %= MOD;
		}
	}
	cout << final << endl;
}